// =============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2010 - DIGITEO - Allan CORNET
//
//  This file is distributed under the same license as the Scilab package.
// =============================================================================

// <-- Non-regression test for bug 6830 -->
//
// <-- Bugzilla URL -->
// http://bugzilla.scilab.org/show_bug.cgi?id=6830
//
// <-- Short Description -->
// C2F(scistring) in stack2.c was broken for macro names of exactly 2 characters.

cd(TMPDIR);
mkdir('bug_6830');
cd('bug_6830'); 
copyfile(SCI+'/modules/core/tests/nonreg_tests/bug_6830.c',TMPDIR + '/bug_6830/bug_6830.c');
files=['bug_6830.c'];
ilib_verbose(0);
ilib_build('bug6830',['callscistring','sci_callscistring'],files,[]);
exec('loader.sce');

function r = scilabfoo(x,y)
  disp("x =");
  disp(x);
  disp("y =");
  disp(y);
  r = x + y;
  disp("r =");
  disp(r);
endfunction
 
ierr = execstr("callscistring(''scilabfoo'')","errcatch");
if ierr <> 0 then pause,end

function r = fo(x,y)
  disp("x =");
  disp(x);
  disp("y =");
  disp(y);
  r = x + y;
  disp("r =");  
  disp(r);
endfunction

ierr = execstr("callscistring(''fo'')","errcatch");
if ierr <> 0 then pause,end