// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2004-2006 - INRIA - Farid BELAHCENE
// 
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function  [mtlbpath,ismtlb]=mtlbtoolfun(namefun)
//This function return true if the function namefun is in a matlab toolbox and determinates the access path 
//Input:
//namefun : the name of the function
//Output : 
//mtlbpath : the path where is the function in the matlab toolbox (if it is in matlab)
//ismtlb : boolean, true if the function is in a matlab toolbox

mtlbpath=gettext("not matlab path");
ismtlb=%f

//tb : table which contains all the matlab functions(exept the matlab function reference) and their access path  
tb=["CreateCellAttrib"  ,  "toolbox/slcontrol/slctrlguis/";
"FreqVectorCheck"  ,  "toolbox/control/ctrlguis/";
"SignalConstrMask"  ,  "toolbox/sloptim/sloptim/";
"TimeVectorCheck"  ,  "toolbox/control/ctrlguis/";
"abcbalance"  ,  "toolbox/control/ctrlutil/";
"abccheck"  ,  "toolbox/ident/idutils/";
"aboutcst"  ,  "toolbox/control/ctrlguis/";
"aboutidenttbx"  ,  "toolbox/ident/ident/";
"aboutsignaltbx"  ,  "toolbox/signal/signal/";
"absdata"  ,  "toolbox/simulink/simdemos/automotive/";
"ac2poly"  ,  "toolbox/signal/signal/";
"ac2rc"  ,  "toolbox/signal/signal/";
"accdemo"  ,  "toolbox/robust/";
"accdm2"  ,  "toolbox/robust/";
"acceva"  ,  "toolbox/robust/";
"acceva2"  ,  "toolbox/robust/";
"accplt"  ,  "toolbox/robust/";
"accroot"  ,  "toolbox/robust/";
"acker"  ,  "toolbox/control/control/";
"acquire_print_portal"  ,  "toolbox/stateflow/stateflow/private/";
"acquire_target"  ,  "toolbox/stateflow/stateflow/private/";
"actdemo"  ,  "toolbox/robust/";
"actual_machine_referred_by"  ,  "toolbox/stateflow/stateflow/private/";
"adams"  ,  "toolbox/simulink/simulink/";
"adapthisteq"  ,  "toolbox/images/images/";
"adaptmesh"  ,  "toolbox/pde/";
"add_block"  ,  "toolbox/simulink/simulink/";
"add_engine_event_listener"  ,  "toolbox/simulink/simulink/";
"add_exec_event_listener"  ,  "toolbox/simulink/simulink/";
"add_line"  ,  "toolbox/simulink/simulink/";
"add_param"  ,  "toolbox/simulink/simulink/";
"addbisa"  ,  "toolbox/stats/private/";
"addcomponents"  ,  "toolbox/signal/sigtools/private/";
"addcsmenu"  ,  "toolbox/signal/sigtools/";
"adddynprop"  ,  "toolbox/signal/sigtools/";
"addedvarplot"  ,  "toolbox/stats/";
"addfreqcsmenu"  ,  "toolbox/signal/sigtools/";
"addinvg"  ,  "toolbox/stats/private/";
"addlogi"  ,  "toolbox/stats/private/";
"addmenu"  ,  "toolbox/signal/sigtools/";
"addnaka"  ,  "toolbox/stats/private/";
"addnk"  ,  "toolbox/ident/idutils/";
"addoptask"  ,  "toolbox/shared/slcontrollib/";
"addoutputspec"  ,  "toolbox/shared/slcontrollib/";
"addplugins"  ,  "toolbox/signal/sigtools/";
"addprops"  ,  "toolbox/signal/sigtools/";
"addrice"  ,  "toolbox/stats/private/";
"addss"  ,  "toolbox/robust/";
"addterms"  ,  "toolbox/simulink/simulink/";
"addtimecsmenu"  ,  "toolbox/signal/sigtools/";
"addtls"  ,  "toolbox/stats/private/";
"addtoolbarbtn"  ,  "toolbox/signal/sigtools/";
"addunitsmenu"  ,  "toolbox/signal/sigtools/";
"adesc"  ,  "toolbox/signal/signal/private/";
"aebalance"  ,  "toolbox/control/ctrlutil/";
"aero_atc_callback"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_atcgui"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_atcscript"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_dap3dofdata"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_extkalman"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_guid_dat"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_guid_plot"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_guidancedemoscript"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_init_atc"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_lin_aero"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_phaseplane"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_pointer_tracker"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_preload_atc"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_raddat"  ,  "toolbox/simulink/simdemos/aerospace/";
"aero_radplot"  ,  "toolbox/simulink/simdemos/aerospace/";
"aliastypeddg"  ,  "toolbox/simulink/simulink/";
"allpass"  ,  "toolbox/signal/signal/private/";
"analysistags"  ,  "toolbox/signal/sigtools/private/";
"andrewsplot"  ,  "toolbox/stats/";
"animinit"  ,  "toolbox/simulink/simdemos/simgeneral/";
"anova1"  ,  "toolbox/stats/";
"anova2"  ,  "toolbox/stats/";
"anovan"  ,  "toolbox/stats/";
"aoctool"  ,  "toolbox/stats/";
"append"  ,  "toolbox/control/control/";
"applyabsolute"  ,  "toolbox/images/images/private/";
"applycform"  ,  "toolbox/images/images/";
"applycformsequence"  ,  "toolbox/images/images/private/";
"applyclut"  ,  "toolbox/images/images/private/";
"applyfilt"  ,  "toolbox/signal/sptoolgui/private/";
"applyiccsequence"  ,  "toolbox/images/images/private/";
"applylut"  ,  "toolbox/images/images/";
"applymattrc_fwd"  ,  "toolbox/images/images/private/";
"applymattrc_inv"  ,  "toolbox/images/images/private/";
"appstr"  ,  "toolbox/signal/sptoolgui/private/";
"aprecon"  ,  "toolbox/optim/";
"aptknt"  ,  "toolbox/splines/";
"ar"  ,  "toolbox/ident/ident/";
"arburg"  ,  "toolbox/signal/signal/";
"arcov"  ,  "toolbox/signal/signal/";
"are"  ,  "toolbox/control/ctrlobsolete/";
"arecheckin"  ,  "toolbox/control/control/private/";
"arecheckout"  ,  "toolbox/control/control/private/";
"arefact2x"  ,  "toolbox/control/control/private/";
"arescale"  ,  "toolbox/control/control/private/";
"aresolv"  ,  "toolbox/robust/";
"armax"  ,  "toolbox/ident/ident/";
"armcov"  ,  "toolbox/signal/signal/";
"arparest"  ,  "toolbox/signal/signal/private/";
"arspectra"  ,  "toolbox/signal/signal/private/";
"arx"  ,  "toolbox/ident/ident/";
"arx2th"  ,  "toolbox/ident/idobsolete/";
"arx_f"  ,  "toolbox/ident/ident/";
"arxdecod"  ,  "toolbox/ident/idutils/";
"arxstruc"  ,  "toolbox/ident/ident/";
"aryule"  ,  "toolbox/signal/signal/";
"assema"  ,  "toolbox/pde/";
"assemb"  ,  "toolbox/pde/";
"assempde"  ,  "toolbox/pde/";
"assignline"  ,  "toolbox/signal/sptoolgui/private/";
"asys2ss"  ,  "toolbox/robust/";
"atamult"  ,  "toolbox/optim/private/";
"attachConfigSet"  ,  "toolbox/simulink/simulink/";
"augact"  ,  "toolbox/robust/";
"augd"  ,  "toolbox/robust/";
"augknt"  ,  "toolbox/splines/";
"augment"  ,  "toolbox/robust/";
"augss"  ,  "toolbox/robust/";
"augstate"  ,  "toolbox/control/control/";
"augtf"  ,  "toolbox/robust/";
"autobuild"  ,  "toolbox/stateflow/stateflow/private/";
"autobuild_driver"  ,  "toolbox/stateflow/stateflow/private/";
"autobuild_kernel"  ,  "toolbox/stateflow/stateflow/private/";
"autoline"  ,  "toolbox/simulink/simulink/";
"autopilotdemo"  ,  "toolbox/simulink/simdemos/aerospace/";
"auxvar"  ,  "toolbox/ident/idobsolete/";
"aveknt"  ,  "toolbox/splines/";
"axes2pix"  ,  "toolbox/images/images/private/";
"baldemo"  ,  "toolbox/robust/";
"balmr"  ,  "toolbox/robust/";
"balreal"  ,  "toolbox/control/control/";
"balsq"  ,  "toolbox/robust/";
"bandem"  ,  "toolbox/optim/";
"bandpass"  ,  "toolbox/signal/signal/private/";
"bandstop"  ,  "toolbox/signal/signal/private/";
"barplotm"  ,  "toolbox/simulink/blocks/";
"barthannwin"  ,  "toolbox/signal/signal/";
"bartlett"  ,  "toolbox/signal/signal/";
"barttest"  ,  "toolbox/stats/";
"bbdesign"  ,  "toolbox/stats/";
"bdclose"  ,  "toolbox/simulink/simulink/";
"bdroot"  ,  "toolbox/simulink/simulink/";
"bdschur"  ,  "toolbox/control/ctrlutil/";
"ben2adat"  ,  "toolbox/simulink/simdemos/";
"ben2bdat"  ,  "toolbox/simulink/simdemos/";
"ben2cdat"  ,  "toolbox/simulink/simdemos/";
"ben3adat"  ,  "toolbox/simulink/simdemos/";
"ben3bdat"  ,  "toolbox/simulink/simdemos/";
"besselap"  ,  "toolbox/signal/signal/";
"besself"  ,  "toolbox/signal/signal/";
"bestblk"  ,  "toolbox/images/images/";
"bestfixexp"  ,  "toolbox/simulink/fixedandfloat/";
"betacdf"  ,  "toolbox/stats/";
"betafit"  ,  "toolbox/stats/";
"betainv"  ,  "toolbox/stats/";
"betalik1"  ,  "toolbox/stats/";
"betalike"  ,  "toolbox/stats/";
"betapdf"  ,  "toolbox/stats/";
"betarnd"  ,  "toolbox/stats/";
"betastat"  ,  "toolbox/stats/";
"bhrdemo"  ,  "toolbox/robust/";
"bilexp"  ,  "toolbox/robust/";
"bilin"  ,  "toolbox/robust/";
"bilinear"  ,  "toolbox/signal/signal/";
"binocdf"  ,  "toolbox/stats/";
"binofit"  ,  "toolbox/stats/";
"binoinv"  ,  "toolbox/stats/";
"binopdf"  ,  "toolbox/stats/";
"binornd"  ,  "toolbox/stats/";
"binostat"  ,  "toolbox/stats/";
"bintprog"  ,  "toolbox/optim/";
"biplot"  ,  "toolbox/stats/";
"biqpbox"  ,  "toolbox/optim/private/";
"bitrevorder"  ,  "toolbox/signal/signal/";
"bj"  ,  "toolbox/ident/ident/";
"bkbrk"  ,  "toolbox/splines/";
"blackman"  ,  "toolbox/signal/signal/";
"blackmanharris"  ,  "toolbox/signal/signal/";
"blkbuild"  ,  "toolbox/control/ctrlobsolete/";
"blkout2sfunout"  ,  "toolbox/stateflow/stateflow/private/";
"blkproc"  ,  "toolbox/images/images/";
"blkrsch"  ,  "toolbox/robust/";
"blkxchk"  ,  "toolbox/simulink/simulink/private/";
"block2chart"  ,  "toolbox/stateflow/stateflow/private/";
"block2link"  ,  "toolbox/simulink/components/private/";
"blockGetDialogSchema"  ,  "toolbox/shared/dastudio/";
"blockconnect"  ,  "toolbox/slcontrol/slctrlutil/";
"blowfish"  ,  "toolbox/stateflow/stateflow/private/";
"bode"  ,  "toolbox/control/control/";
"bodeaux"  ,  "toolbox/ident/idutils/";
"bodeplot"  ,  "toolbox/ident/idobsolete/";
"bohmanwin"  ,  "toolbox/signal/signal/";
"boolean"  ,  "toolbox/simulink/simulink/";
"bootstrp"  ,  "toolbox/stats/";
"boxcar"  ,  "toolbox/signal/signal/";
"boxplot"  ,  "toolbox/stats/";
"boxutil"  ,  "toolbox/stats/";
"branch"  ,  "toolbox/robust/";
"brk2knt"  ,  "toolbox/splines/";
"brownfg"  ,  "toolbox/optim/";
"brownfgh"  ,  "toolbox/optim/";
"brownvv"  ,  "toolbox/optim/";
"bscost"  ,  "toolbox/signal/signal/";
"bsplidem"  ,  "toolbox/splines/";
"bspligui"  ,  "toolbox/splines/";
"bspline"  ,  "toolbox/splines/";
"bstschml"  ,  "toolbox/robust/";
"bstschmr"  ,  "toolbox/robust/";
"buffer"  ,  "toolbox/signal/signal/";
"build_model_reference_target"  ,  "toolbox/simulink/simulink/private/";
"build_sl_hierarchy"  ,  "toolbox/simulink/simcoverage/private/";
"build_standalone_rtw_target"  ,  "toolbox/simulink/simulink/private/";
"build_target"  ,  "toolbox/simulink/simulink/private/";
"busAssignmentddg"  ,  "toolbox/simulink/blocks/";
"busCreatorddg"  ,  "toolbox/simulink/blocks/";
"busCreatorddg_cb"  ,  "toolbox/simulink/simulink/";
"busSelectorddg"  ,  "toolbox/simulink/blocks/";
"buscreator"  ,  "toolbox/simulink/simulink/";
"busddg"  ,  "toolbox/simulink/simulink/";
"busdemoscript"  ,  "toolbox/simulink/simdemos/simfeatures/";
"buseditor"  ,  "toolbox/simulink/simulink/";
"buselementddg"  ,  "toolbox/simulink/simulink/";
"busselect"  ,  "toolbox/simulink/simulink/";
"buttap"  ,  "toolbox/signal/signal/";
"butter"  ,  "toolbox/signal/signal/";
"buttord"  ,  "toolbox/signal/signal/";
"bwarea"  ,  "toolbox/images/images/";
"bwareaopen"  ,  "toolbox/images/images/";
"bwboundaries"  ,  "toolbox/images/images/";
"bwdist"  ,  "toolbox/images/images/";
"bweuler"  ,  "toolbox/images/images/";
"bwfill"  ,  "toolbox/images/images/";
"bwhitmiss"  ,  "toolbox/images/images/";
"bwlabel"  ,  "toolbox/images/images/";
"bwlabeln"  ,  "toolbox/images/images/";
"bwmorph"  ,  "toolbox/images/images/";
"bwpack"  ,  "toolbox/images/images/";
"bwperim"  ,  "toolbox/images/images/";
"bwselect"  ,  "toolbox/images/images/";
"bwtraceboundary"  ,  "toolbox/images/images/";
"bwulterode"  ,  "toolbox/images/images/";
"bwunpack"  ,  "toolbox/images/images/";
"c2d"  ,  "toolbox/simulink/simulink/private/";
"c2d"  ,  "toolbox/control/control/";
"c2dm"  ,  "toolbox/control/ctrlobsolete/";
"c2dt"  ,  "toolbox/control/ctrlobsolete/";
"c_indent"  ,  "toolbox/rtw/rtw/";
"c_type_from_sf_type"  ,  "toolbox/stateflow/coder/private/";
"callback_function_management"  ,  "toolbox/rtw/rtw/";
"callperl"  ,  "toolbox/simulink/simulink/";
"candexch"  ,  "toolbox/stats/";
"candgen"  ,  "toolbox/stats/";
"canform"  ,  "toolbox/ident/idobsolete/";
"canon"  ,  "toolbox/control/control/";
"canoncorr"  ,  "toolbox/stats/";
"canstart"  ,  "toolbox/ident/idobsolete/";
"capable"  ,  "toolbox/stats/";
"capacitor"  ,  "toolbox/control/ctrldemos/private/";
"capaplot"  ,  "toolbox/stats/";
"cardb"  ,  "toolbox/pde/";
"cardg"  ,  "toolbox/pde/";
"care"  ,  "toolbox/control/control/";
"caseread"  ,  "toolbox/stats/";
"casewrite"  ,  "toolbox/stats/";
"cast"  ,  "toolbox/images/images/private/";
"cccopyfcn"  ,  "toolbox/rtw/rtw/";
"ccdesign"  ,  "toolbox/stats/";
"cceps"  ,  "toolbox/signal/signal/";
"ccopenfcn"  ,  "toolbox/rtw/rtw/";
"cdf"  ,  "toolbox/stats/";
"cdfcalc"  ,  "toolbox/stats/";
"cdfplot"  ,  "toolbox/stats/";
"cedit"  ,  "toolbox/local/";
"cell2sos"  ,  "toolbox/signal/signal/";
"cellengunits"  ,  "toolbox/signal/sigtools/";
"centerfig"  ,  "toolbox/shared/controllib/";
"centerfigonfig"  ,  "toolbox/signal/sigtools/private/";
"cfgDlgCBRedirect"  ,  "toolbox/simulink/simulink/private/";
"cfirpm"  ,  "toolbox/signal/signal/";
"cftoolchecknames"  ,  "toolbox/images/images/private/";
"cgloci"  ,  "toolbox/robust/";
"cgloci2"  ,  "toolbox/robust/";
"changeBoundDualFeasible"  ,  "toolbox/optim/private/";
"changeBoundLP"  ,  "toolbox/optim/private/";
"changeSimPrmTab"  ,  "toolbox/simulink/simulink/";
"change_de_port_index"  ,  "toolbox/stateflow/stateflow/private/";
"change_icon_to"  ,  "toolbox/stateflow/stateflow/private/";
"changeclass"  ,  "toolbox/images/images/private/";
"changedisplay"  ,  "toolbox/signal/sigtools/";
"chanupd"  ,  "toolbox/ident/idguis/";
"chaos2das"  ,  "toolbox/shared/dastudio/";
"chart2block"  ,  "toolbox/stateflow/stateflow/private/";
"chart2name"  ,  "toolbox/stateflow/stateflow/private/";
"chart_real_transitions"  ,  "toolbox/stateflow/stateflow/private/";
"chart_recovery_man"  ,  "toolbox/stateflow/stateflow/private/";
"chartddg"  ,  "toolbox/stateflow/stateflow/private/";
"chartdlg"  ,  "toolbox/stateflow/stateflow/private/";
"chbpnt"  ,  "toolbox/splines/";
"chckxywp"  ,  "toolbox/splines/";
"cheb1ap"  ,  "toolbox/signal/signal/";
"cheb1ord"  ,  "toolbox/signal/signal/";
"cheb2ap"  ,  "toolbox/signal/signal/";
"cheb2ord"  ,  "toolbox/signal/signal/";
"chebdem"  ,  "toolbox/splines/";
"chebloop"  ,  "toolbox/splines/";
"chebwin"  ,  "toolbox/signal/signal/";
"cheby1"  ,  "toolbox/signal/signal/";
"cheby2"  ,  "toolbox/signal/signal/";
"checkSimPrm"  ,  "toolbox/simulink/simulink/private/";
"check_bang_in_dir"  ,  "toolbox/stateflow/stateflow/private/";
"check_fan_params"  ,  "toolbox/images/images/private/";
"check_for_long_model_name"  ,  "toolbox/stateflow/stateflow/private/";
"check_if_file_is_in_sync"  ,  "toolbox/stateflow/stateflow/private/";
"check_mdl_precedence"  ,  "toolbox/simulink/simulink/";
"check_order"  ,  "toolbox/signal/signal/private/";
"checkbounds"  ,  "toolbox/shared/optimlib/";
"checkconn"  ,  "toolbox/images/images/private/";
"checkerboard"  ,  "toolbox/images/images/";
"checkinput"  ,  "toolbox/images/images/private/";
"checkinputsigdim"  ,  "toolbox/signal/sigtools/";
"checkmap"  ,  "toolbox/images/images/private/";
"checknargin"  ,  "toolbox/images/images/private/";
"checkstrs"  ,  "toolbox/images/images/private/";
"chi2cdf"  ,  "toolbox/stats/";
"chi2conf"  ,  "toolbox/signal/signal/private/";
"chi2inv"  ,  "toolbox/stats/";
"chi2pdf"  ,  "toolbox/stats/";
"chi2rnd"  ,  "toolbox/stats/";
"chi2stat"  ,  "toolbox/stats/";
"chirp"  ,  "toolbox/signal/signal/";
"chk_license"  ,  "toolbox/simulink/simdemos/automotive/";
"chkmdinteg"  ,  "toolbox/ident/idutils/";
"chkrules"  ,  "toolbox/simulink/components/private/";
"chop"  ,  "toolbox/control/ctrlobsolete/";
"circleb1"  ,  "toolbox/pde/";
"circleb2"  ,  "toolbox/pde/";
"circlef"  ,  "toolbox/pde/";
"circleg"  ,  "toolbox/pde/";
"circlepick"  ,  "toolbox/pde/";
"circustent"  ,  "toolbox/optim/";
"cirsb"  ,  "toolbox/pde/";
"cirsg"  ,  "toolbox/pde/";
"classdemo"  ,  "toolbox/stats/";
"classify"  ,  "toolbox/stats/";
"clean_code_gen_dir"  ,  "toolbox/stateflow/coder/private/";
"clean_error_msg"  ,  "toolbox/stateflow/stateflow/private/";
"clean_target"  ,  "toolbox/stateflow/stateflow/private/";
"cleanerrormsg"  ,  "toolbox/signal/sigtools/";
"clipdivide"  ,  "toolbox/images/images/private/";
"cloop"  ,  "toolbox/control/ctrlobsolete/";
"close_models"  ,  "toolbox/simulink/simulink/private/";
"close_system"  ,  "toolbox/simulink/simulink/";
"closemachines"  ,  "toolbox/stateflow/stateflow/private/";
"cluster"  ,  "toolbox/stats/";
"clusterdata"  ,  "toolbox/stats/";
"clusterdemo"  ,  "toolbox/stats/";
"clutchplot"  ,  "toolbox/simulink/simdemos/automotive/";
"clutchplot_if"  ,  "toolbox/simulink/simdemos/automotive/";
"clxbode"  ,  "toolbox/robust/";
"cmd_window_buffering"  ,  "toolbox/rtw/rtw/";
"cmdscale"  ,  "toolbox/stats/";
"cmdscaledemo"  ,  "toolbox/stats/";
"cmgamdef"  ,  "toolbox/images/images/";
"cmgamma"  ,  "toolbox/images/images/";
"cminfo"  ,  "toolbox/local/";
"cmopts"  ,  "toolbox/local/";
"cmpermute"  ,  "toolbox/images/images/";
"cmunique"  ,  "toolbox/images/images/";
"code_borland_make_file"  ,  "toolbox/stateflow/coder/private/";
"code_chart_debug_initialization"  ,  "toolbox/stateflow/coder/private/";
"code_chart_header_file"  ,  "toolbox/stateflow/coder/private/";
"code_chart_header_file__rtw"  ,  "toolbox/stateflow/coder/private/";
"code_chart_header_file_custom"  ,  "toolbox/stateflow/coder/private/";
"code_chart_header_file_sfun"  ,  "toolbox/stateflow/coder/private/";
"code_chart_source_file"  ,  "toolbox/stateflow/coder/private/";
"code_chart_source_file_custom"  ,  "toolbox/stateflow/coder/private/";
"code_chart_source_file_rtw"  ,  "toolbox/stateflow/coder/private/";
"code_chart_source_file_sfun"  ,  "toolbox/stateflow/coder/private/";
"code_data_initialization"  ,  "toolbox/stateflow/coder/private/";
"code_debug_macros"  ,  "toolbox/stateflow/coder/private/";
"code_interface_and_support_files"  ,  "toolbox/stateflow/coder/private/";
"code_lcc_make_file"  ,  "toolbox/stateflow/coder/private/";
"code_machine_debug_initialization"  ,  "toolbox/stateflow/coder/private/";
"code_machine_def_file"  ,  "toolbox/stateflow/coder/private/";
"code_machine_header_file"  ,  "toolbox/stateflow/coder/private/";
"code_machine_header_file_custom"  ,  "toolbox/stateflow/coder/private/";
"code_machine_header_file_rtw"  ,  "toolbox/stateflow/coder/private/";
"code_machine_header_file_sfun"  ,  "toolbox/stateflow/coder/private/";
"code_machine_objlist_file"  ,  "toolbox/stateflow/coder/private/";
"code_machine_registry_file"  ,  "toolbox/stateflow/coder/private/";
"code_machine_source_file"  ,  "toolbox/stateflow/coder/private/";
"code_machine_source_file_custom"  ,  "toolbox/stateflow/coder/private/";
"code_machine_source_file_rtw"  ,  "toolbox/stateflow/coder/private/";
"code_machine_source_file_sfun"  ,  "toolbox/stateflow/coder/private/";
"code_msvc50_dswfile"  ,  "toolbox/stateflow/coder/private/";
"code_msvc50_makefile"  ,  "toolbox/stateflow/coder/private/";
"code_msvc_make_file"  ,  "toolbox/stateflow/coder/private/";
"code_sfun_glue_code"  ,  "toolbox/stateflow/coder/private/";
"code_unix_make_file"  ,  "toolbox/stateflow/coder/private/";
"code_watcom_make_file"  ,  "toolbox/stateflow/coder/private/";
"coder_error_count_man"  ,  "toolbox/stateflow/stateflow/private/";
"coder_options"  ,  "toolbox/stateflow/coder/private/";
"coder_opts_ddg"  ,  "toolbox/stateflow/stateflow/private/";
"coder_opts_ddg_preapply_cb"  ,  "toolbox/stateflow/stateflow/private/";
"cohere"  ,  "toolbox/signal/signal/";
"col2im"  ,  "toolbox/images/images/";
"colfilt"  ,  "toolbox/images/images/";
"collatetranslations"  ,  "toolbox/simulink/simulink/";
"collect_custom_code_symbols"  ,  "toolbox/stateflow/stateflow/private/";
"color"  ,  "toolbox/optim/";
"color2background"  ,  "toolbox/signal/sigtools/";
"combnk"  ,  "toolbox/stats/";
"comclient"  ,  "toolbox/local/";
"compare_components"  ,  "toolbox/simulink/simulink/private/";
"compare_configuration_sets"  ,  "toolbox/simulink/simulink/private/";
"compat13"  ,  "toolbox/simulink/simulink/private/";
"compdir"  ,  "toolbox/shared/optimlib/";
"compilerman"  ,  "toolbox/stateflow/stateflow/private/";
"completefreqresp"  ,  "toolbox/signal/signal/";
"compreal"  ,  "toolbox/control/ctrlutil/";
"compute_chart_information"  ,  "toolbox/stateflow/coder/private/";
"compute_compiler_info"  ,  "toolbox/stateflow/coder/private/";
"compute_event_enum_values"  ,  "toolbox/stateflow/coder/private/";
"compute_inc_codegen_info"  ,  "toolbox/stateflow/coder/private/";
"compute_machine_info"  ,  "toolbox/stateflow/coder/private/";
"compute_rtw_multi_instance_info"  ,  "toolbox/stateflow/coder/private/";
"compute_sfun_io_port_info"  ,  "toolbox/stateflow/coder/private/";
"compute_state_enums"  ,  "toolbox/stateflow/coder/private/";
"compute_target_info"  ,  "toolbox/stateflow/coder/private/";
"compute_value_from_rtwoptions"  ,  "toolbox/rtw/rtw/";
"computeperiodogram"  ,  "toolbox/signal/signal/private/";
"computepsd"  ,  "toolbox/signal/signal/";
"configDlgAction"  ,  "toolbox/simulink/simulink/private/";
"configDlgCallback"  ,  "toolbox/simulink/simulink/private/";
"configHelp"  ,  "toolbox/simulink/simulink/private/";
"configSetPref"  ,  "toolbox/simulink/simulink/private/";
"config_dlg_configure_param"  ,  "toolbox/simulink/simulink/";
"configblk"  ,  "toolbox/simulink/simulink/";
"configset_delete"  ,  "toolbox/simulink/simulink/private/";
"configure_model_reference_target_status"  ,  "toolbox/simulink/simulink/private/";
"confun"  ,  "toolbox/optim/";
"confuneq"  ,  "toolbox/optim/";
"confungrad"  ,  "toolbox/optim/";
"conn2array"  ,  "toolbox/images/images/private/";
"conndef"  ,  "toolbox/images/images/";
"connect"  ,  "toolbox/control/control/";
"connectline"  ,  "toolbox/control/ctrlutil/";
"construct_coder_error"  ,  "toolbox/stateflow/coder/private/";
"construct_context_for_machine"  ,  "toolbox/stateflow/coder/private/";
"construct_error"  ,  "toolbox/stateflow/stateflow/private/";
"construct_module"  ,  "toolbox/stateflow/coder/private/";
"construct_tt_error"  ,  "toolbox/stateflow/stateflow/private/";
"construct_warning"  ,  "toolbox/stateflow/stateflow/private/";
"convert2db"  ,  "toolbox/signal/sigtools/";
"convert2deg"  ,  "toolbox/signal/sigtools/";
"convert2engstrs"  ,  "toolbox/signal/sigtools/";
"convert2sq"  ,  "toolbox/signal/sigtools/";
"convert2vector"  ,  "toolbox/signal/sigtools/";
"convertSampleTimeInfo"  ,  "toolbox/simulink/simulink/private/";
"convertfrequnits"  ,  "toolbox/signal/sigtools/";
"convertmagunits"  ,  "toolbox/signal/sigtools/";
"convhullx"  ,  "toolbox/images/images/private/";
"convmtx"  ,  "toolbox/signal/signal/";
"convmtx2"  ,  "toolbox/images/images/";
"cophenet"  ,  "toolbox/stats/";
"copulademo"  ,  "toolbox/stats/";
"copy_object_properties"  ,  "toolbox/simulink/simulink/";
"copy_target_props"  ,  "toolbox/stateflow/stateflow/private/";
"cordexch"  ,  "toolbox/stats/";
"corelucy"  ,  "toolbox/images/images/private/";
"corr"  ,  "toolbox/stats/";
"corr2"  ,  "toolbox/images/images/";
"corrmtx"  ,  "toolbox/signal/signal/";
"cosint"  ,  "toolbox/symbolic/";
"count_fixpt_blks"  ,  "toolbox/simulink/fixedandfloat/";
"covar"  ,  "toolbox/control/control/";
"covf"  ,  "toolbox/ident/idobsolete/";
"covf2"  ,  "toolbox/ident/idobsolete/";
"covlamb"  ,  "toolbox/ident/idutils/";
"cp2tform"  ,  "toolbox/images/images/";
"cpcorr"  ,  "toolbox/images/images/";
"cppredict"  ,  "toolbox/images/images/private/";
"cpsave"  ,  "toolbox/images/images/private/";
"cpsd"  ,  "toolbox/signal/signal/";
"cpselect"  ,  "toolbox/images/images/";
"cpselecthelp"  ,  "toolbox/images/images/private/";
"cpstruct2pairs"  ,  "toolbox/images/images/";
"cr"  ,  "toolbox/simulink/simulink/private/";
"cra"  ,  "toolbox/ident/ident/";
"crackb"  ,  "toolbox/pde/";
"crackg"  ,  "toolbox/pde/";
"createDASimulink"  ,  "toolbox/shared/dastudio/";
"create_directory_path"  ,  "toolbox/stateflow/stateflow/private/";
"create_file_name_info"  ,  "toolbox/stateflow/coder/private/";
"create_nag"  ,  "toolbox/simulink/simulink/private/";
"create_truth_table"  ,  "toolbox/stateflow/stateflow/private/";
"createfigcopy"  ,  "toolbox/signal/sigtools/private/";
"createsignalzoom"  ,  "toolbox/signal/sigtools/";
"createtdtlisteners"  ,  "toolbox/simulink/simulink/";
"cremez"  ,  "toolbox/signal/signal/";
"crmz"  ,  "toolbox/signal/signal/private/";
"crosstab"  ,  "toolbox/stats/";
"crtanim1"  ,  "toolbox/simulink/simdemos/simgeneral/";
"crtanim2"  ,  "toolbox/simulink/simdemos/simgeneral/";
"cs"  ,  "toolbox/ident/iddemos/";
"cs1"  ,  "toolbox/ident/iddemos/";
"cs2"  ,  "toolbox/ident/iddemos/";
"csape"  ,  "toolbox/splines/";
"csapi"  ,  "toolbox/splines/";
"csapidem"  ,  "toolbox/splines/";
"csaps"  ,  "toolbox/splines/";
"csapsdem"  ,  "toolbox/splines/";
"cschur"  ,  "toolbox/robust/";
"cscvn"  ,  "toolbox/splines/";
"csd"  ,  "toolbox/signal/signal/";
"csfunc"  ,  "toolbox/simulink/blocks/";
"csgchk"  ,  "toolbox/pde/";
"csgdel"  ,  "toolbox/pde/";
"cshelpcontextmenu"  ,  "toolbox/signal/sigtools/";
"cshelpengine"  ,  "toolbox/signal/sigtools/";
"cshelpgeneral_cb"  ,  "toolbox/signal/sigtools/";
"cspecchk"  ,  "toolbox/images/images/private/";
"cstdefs"  ,  "toolbox/control/ctrlguis/";
"cstupdate"  ,  "toolbox/control/ctrlguis/";
"ctrb"  ,  "toolbox/control/control/";
"ctrbf"  ,  "toolbox/control/control/";
"ctrlguihelp"  ,  "toolbox/control/ctrlguis/";
"ctrlpref"  ,  "toolbox/control/control/";
"ctx_add_note"  ,  "toolbox/stateflow/stateflow/private/";
"ctx_toggle_smart"  ,  "toolbox/stateflow/stateflow/private/";
"ctxmenuman"  ,  "toolbox/stateflow/stateflow/private/";
"cubic"  ,  "toolbox/optim/";
"cubici1"  ,  "toolbox/optim/";
"cubici2"  ,  "toolbox/optim/";
"cubici3"  ,  "toolbox/optim/";
"currentchart"  ,  "toolbox/stateflow/stateflow/private/";
"custcodehelp"  ,  "toolbox/rtw/rtw/";
"customdist1demo"  ,  "toolbox/stats/";
"customdist2demo"  ,  "toolbox/stats/";
"cv_append_autoscale_data"  ,  "toolbox/simulink/simcoverage/private/";
"cv_dialog_options"  ,  "toolbox/simulink/simcoverage/private/";
"cv_init_dialog_test"  ,  "toolbox/simulink/simcoverage/private/";
"cv_is_model_autoscale"  ,  "toolbox/simulink/simcoverage/private/";
"cv_metric_names"  ,  "toolbox/simulink/simcoverage/private/";
"cv_model_enabled"  ,  "toolbox/simulink/simcoverage/private/";
"cv_sf_chart_data"  ,  "toolbox/simulink/simcoverage/private/";
"cv_term_dialog_test"  ,  "toolbox/simulink/simcoverage/private/";
"cvinit"  ,  "toolbox/simulink/simcoverage/private/";
"cvmodel"  ,  "toolbox/simulink/simcoverage/private/";
"cvsf"  ,  "toolbox/simulink/simcoverage/private/";
"cycle_error_help"  ,  "toolbox/stateflow/stateflow/private/";
"czt"  ,  "toolbox/signal/signal/";
"cztdemo"  ,  "toolbox/signal/sigdemos/";
"d2c"  ,  "toolbox/control/control/";
"d2ci"  ,  "toolbox/simulink/simulink/private/";
"d2cm"  ,  "toolbox/control/ctrlobsolete/";
"d2d"  ,  "toolbox/control/control/";
"d2d"  ,  "toolbox/simulink/simulink/private/";
"da_mxarray_get_schema"  ,  "toolbox/shared/dastudio/";
"daabout"  ,  "toolbox/shared/dastudio/";
"dactdemo"  ,  "toolbox/robust/";
"daexplr"  ,  "toolbox/shared/dastudio/";
"damp"  ,  "toolbox/control/control/";
"damp"  ,  "toolbox/ident/idutils/private/";
"dare"  ,  "toolbox/control/control/";
"daresolv"  ,  "toolbox/robust/";
"das2chaos"  ,  "toolbox/shared/dastudio/";
"das_dv_hyperlink"  ,  "toolbox/shared/dastudio/";
"das_get_data_type"  ,  "toolbox/shared/dastudio/";
"das_get_enum_values"  ,  "toolbox/shared/dastudio/";
"das_undo_gateway"  ,  "toolbox/shared/dastudio/";
"das_undo_stack"  ,  "toolbox/shared/dastudio/";
"dataStoreMemddg"  ,  "toolbox/simulink/blocks/";
"dataStoreRWddg"  ,  "toolbox/simulink/blocks/";
"dataStoreRWddg_cb"  ,  "toolbox/simulink/simulink/";
"dataddg"  ,  "toolbox/simulink/simulink/";
"dataddg"  ,  "toolbox/stateflow/stateflow/private/";
"dataddg_cb"  ,  "toolbox/simulink/simulink/";
"dataddg_mxarray"  ,  "toolbox/shared/dastudio/";
"dataddg_port_callback"  ,  "toolbox/stateflow/stateflow/private/";
"dataddg_preapply_callback"  ,  "toolbox/stateflow/stateflow/private/";
"dataddg_preclose_callback"  ,  "toolbox/stateflow/stateflow/private/";
"datadlg"  ,  "toolbox/stateflow/stateflow/private/";
"datatip"  ,  "toolbox/control/ctrlobsolete/";
"datawrap"  ,  "toolbox/signal/signal/";
"datdemo"  ,  "toolbox/optim/";
"daugment"  ,  "toolbox/stats/";
"db"  ,  "toolbox/signal/signal/";
"dbalreal"  ,  "toolbox/control/ctrlobsolete/";
"dbm"  ,  "toolbox/signal/signal/private/";
"dbode"  ,  "toolbox/control/ctrlobsolete/";
"dcdemo"  ,  "toolbox/control/ctrldemos/";
"dcgain"  ,  "toolbox/control/control/";
"dcgloci"  ,  "toolbox/robust/";
"dcgloci2"  ,  "toolbox/robust/";
"dclxbode"  ,  "toolbox/robust/";
"dcovar"  ,  "toolbox/control/ctrlobsolete/";
"dcovary"  ,  "toolbox/stats/";
"dct"  ,  "toolbox/images/images/private/";
"dct"  ,  "toolbox/signal/signal/";
"dct2"  ,  "toolbox/images/images/";
"dctdemo"  ,  "toolbox/images/imdemos/";
"dctmtx"  ,  "toolbox/images/images/";
"dctmtx2"  ,  "toolbox/images/images/";
"dctold"  ,  "toolbox/signal/signal/private/";
"ddamp"  ,  "toolbox/control/ctrlobsolete/";
"ddcgain"  ,  "toolbox/control/ctrlobsolete/";
"ddg_get_parent_name"  ,  "toolbox/stateflow/stateflow/private/";
"ddist"  ,  "toolbox/images/images/private/";
"deblankall"  ,  "toolbox/simulink/simulink/private/";
"debugdlg"  ,  "toolbox/stateflow/stateflow/private/";
"decimate"  ,  "toolbox/signal/signal/";
"deconvblind"  ,  "toolbox/images/images/";
"deconvlucy"  ,  "toolbox/images/images/";
"deconvreg"  ,  "toolbox/images/images/";
"deconvwnr"  ,  "toolbox/images/images/";
"decorrstretch"  ,  "toolbox/images/images/";
"decrypt_machine"  ,  "toolbox/stateflow/stateflow/private/";
"decsg"  ,  "toolbox/pde/";
"dee4plt"  ,  "toolbox/simulink/dee/";
"dee4plti"  ,  "toolbox/simulink/dee/";
"deechgnm"  ,  "toolbox/simulink/dee/";
"deedemi4"  ,  "toolbox/simulink/dee/";
"deeflag"  ,  "toolbox/simulink/dee/";
"deehelp"  ,  "toolbox/simulink/dee/";
"deelin"  ,  "toolbox/simulink/dee/";
"deerestr"  ,  "toolbox/simulink/dee/";
"deeupdat"  ,  "toolbox/simulink/dee/";
"default_target_methods"  ,  "toolbox/stateflow/stateflow/private/";
"defaultlutblklist"  ,  "toolbox/simulink/blocks/private/";
"definev"  ,  "toolbox/optim/private/";
"defnum"  ,  "toolbox/ident/idutils/";
"defnum2"  ,  "toolbox/ident/idutils/";
"defnum3"  ,  "toolbox/ident/idutils/";
"delayest"  ,  "toolbox/ident/ident/";
"delayfr"  ,  "toolbox/control/ctrlutil/";
"delete_block"  ,  "toolbox/simulink/simulink/";
"delete_line"  ,  "toolbox/simulink/simulink/";
"delete_param"  ,  "toolbox/simulink/simulink/";
"deletehgfig"  ,  "toolbox/simulink/simulink/";
"democlean"  ,  "toolbox/control/ctrldemos/private/";
"demod"  ,  "toolbox/signal/signal/";
"dendrogram"  ,  "toolbox/stats/";
"dep"  ,  "toolbox/optim/private/";
"des2ss"  ,  "toolbox/robust/";
"despace"  ,  "toolbox/stateflow/stateflow/private/";
"destim"  ,  "toolbox/control/ctrlobsolete/";
"detachConfigSet"  ,  "toolbox/simulink/simulink/";
"deterministicsignalpower"  ,  "toolbox/signal/sigdemos/";
"dexresp"  ,  "toolbox/control/ctrlobsolete/";
"dfaddbuttons"  ,  "toolbox/stats/private/";
"dfaddparamfit"  ,  "toolbox/stats/private/";
"dfaddsmoothfit"  ,  "toolbox/stats/private/";
"dfadjustlayout"  ,  "toolbox/stats/private/";
"dfadjustmenu"  ,  "toolbox/stats/private/";
"dfadjusttoolbar"  ,  "toolbox/stats/private/";
"dfasksavesession"  ,  "toolbox/stats/private/";
"dfaxlimctrl"  ,  "toolbox/stats/private/";
"dfbinwidthpreview"  ,  "toolbox/stats/private/";
"dfboundwarn"  ,  "toolbox/stats/private/";
"dfcanplotdata"  ,  "toolbox/stats/private/";
"dfcbkclear"  ,  "toolbox/stats/private/";
"dfcheckselections"  ,  "toolbox/stats/private/";
"dfcopyexrule"  ,  "toolbox/stats/private/";
"dfcreatecopy"  ,  "toolbox/stats/private/";
"dfcreatedataset"  ,  "toolbox/stats/private/";
"dfcreateexclusionrule"  ,  "toolbox/stats/private/";
"dfcreateplot"  ,  "toolbox/stats/private/";
"dfcustomdist"  ,  "toolbox/stats/private/";
"dfdeleteexrule"  ,  "toolbox/stats/private/";
"dfdelgraphexclude"  ,  "toolbox/stats/private/";
"dfdocontext"  ,  "toolbox/stats/private/";
"dfdupfigure"  ,  "toolbox/stats/private/";
"dfevaluate"  ,  "toolbox/stats/private/";
"dfevaluateplot"  ,  "toolbox/stats/private/";
"dfexport2workspace"  ,  "toolbox/stats/private/";
"dffig2m"  ,  "toolbox/stats/private/";
"dfgetbinwidthdefaults"  ,  "toolbox/stats/private/";
"dfgetdistributions"  ,  "toolbox/stats/private/";
"dfgetexclusionrule"  ,  "toolbox/stats/private/";
"dfgetfitname"  ,  "toolbox/stats/private/";
"dfgetset"  ,  "toolbox/stats/";
"dfgetupdateinfo"  ,  "toolbox/stats/private/";
"dfgetuserdists"  ,  "toolbox/stats/private/";
"dfgraphexclude"  ,  "toolbox/stats/private/";
"dfhelpviewer"  ,  "toolbox/stats/private/";
"dfhistbins"  ,  "toolbox/stats/private/";
"dfildemo"  ,  "toolbox/optim/";
"dfilt2qfilt"  ,  "toolbox/signal/sigtools/";
"dfiltdemo"  ,  "toolbox/signal/sigdemos/";
"dfiltfftfirdemo"  ,  "toolbox/signal/sigdemos/";
"dfiltfilteringdemo"  ,  "toolbox/signal/sigdemos/";
"dfiltloadobj"  ,  "toolbox/signal/sigtools/";
"dfittool"  ,  "toolbox/stats/";
"dfpreview"  ,  "toolbox/stats/private/";
"dfreqrc"  ,  "toolbox/robust/";
"dfrqint"  ,  "toolbox/control/ctrlobsolete/";
"dfrqint2"  ,  "toolbox/control/ctrlobsolete/";
"dfsectionpreview"  ,  "toolbox/stats/private/";
"dfsession"  ,  "toolbox/stats/private/";
"dfsetbinwidthrules"  ,  "toolbox/stats/private/";
"dfsetconflev"  ,  "toolbox/stats/private/";
"dfsetdistributions"  ,  "toolbox/stats/private/";
"dfsetfunction"  ,  "toolbox/stats/private/";
"dfsetplottype"  ,  "toolbox/stats/private/";
"dfswitchyard"  ,  "toolbox/stats/";
"dftips"  ,  "toolbox/stats/private/";
"dftmtx"  ,  "toolbox/signal/signal/";
"dftoggleaxlimctrl"  ,  "toolbox/stats/private/";
"dftogglegrid"  ,  "toolbox/stats/private/";
"dftogglelegend"  ,  "toolbox/stats/private/";
"dftoggletoolbar"  ,  "toolbox/stats/private/";
"dftoolgetudd"  ,  "toolbox/stats/private/";
"dftoolinittemplate"  ,  "toolbox/stats/private/";
"dfupdateallplots"  ,  "toolbox/stats/private/";
"dfupdatebinwidthpreview"  ,  "toolbox/stats/private/";
"dfupdatelegend"  ,  "toolbox/stats/private/";
"dfupdateppdists"  ,  "toolbox/stats/private/";
"dfupdatexlim"  ,  "toolbox/stats/private/";
"dfupdateylim"  ,  "toolbox/stats/private/";
"dfviewdata"  ,  "toolbox/stats/private/";
"dfviewdatapreview"  ,  "toolbox/stats/private/";
"dfviewexcludepreview"  ,  "toolbox/stats/private/";
"dfviewpreview"  ,  "toolbox/stats/private/";
"dgammainc"  ,  "toolbox/stats/private/";
"dgram"  ,  "toolbox/control/ctrlobsolete/";
"dh2lqg"  ,  "toolbox/robust/";
"dhinf"  ,  "toolbox/robust/";
"dhinfopt"  ,  "toolbox/robust/";
"diagmx"  ,  "toolbox/robust/";
"diagnose"  ,  "toolbox/shared/optimlib/";
"dicom_add_attr"  ,  "toolbox/images/images/private/";
"dicom_add_item"  ,  "toolbox/images/images/private/";
"dicom_close_msg"  ,  "toolbox/images/images/private/";
"dicom_compress_pixel_cells"  ,  "toolbox/images/images/private/";
"dicom_convert_meta_to_attr"  ,  "toolbox/images/images/private/";
"dicom_copy_IOD"  ,  "toolbox/images/images/private/";
"dicom_create_IOD"  ,  "toolbox/images/images/private/";
"dicom_create_attr"  ,  "toolbox/images/images/private/";
"dicom_create_file_struct"  ,  "toolbox/images/images/private/";
"dicom_create_guid"  ,  "toolbox/images/images/private/";
"dicom_create_meta_struct"  ,  "toolbox/images/images/private/";
"dicom_decode_jpg8"  ,  "toolbox/images/images/private/";
"dicom_decode_pixel_cells"  ,  "toolbox/images/images/private/";
"dicom_decode_rle"  ,  "toolbox/images/images/private/";
"dicom_dict_lookup"  ,  "toolbox/images/images/private/";
"dicom_encode_attrs"  ,  "toolbox/images/images/private/";
"dicom_encode_jpeg_lossless"  ,  "toolbox/images/images/private/";
"dicom_encode_jpeg_lossy"  ,  "toolbox/images/images/private/";
"dicom_encode_pixel_cells"  ,  "toolbox/images/images/private/";
"dicom_encode_pn"  ,  "toolbox/images/images/private/";
"dicom_encode_rle"  ,  "toolbox/images/images/private/";
"dicom_generate_uid"  ,  "toolbox/images/images/private/";
"dicom_get_msg"  ,  "toolbox/images/images/private/";
"dicom_get_next_tag"  ,  "toolbox/images/images/private/";
"dicom_get_tags"  ,  "toolbox/images/images/private/";
"dicom_has_fmeta"  ,  "toolbox/images/images/private/";
"dicom_has_overlay_bits"  ,  "toolbox/images/images/private/";
"dicom_iods"  ,  "toolbox/images/images/private/";
"dicom_load_dictionary"  ,  "toolbox/images/images/private/";
"dicom_modules"  ,  "toolbox/images/images/private/";
"dicom_name_lookup"  ,  "toolbox/images/images/private/";
"dicom_open_msg"  ,  "toolbox/images/images/private/";
"dicom_prep_FileMetadata"  ,  "toolbox/images/images/private/";
"dicom_prep_FrameOfReference"  ,  "toolbox/images/images/private/";
"dicom_prep_GeneralImage"  ,  "toolbox/images/images/private/";
"dicom_prep_GeneralSeries"  ,  "toolbox/images/images/private/";
"dicom_prep_GeneralStudy"  ,  "toolbox/images/images/private/";
"dicom_prep_ImagePixel"  ,  "toolbox/images/images/private/";
"dicom_prep_SCImageEquipment"  ,  "toolbox/images/images/private/";
"dicom_prep_SOPCommon"  ,  "toolbox/images/images/private/";
"dicom_prep_metadata"  ,  "toolbox/images/images/private/";
"dicom_read_attr"  ,  "toolbox/images/images/private/";
"dicom_read_attr_by_pos"  ,  "toolbox/images/images/private/";
"dicom_read_attr_length"  ,  "toolbox/images/images/private/";
"dicom_read_attr_metadata"  ,  "toolbox/images/images/private/";
"dicom_read_attr_tag"  ,  "toolbox/images/images/private/";
"dicom_read_attr_vr"  ,  "toolbox/images/images/private/";
"dicom_read_encapsulated"  ,  "toolbox/images/images/private/";
"dicom_read_fmeta"  ,  "toolbox/images/images/private/";
"dicom_read_image"  ,  "toolbox/images/images/private/";
"dicom_read_mmeta"  ,  "toolbox/images/images/private/";
"dicom_read_native"  ,  "toolbox/images/images/private/";
"dicom_set_image_encoding"  ,  "toolbox/images/images/private/";
"dicom_set_imfinfo_values"  ,  "toolbox/images/images/private/";
"dicom_set_mmeta_encoding"  ,  "toolbox/images/images/private/";
"dicom_supported_txfr_syntax"  ,  "toolbox/images/images/private/";
"dicom_tag_lookup"  ,  "toolbox/images/images/private/";
"dicom_uid_decode"  ,  "toolbox/images/images/private/";
"dicom_warn"  ,  "toolbox/images/images/private/";
"dicom_write_stream"  ,  "toolbox/images/images/private/";
"dicom_xform_image"  ,  "toolbox/images/images/private/";
"dicomdict"  ,  "toolbox/images/images/";
"dicominfo"  ,  "toolbox/images/images/";
"dicomread"  ,  "toolbox/images/images/";
"dicomuid"  ,  "toolbox/images/images/";
"dicomwrite"  ,  "toolbox/images/images/";
"difeqdem"  ,  "toolbox/splines/";
"difeqite"  ,  "toolbox/splines/";
"difeqset"  ,  "toolbox/splines/";
"diffeqed"  ,  "toolbox/simulink/dee/";
"differentiator"  ,  "toolbox/signal/signal/private/";
"digitrevorder"  ,  "toolbox/signal/signal/";
"digits"  ,  "toolbox/symbolic/";
"dilate"  ,  "toolbox/images/images/";
"dimpulse"  ,  "toolbox/control/ctrlobsolete/";
"dinitial"  ,  "toolbox/control/ctrlobsolete/";
"dintdemo"  ,  "toolbox/robust/";
"dinteva"  ,  "toolbox/robust/";
"dintplt"  ,  "toolbox/robust/";
"dirac"  ,  "toolbox/symbolic/";
"diric"  ,  "toolbox/signal/signal/";
"disableimplicitsignalresolution"  ,  "toolbox/simulink/simulink/";
"diskdemo"  ,  "toolbox/control/ctrldemos/";
"diskdemo_aux"  ,  "toolbox/control/ctrldemos/";
"dispblocksmissed"  ,  "toolbox/slcontrol/slctrlutil/";
"display1"  ,  "toolbox/optim/private/";
"distchck"  ,  "toolbox/stats/";
"disttool"  ,  "toolbox/stats/";
"dither"  ,  "toolbox/images/images/";
"ditherc"  ,  "toolbox/images/images/private/";
"dividenowarn"  ,  "toolbox/signal/signal/private/";
"dkalman"  ,  "toolbox/control/control/";
"dlg_apply_bitops_to_all_charts"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_apply_ui_checkbox"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_call"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_common_uis"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_constants"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_data"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_edit_field"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_enable_ui"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_end_construction"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_figure"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_get_string"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_goto_debugger"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_goto_dest"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_goto_document"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_goto_object"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_goto_parent"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_goto_source"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_is_iced"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_mouse"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_open"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_origin"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_refresh"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_resize"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_revert"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_revert_property"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_set"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_set_string"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_sort_uicontrols"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_str_width"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_sub_dialog"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_trans_table"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_update_parent_ui"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_update_srcdst_ui"  ,  "toolbox/stateflow/stateflow/private/";
"dlg_update_subsystem_ui"  ,  "toolbox/stateflow/stateflow/private/";
"dlinmod"  ,  "toolbox/simulink/simulink/";
"dlinmodv5"  ,  "toolbox/simulink/simulink/";
"dlqe"  ,  "toolbox/control/ctrlobsolete/";
"dlqew"  ,  "toolbox/control/ctrlobsolete/";
"dlqr"  ,  "toolbox/control/control/";
"dlqrc"  ,  "toolbox/robust/";
"dlqry"  ,  "toolbox/control/ctrlobsolete/";
"dlsim"  ,  "toolbox/control/ctrlobsolete/";
"dlyap"  ,  "toolbox/control/control/";
"dlyapchol"  ,  "toolbox/control/control/";
"dmodred"  ,  "toolbox/control/ctrlobsolete/";
"dmulresp"  ,  "toolbox/control/ctrlobsolete/";
"dnichols"  ,  "toolbox/control/ctrlobsolete/";
"dnyquist"  ,  "toolbox/control/ctrlobsolete/";
"dobal"  ,  "toolbox/robust/";
"docblock"  ,  "toolbox/simulink/blocks/";
"docopt"  ,  "toolbox/local/";
"dogleg"  ,  "toolbox/optim/private/";
"dow_package_registry"  ,  "toolbox/simulink/simulink/";
"downsample"  ,  "toolbox/signal/signal/";
"dparseit"  ,  "toolbox/simulink/dee/";
"dpss"  ,  "toolbox/signal/signal/";
"dpssclear"  ,  "toolbox/signal/signal/";
"dpssdir"  ,  "toolbox/signal/signal/";
"dpssload"  ,  "toolbox/signal/signal/";
"dpsssave"  ,  "toolbox/signal/signal/";
"drawacc"  ,  "toolbox/robust/";
"drawpznumbers"  ,  "toolbox/signal/signal/";
"dreg"  ,  "toolbox/control/ctrlobsolete/";
"dric"  ,  "toolbox/control/ctrlobsolete/";
"driccond"  ,  "toolbox/robust/";
"drmodel"  ,  "toolbox/control/control/";
"drqpbox"  ,  "toolbox/optim/private/";
"drss"  ,  "toolbox/control/control/";
"drt_rtw_info_hook"  ,  "toolbox/rtw/rtw/";
"drum1"  ,  "toolbox/pde/";
"drum2"  ,  "toolbox/pde/";
"dsfunc"  ,  "toolbox/simulink/blocks/";
"dsigma"  ,  "toolbox/control/ctrlobsolete/";
"dskwheel"  ,  "toolbox/control/ctrldemos/private/";
"dsolve"  ,  "toolbox/symbolic/";
"dsort"  ,  "toolbox/control/control/";
"dspblksstatusbar"  ,  "toolbox/signal/sigtools/";
"dspblkstructures"  ,  "toolbox/signal/sigtools/";
"dspplugin"  ,  "toolbox/signal/sigtools/";
"dss"  ,  "toolbox/control/control/";
"dst"  ,  "toolbox/pde/";
"dstep"  ,  "toolbox/control/ctrlobsolete/";
"dtf2ss"  ,  "toolbox/simulink/simulink/";
"dtimscale"  ,  "toolbox/ident/idutils/private/";
"dtimvec"  ,  "toolbox/control/ctrlobsolete/";
"dtmfdemo"  ,  "toolbox/signal/sigdemos/";
"dtrend"  ,  "toolbox/ident/idobsolete/";
"dualsimplex"  ,  "toolbox/optim/private/";
"dummyvar"  ,  "toolbox/stats/";
"dump_exported_fcn_prototypes"  ,  "toolbox/stateflow/coder/private/";
"dump_module"  ,  "toolbox/stateflow/coder/private/";
"dynamicdlg"  ,  "toolbox/shared/dastudio/";
"ecdf"  ,  "toolbox/stats/";
"ecdfhist"  ,  "toolbox/stats/";
"ecg"  ,  "toolbox/signal/sigdemos/";
"edge"  ,  "toolbox/images/images/";
"edgedemo"  ,  "toolbox/images/imdemos/";
"edgelist2mask"  ,  "toolbox/images/images/private/";
"edgetaper"  ,  "toolbox/images/images/";
"elimone"  ,  "toolbox/optim/";
"ellip"  ,  "toolbox/signal/signal/";
"ellipap"  ,  "toolbox/signal/signal/";
"ellipord"  ,  "toolbox/signal/signal/";
"eml_blocks_in"  ,  "toolbox/stateflow/stateflow/private/";
"eml_chart_man"  ,  "toolbox/stateflow/stateflow/private/";
"eml_fcns_in"  ,  "toolbox/stateflow/stateflow/private/";
"eml_function_man"  ,  "toolbox/stateflow/stateflow/private/";
"eml_man"  ,  "toolbox/stateflow/stateflow/private/";
"eml_script_man"  ,  "toolbox/stateflow/stateflow/private/";
"eml_template_man"  ,  "toolbox/stateflow/stateflow/private/";
"emlnew"  ,  "toolbox/stateflow/stateflow/";
"emptyfixptsimrange"  ,  "toolbox/simulink/fixedandfloat/";
"enabdynprop"  ,  "toolbox/signal/sigtools/";
"encode_color"  ,  "toolbox/images/images/private/";
"encrypt_machine"  ,  "toolbox/stateflow/stateflow/private/";
"engunits"  ,  "toolbox/signal/sigtools/";
"eqtflength"  ,  "toolbox/signal/signal/";
"equation"  ,  "toolbox/control/ctrldemos/private/";
"erode"  ,  "toolbox/images/images/";
"esort"  ,  "toolbox/control/control/";
"esplit"  ,  "toolbox/control/ctrlutil/";
"estim"  ,  "toolbox/control/control/";
"etfe"  ,  "toolbox/ident/ident/";
"eucdist2"  ,  "toolbox/images/images/private/";
"eucdistn"  ,  "toolbox/images/images/private/";
"euler"  ,  "toolbox/simulink/simulink/";
"eulrotdisplay"  ,  "toolbox/simulink/simdemos/simgeneral/";
"evaluate_handle"  ,  "toolbox/stateflow/stateflow/private/";
"evaluate_handle_in_base_ws"  ,  "toolbox/stateflow/stateflow/private/";
"evaluatefs"  ,  "toolbox/signal/sigtools/";
"evaluatevars"  ,  "toolbox/signal/sigtools/";
"evcdf"  ,  "toolbox/stats/";
"eventddg"  ,  "toolbox/stateflow/stateflow/private/";
"eventddg_port_callback"  ,  "toolbox/stateflow/stateflow/private/";
"eventddg_preapply_callback"  ,  "toolbox/stateflow/stateflow/private/";
"eventddg_preclose_callback"  ,  "toolbox/stateflow/stateflow/private/";
"eventdlg"  ,  "toolbox/stateflow/stateflow/private/";
"evfit"  ,  "toolbox/stats/";
"evinv"  ,  "toolbox/stats/";
"evlike"  ,  "toolbox/stats/";
"evnegloglike"  ,  "toolbox/stats/";
"evpdf"  ,  "toolbox/stats/";
"evrnd"  ,  "toolbox/stats/";
"evstat"  ,  "toolbox/stats/";
"ewmaplot"  ,  "toolbox/stats/";
"execute_in_java_thread"  ,  "toolbox/stateflow/stateflow/private/";
"expand_double_byte_string"  ,  "toolbox/stateflow/stateflow/private/";
"expcdf"  ,  "toolbox/stats/";
"expfit"  ,  "toolbox/stats/";
"expinv"  ,  "toolbox/stats/";
"explike"  ,  "toolbox/stats/";
"explore_system"  ,  "toolbox/simulink/simulink/";
"explr_config_colormap"  ,  "toolbox/stateflow/stateflow/private/";
"explr_obj_del"  ,  "toolbox/stateflow/stateflow/private/";
"explr_position"  ,  "toolbox/stateflow/stateflow/private/";
"export2wsdlg"  ,  "toolbox/stats/private/";
"export_chart_functions"  ,  "toolbox/stateflow/coder/private/";
"exportccsplugin"  ,  "toolbox/signal/sigtools/";
"exportcoeffgen"  ,  "toolbox/signal/sigtools/";
"exported_fcn_checksum"  ,  "toolbox/stateflow/stateflow/private/";
"exported_fcns_in_machine"  ,  "toolbox/stateflow/stateflow/private/";
"exportlti"  ,  "toolbox/control/ctrlguis/";
"exppdf"  ,  "toolbox/stats/";
"exprnd"  ,  "toolbox/stats/";
"expstat"  ,  "toolbox/stats/";
"exresp"  ,  "toolbox/control/ctrlobsolete/";
"extendlocus"  ,  "toolbox/control/ctrlguis/";
"external_temp_limit"  ,  "toolbox/simulink/simdemos/automotive/";
"external_temp_limit1"  ,  "toolbox/simulink/simdemos/automotive/";
"extmode_transports"  ,  "toolbox/simulink/simulink/";
"extmodecallback"  ,  "toolbox/simulink/simulink/private/";
"extract_norw"  ,  "toolbox/signal/signal/private/";
"extract_relevant_dirs"  ,  "toolbox/stateflow/stateflow/private/";
"f14_digdemo"  ,  "toolbox/simulink/simdemos/aerospace/";
"f14_show"  ,  "toolbox/simulink/simdemos/aerospace/";
"f14dat"  ,  "toolbox/simulink/simdemos/aerospace/";
"f14dat_digital"  ,  "toolbox/simulink/simdemos/aerospace/";
"f14def"  ,  "toolbox/simulink/simdemos/aerospace/";
"factoran"  ,  "toolbox/stats/";
"factorandemo"  ,  "toolbox/stats/";
"factorymenu"  ,  "toolbox/signal/sigtools/";
"faddmenu"  ,  "toolbox/signal/sigtools/";
"fan2para"  ,  "toolbox/images/images/";
"fan2para_int"  ,  "toolbox/images/images/private/";
"fanbeam"  ,  "toolbox/images/images/";
"fastreshape"  ,  "toolbox/signal/signal/";
"fbode"  ,  "toolbox/control/ctrlobsolete/";
"fbox4"  ,  "toolbox/optim/";
"fcdf"  ,  "toolbox/stats/";
"fcfileread"  ,  "toolbox/signal/sigtools/";
"fdaddcontextmenu"  ,  "toolbox/signal/sigtools/";
"fdaprivate"  ,  "toolbox/signal/sigtools/";
"fdatool"  ,  "toolbox/signal/sigtools/";
"fdatool_cfi"  ,  "toolbox/signal/sigtools/private/";
"fdatool_design"  ,  "toolbox/signal/sigtools/private/";
"fdatool_fvtool"  ,  "toolbox/signal/sigtools/private/";
"fdatool_help"  ,  "toolbox/signal/sigtools/";
"fdatool_import"  ,  "toolbox/signal/sigtools/private/";
"fdatool_mfilttool"  ,  "toolbox/signal/sigtools/private/";
"fdatool_pzeditor"  ,  "toolbox/signal/sigtools/private/";
"fdatool_qfiltpanel"  ,  "toolbox/signal/sigtools/private/";
"fdatool_sidebar"  ,  "toolbox/signal/sigtools/private/";
"fdatool_xformtool"  ,  "toolbox/signal/sigtools/private/";
"fdbutter"  ,  "toolbox/signal/sptoolgui/";
"fdcheby1"  ,  "toolbox/signal/sptoolgui/";
"fdcheby2"  ,  "toolbox/signal/sptoolgui/";
"fdellip"  ,  "toolbox/signal/sptoolgui/";
"fdfirls"  ,  "toolbox/signal/sptoolgui/";
"fdhelpstr"  ,  "toolbox/signal/sptoolgui/private/";
"fdkaiser"  ,  "toolbox/signal/sptoolgui/";
"fdmodp"  ,  "toolbox/signal/sptoolgui/private/";
"fdobjhelp"  ,  "toolbox/signal/sptoolgui/private/";
"fdplugin"  ,  "toolbox/signal/sigtools/";
"fdpzedit"  ,  "toolbox/signal/sptoolgui/";
"fdremez"  ,  "toolbox/signal/sptoolgui/";
"fdrmmenu"  ,  "toolbox/signal/sigtools/";
"fdrmtoolbarbtn"  ,  "toolbox/signal/sigtools/";
"fduiputfile"  ,  "toolbox/signal/sigtools/";
"fdutil"  ,  "toolbox/signal/sptoolgui/";
"feasibl"  ,  "toolbox/optim/private/";
"feedback"  ,  "toolbox/control/control/";
"feedbk"  ,  "toolbox/robust/";
"fevaldlg"  ,  "toolbox/simulink/dee/";
"ff2n"  ,  "toolbox/stats/";
"ffplot"  ,  "toolbox/ident/ident/";
"fftfilt"  ,  "toolbox/signal/signal/";
"fgoalattain"  ,  "toolbox/optim/";
"fiactha"  ,  "toolbox/ident/idguis/";
"fiacthad"  ,  "toolbox/ident/idguis/";
"fiactham"  ,  "toolbox/ident/idguis/";
"figpos"  ,  "toolbox/simulink/simulink/private/";
"file2str"  ,  "toolbox/stateflow/stateflow/private/";
"filt"  ,  "toolbox/control/control/";
"filtcon"  ,  "toolbox/optim/";
"filtdem"  ,  "toolbox/signal/sigdemos/";
"filtdem2"  ,  "toolbox/signal/sigdemos/";
"filtdemo"  ,  "toolbox/signal/sigdemos/";
"filtdes"  ,  "toolbox/signal/sptoolgui/";
"filter_deleted_ids"  ,  "toolbox/stateflow/stateflow/private/";
"filterguitar"  ,  "toolbox/signal/sigdemos/";
"filterguitardemo"  ,  "toolbox/signal/sigdemos/";
"filternorm"  ,  "toolbox/signal/signal/";
"filtfilt"  ,  "toolbox/signal/signal/";
"filtfun"  ,  "toolbox/optim/";
"filtfun2"  ,  "toolbox/optim/";
"filtic"  ,  "toolbox/signal/signal/";
"filtm"  ,  "toolbox/simulink/blocks/";
"filtobj"  ,  "toolbox/optim/";
"filtview"  ,  "toolbox/signal/sptoolgui/";
"find_by_type"  ,  "toolbox/stateflow/stateflow/private/";
"find_dv"  ,  "toolbox/shared/dastudio/";
"find_mdlrefs"  ,  "toolbox/simulink/simulink/";
"find_model_reference_candidates"  ,  "toolbox/simulink/simulink/private/";
"find_system"  ,  "toolbox/simulink/simulink/";
"find_target_files"  ,  "toolbox/stateflow/stateflow/private/";
"findallwinclasses"  ,  "toolbox/signal/sigtools/";
"findblib"  ,  "toolbox/simulink/simulink/";
"findbounds"  ,  "toolbox/images/images/";
"findbussrc"  ,  "toolbox/simulink/simulink/private/";
"findcstr"  ,  "toolbox/signal/sptoolgui/private/";
"findfilters"  ,  "toolbox/signal/sigtools/";
"findif"  ,  "toolbox/simulink/simulink/private/";
"findmax"  ,  "toolbox/optim/";
"findmax2"  ,  "toolbox/optim/";
"findnk"  ,  "toolbox/ident/idutils/";
"findnonabstractsubclasses"  ,  "toolbox/signal/sigtools/";
"findop"  ,  "toolbox/slcontrol/slcontrol/";
"findp"  ,  "toolbox/optim/private/";
"findplugins"  ,  "toolbox/signal/sigtools/private/";
"findslobj"  ,  "toolbox/simulink/simulink/";
"findtau"  ,  "toolbox/ident/idutils/";
"findzero"  ,  "toolbox/ident/idutils/";
"finishdlg"  ,  "toolbox/local/";
"finishsav"  ,  "toolbox/local/";
"finitedifferences"  ,  "toolbox/shared/optimlib/";
"finv"  ,  "toolbox/stats/";
"fipert_qr"  ,  "toolbox/ident/idutils/private/";
"fir1"  ,  "toolbox/signal/signal/";
"fir2"  ,  "toolbox/signal/signal/";
"firchk"  ,  "toolbox/signal/signal/private/";
"fircls"  ,  "toolbox/signal/signal/";
"fircls1"  ,  "toolbox/signal/signal/";
"firdemo"  ,  "toolbox/images/imdemos/";
"fire_show"  ,  "toolbox/stateflow/sfdemos/";
"firgauss"  ,  "toolbox/signal/signal/";
"firls"  ,  "toolbox/signal/signal/";
"firpm"  ,  "toolbox/signal/signal/";
"firpmfrf"  ,  "toolbox/signal/signal/private/";
"firpmord"  ,  "toolbox/signal/signal/";
"firrcos"  ,  "toolbox/signal/signal/";
"fitd"  ,  "toolbox/robust/";
"fitdecorrtrans"  ,  "toolbox/images/images/private/";
"fitfun2"  ,  "toolbox/optim/";
"fitfun2outputfcn"  ,  "toolbox/optim/";
"fitgain"  ,  "toolbox/robust/";
"fix_corrupted_grouped_bits"  ,  "toolbox/stateflow/stateflow/private/";
"fix_corrupted_sf_blocks"  ,  "toolbox/stateflow/stateflow/private/";
"fix_corrupted_subgroups"  ,  "toolbox/stateflow/stateflow/private/";
"fix_outport_initial_values"  ,  "toolbox/stateflow/stateflow/private/";
"fixdt"  ,  "toolbox/simulink/fixedandfloat/";
"fixedfont"  ,  "toolbox/signal/sptoolgui/private/";
"fixmult"  ,  "toolbox/robust/";
"fixpar"  ,  "toolbox/ident/idobsolete/";
"fixpoint"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt"  ,  "toolbox/simulink/fixedandfloat/";
"fixptPrivate"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_blks_in_mdl"  ,  "toolbox/simulink/simulink/private/";
"fixpt_clear_tag"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_evenspace_cleanup"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_extractbits_mask"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_extractbits_mask_script"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_fir_mask_data"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_gain_mask_data"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_interp1"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_look1_func_approx"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_look1_func_plot"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_look1_mask_data"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_look2_mask_data"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_mask_disp_prep"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_mpswitch_mask_data"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_mul_mask_data"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_mul_mask_data_str"  ,  "toolbox/simulink/fixedandfloat/";
"fixpt_set_all"  ,  "toolbox/simulink/fixedandfloat/";
"fixptbestexp"  ,  "toolbox/simulink/fixedandfloat/";
"fixptbestprec"  ,  "toolbox/simulink/fixedandfloat/";
"fixptdeftype"  ,  "toolbox/simulink/fixedandfloat/";
"fixptdialog"  ,  "toolbox/simulink/fixedandfloat/";
"fixptlibname"  ,  "toolbox/simulink/fixedandfloat/";
"fixptmaskinit"  ,  "toolbox/simulink/fixedandfloat/";
"fixptopt"  ,  "toolbox/simulink/fixedandfloat/";
"fixradix"  ,  "toolbox/simulink/fixedandfloat/obsolete/";
"fixscale"  ,  "toolbox/simulink/fixedandfloat/obsolete/";
"fixslope"  ,  "toolbox/simulink/fixedandfloat/obsolete/";
"fixup_uiedit"  ,  "toolbox/signal/sigtools/";
"flattopwin"  ,  "toolbox/signal/signal/";
"fleq3"  ,  "toolbox/optim/";
"fliptform"  ,  "toolbox/images/images/";
"float"  ,  "toolbox/simulink/fixedandfloat/";
"fmincon"  ,  "toolbox/optim/";
"fminimax"  ,  "toolbox/optim/";
"fminunc"  ,  "toolbox/optim/";
"fminusub"  ,  "toolbox/optim/private/";
"fn2fm"  ,  "toolbox/splines/";
"fnbrk"  ,  "toolbox/splines/";
"fnchg"  ,  "toolbox/splines/";
"fncmb"  ,  "toolbox/splines/";
"fnd_objprop"  ,  "toolbox/stateflow/stateflow/private/";
"fnd_runsearch"  ,  "toolbox/stateflow/stateflow/private/";
"fnder"  ,  "toolbox/splines/";
"fndir"  ,  "toolbox/splines/";
"fnint"  ,  "toolbox/splines/";
"fnjmp"  ,  "toolbox/splines/";
"fnmin"  ,  "toolbox/splines/";
"fnplt"  ,  "toolbox/splines/";
"fnrfn"  ,  "toolbox/splines/";
"fntlr"  ,  "toolbox/splines/";
"fnval"  ,  "toolbox/splines/";
"fnzeros"  ,  "toolbox/splines/";
"foccheck"  ,  "toolbox/ident/idutils/";
"focus_explorer_on_model_configuration"  ,  "toolbox/simulink/simulink/private/";
"foptions"  ,  "toolbox/simulink/simulink/";
"foreach"  ,  "toolbox/simulink/simulink/private/";
"fpbhelp"  ,  "toolbox/simulink/fixedandfloat/";
"fpdf"  ,  "toolbox/stats/";
"fqf2ido"  ,  "toolbox/ident/idobsolete/";
"fquad"  ,  "toolbox/optim/private/";
"fracfact"  ,  "toolbox/stats/";
"frame"  ,  "toolbox/stateflow/stateflow/private/";
"frameedit"  ,  "toolbox/simulink/simulink/";
"framelab"  ,  "toolbox/signal/sptoolgui/private/";
"framewlabel"  ,  "toolbox/signal/sigtools/";
"franke"  ,  "toolbox/splines/";
"frefine"  ,  "toolbox/signal/signal/private/";
"freqchk"  ,  "toolbox/signal/signal/private/";
"freqfocus"  ,  "toolbox/ident/idutils/private/";
"freqint"  ,  "toolbox/control/ctrlobsolete/";
"freqint2"  ,  "toolbox/control/ctrlobsolete/";
"freqkern"  ,  "toolbox/ident/idutils/";
"freqpick"  ,  "toolbox/ident/idutils/private/";
"freqplotter"  ,  "toolbox/signal/sigtools/";
"freqrc"  ,  "toolbox/robust/";
"freqresp"  ,  "toolbox/control/control/";
"freqs"  ,  "toolbox/signal/signal/";
"freqz"  ,  "toolbox/signal/signal/";
"freqz2"  ,  "toolbox/images/images/";
"freqz_freqvec"  ,  "toolbox/signal/signal/";
"freqzparse"  ,  "toolbox/signal/signal/";
"freqzplot"  ,  "toolbox/signal/signal/";
"friedman"  ,  "toolbox/stats/";
"frmcell"  ,  "toolbox/stateflow/stateflow/private/";
"frnd"  ,  "toolbox/stats/";
"fromddg"  ,  "toolbox/simulink/blocks/";
"fsamp2"  ,  "toolbox/images/images/";
"fsdialog"  ,  "toolbox/signal/sigtools/";
"fseminf"  ,  "toolbox/optim/";
"fsolve"  ,  "toolbox/optim/";
"fspecial"  ,  "toolbox/images/images/";
"fstab"  ,  "toolbox/ident/idutils/";
"fstat"  ,  "toolbox/stats/";
"fsub_estim"  ,  "toolbox/ident/idutils/";
"fsurfht"  ,  "toolbox/stats/";
"ftrans2"  ,  "toolbox/images/images/";
"fullfact"  ,  "toolbox/stats/";
"fullviewlink"  ,  "toolbox/signal/sigtools/private/";
"function_prototype_utils"  ,  "toolbox/stateflow/stateflow/private/";
"functiontostring"  ,  "toolbox/optim/";
"funtool"  ,  "toolbox/symbolic/";
"fvhelpstr"  ,  "toolbox/signal/sptoolgui/private/";
"fvinit"  ,  "toolbox/signal/sptoolgui/private/";
"fvmotion"  ,  "toolbox/signal/sptoolgui/private/";
"fvresize"  ,  "toolbox/signal/sptoolgui/private/";
"fvtool"  ,  "toolbox/signal/sigtools/";
"fvtooldemo"  ,  "toolbox/signal/sigdemos/";
"fvtoolwaddnreplace"  ,  "toolbox/signal/sigtools/";
"fvzoom"  ,  "toolbox/signal/sptoolgui/private/";
"fwind1"  ,  "toolbox/images/images/";
"fwind2"  ,  "toolbox/images/images/";
"fxpdemo_approx_sin"  ,  "toolbox/simulink/fixedandfloat/fxpdemos/";
"fxptdlg"  ,  "toolbox/simulink/fixedandfloat/";
"fxptplt"  ,  "toolbox/simulink/fixedandfloat/";
"fzmult"  ,  "toolbox/optim/";
"gamcdf"  ,  "toolbox/stats/";
"gamfit"  ,  "toolbox/stats/";
"gaminv"  ,  "toolbox/stats/";
"gamlike"  ,  "toolbox/stats/";
"gampdf"  ,  "toolbox/stats/";
"gamrnd"  ,  "toolbox/stats/";
"gamstat"  ,  "toolbox/stats/";
"gangstr"  ,  "toolbox/optim/";
"gauspuls"  ,  "toolbox/signal/signal/";
"gausswin"  ,  "toolbox/signal/signal/";
"gcare"  ,  "toolbox/control/control/";
"gcb"  ,  "toolbox/simulink/simulink/";
"gcbh"  ,  "toolbox/simulink/simulink/";
"gcr"  ,  "toolbox/control/ctrlguis/";
"gcs"  ,  "toolbox/simulink/simulink/";
"gdare"  ,  "toolbox/control/control/";
"gear"  ,  "toolbox/simulink/simulink/";
"gencoswin"  ,  "toolbox/signal/signal/private/";
"generate_code_for_charts_and_machine"  ,  "toolbox/stateflow/coder/private/";
"generate_results"  ,  "toolbox/simulink/simcoverage/private/";
"generatemsgid"  ,  "toolbox/signal/sigtools/";
"genericddg"  ,  "toolbox/simulink/simulink/";
"genmcode"  ,  "toolbox/signal/sigtools/";
"genmcodeutils"  ,  "toolbox/signal/sigtools/";
"genplotdata"  ,  "toolbox/signal/signal/";
"gensig"  ,  "toolbox/control/control/";
"geocdf"  ,  "toolbox/stats/";
"geoinv"  ,  "toolbox/stats/";
"geomean"  ,  "toolbox/stats/";
"geopdf"  ,  "toolbox/stats/";
"geornd"  ,  "toolbox/stats/";
"geostat"  ,  "toolbox/stats/";
"getActiveCode"  ,  "toolbox/simulink/simulink/";
"getActiveConfigSet"  ,  "toolbox/simulink/simulink/";
"getConfigSet"  ,  "toolbox/simulink/simulink/";
"getConfigSets"  ,  "toolbox/simulink/simulink/";
"getDAWorkspace"  ,  "toolbox/shared/dastudio/";
"getHardwareConfigs"  ,  "toolbox/simulink/simulink/";
"getMappingOldMaskToCurrent"  ,  "toolbox/simulink/simulink/private/";
"getSoftwareEnvironments"  ,  "toolbox/simulink/simulink/";
"getWorkspaceWrapper"  ,  "toolbox/shared/dastudio/";
"get_autoinheritance_info"  ,  "toolbox/stateflow/stateflow/private/";
"get_boiler_plate_comment"  ,  "toolbox/stateflow/coder/private/";
"get_boolean_rtw_option"  ,  "toolbox/stateflow/coder/private/";
"get_charts_of"  ,  "toolbox/stateflow/stateflow/private/";
"get_checksum_from_dll"  ,  "toolbox/stateflow/stateflow/private/";
"get_clipboard_machine"  ,  "toolbox/stateflow/stateflow/private/";
"get_datestring"  ,  "toolbox/stateflow/stateflow/private/";
"get_eml_script"  ,  "toolbox/simulink/simulink/";
"get_ert_multi_instance_errcode"  ,  "toolbox/stateflow/coder/private/";
"get_filepath_from_user"  ,  "toolbox/stateflow/stateflow/private/";
"get_fxpprop_from_name"  ,  "toolbox/simulink/blocks/private/";
"get_image_title"  ,  "toolbox/images/images/private/";
"get_instances_in_machine"  ,  "toolbox/stateflow/stateflow/private/";
"get_link_chart_file_numbers"  ,  "toolbox/stateflow/stateflow/private/";
"get_link_machine_list"  ,  "toolbox/stateflow/stateflow/private/";
"get_mdl_dir"  ,  "toolbox/simulink/simulink/private/";
"get_model_reference_info"  ,  "toolbox/stateflow/coder/private/";
"get_ordered_model_references"  ,  "toolbox/simulink/simulink/private/";
"get_param"  ,  "toolbox/simulink/simulink/";
"get_params_str_for_chart"  ,  "toolbox/stateflow/stateflow/private/";
"get_relevant_machine"  ,  "toolbox/stateflow/coder/private/";
"get_sf_block_port_info"  ,  "toolbox/stateflow/stateflow/private/";
"get_stateflow_path_to_parent"  ,  "toolbox/stateflow/stateflow/private/";
"get_test_point_properties"  ,  "toolbox/stateflow/stateflow/private/";
"get_tmf_for_target"  ,  "toolbox/rtw/rtw/";
"get_valid_property_values"  ,  "toolbox/stateflow/stateflow/private/";
"get_value_of_fields"  ,  "toolbox/rtw/rtw/";
"get_wksp_data_for_chart"  ,  "toolbox/stateflow/stateflow/private/";
"get_wksp_data_names_for_chart"  ,  "toolbox/stateflow/stateflow/private/";
"get_word_sizes"  ,  "toolbox/stateflow/coder/private/";
"getargth"  ,  "toolbox/ident/idobsolete/";
"getarxms"  ,  "toolbox/ident/idutils/";
"getblocklinearizeio"  ,  "toolbox/slcontrol/slctrlguis/private/";
"getblocklinio"  ,  "toolbox/slcontrol/slctrlutil/";
"getclassindex"  ,  "toolbox/stats/private/";
"getcolorfromindex"  ,  "toolbox/signal/sigtools/";
"getconstructorfromstructure"  ,  "toolbox/signal/sigtools/";
"getcurpt"  ,  "toolbox/images/images/private/";
"getcurv2"  ,  "toolbox/splines/";
"getcurve"  ,  "toolbox/splines/";
"getdatatypespecs"  ,  "toolbox/simulink/fixedandfloat/";
"getdiscdata"  ,  "toolbox/simulink/components/";
"getdsdb"  ,  "toolbox/stats/private/";
"getfdasessionhandle"  ,  "toolbox/signal/sigtools/";
"getff"  ,  "toolbox/ident/idobsolete/";
"getfitdb"  ,  "toolbox/stats/private/";
"getfreqlbl"  ,  "toolbox/signal/sigtools/";
"getfrequnitstrs"  ,  "toolbox/signal/sigtools/";
"getfullname"  ,  "toolbox/simulink/simulink/";
"getgloballog"  ,  "toolbox/simulink/fixedandfloat/";
"gethgstackorder"  ,  "toolbox/signal/sigtools/";
"getimage"  ,  "toolbox/images/images/";
"getinternaldiscfunction"  ,  "toolbox/simulink/components/private/";
"getinterpfrequencies"  ,  "toolbox/signal/signal/private/";
"getlevel"  ,  "toolbox/simulink/simulink/private/";
"getline"  ,  "toolbox/images/images/";
"getlinio"  ,  "toolbox/slcontrol/slcontrol/";
"getlinplant"  ,  "toolbox/slcontrol/slcontrol/";
"getmagunitstrs"  ,  "toolbox/signal/sigtools/";
"getmfth"  ,  "toolbox/ident/idobsolete/";
"getncap"  ,  "toolbox/ident/idobsolete/";
"getolmodel"  ,  "toolbox/slcontrol/slctrlutil/";
"getoutlierdb"  ,  "toolbox/stats/private/";
"getpts"  ,  "toolbox/images/images/";
"getrect"  ,  "toolbox/images/images/";
"getsigpref"  ,  "toolbox/signal/sptoolgui/";
"getsro"  ,  "toolbox/sloptim/sloptim/";
"getsys"  ,  "toolbox/simulink/dee/";
"gett"  ,  "toolbox/ident/idobsolete/";
"gettargdatamap"  ,  "toolbox/rtw/rtw/";
"gettargetcharshortintlong"  ,  "toolbox/simulink/fixedandfloat/";
"getvalidproject"  ,  "toolbox/shared/slcontrollib/";
"getwinobject"  ,  "toolbox/signal/sigtools/";
"getxo"  ,  "toolbox/simulink/blocks/";
"getxu"  ,  "toolbox/slcontrol/slcontrol/";
"getzeros"  ,  "toolbox/control/ctrlutil/";
"getzp"  ,  "toolbox/ident/idobsolete/";
"givens"  ,  "toolbox/control/ctrlobsolete/";
"gline"  ,  "toolbox/stats/";
"glmdemo"  ,  "toolbox/stats/";
"glmfit"  ,  "toolbox/stats/";
"glmval"  ,  "toolbox/stats/";
"glyphplot"  ,  "toolbox/stats/";
"gmonopuls"  ,  "toolbox/signal/signal/";
"gname"  ,  "toolbox/stats/";
"gnnans"  ,  "toolbox/ident/idutils/private/";
"gnnans_f"  ,  "toolbox/ident/idutils/private/";
"gnnew"  ,  "toolbox/ident/idutils/";
"gnnew_f"  ,  "toolbox/ident/idutils/";
"gnnew_fp"  ,  "toolbox/ident/idutils/";
"goalcon"  ,  "toolbox/optim/";
"goaldemo"  ,  "toolbox/optim/";
"goalfun"  ,  "toolbox/optim/";
"goertzel"  ,  "toolbox/signal/signal/";
"goto_target"  ,  "toolbox/stateflow/stateflow/private/";
"gotoddg"  ,  "toolbox/simulink/blocks/";
"gotoddg_cb"  ,  "toolbox/simulink/simulink/";
"gparetodemo"  ,  "toolbox/stats/";
"gpdhelp"  ,  "toolbox/stateflow/stateflow/private/";
"gpicon"  ,  "toolbox/stateflow/stateflow/private/";
"gplotmatrix"  ,  "toolbox/stats/";
"gpnegloglike"  ,  "toolbox/stats/";
"gpnegloglike2"  ,  "toolbox/stats/";
"gpzoom"  ,  "toolbox/stateflow/stateflow/private/";
"graderr"  ,  "toolbox/simulink/simulink/private/";
"graderr"  ,  "toolbox/shared/optimlib/";
"graft"  ,  "toolbox/robust/";
"gram"  ,  "toolbox/control/ctrlobsolete/";
"grandfather"  ,  "toolbox/stateflow/stateflow/private/";
"grandfather_precedence"  ,  "toolbox/stateflow/stateflow/private/";
"gray2ind"  ,  "toolbox/images/images/";
"grayslice"  ,  "toolbox/images/images/";
"graythresh"  ,  "toolbox/images/images/";
"grayto16"  ,  "toolbox/images/images/private/";
"grayto8"  ,  "toolbox/images/images/private/";
"gridline"  ,  "toolbox/control/ctrldemos/private/";
"gridopts"  ,  "toolbox/control/ctrlguis/";
"gridunc"  ,  "toolbox/sloptim/sloptim/";
"ground"  ,  "toolbox/control/ctrldemos/private/";
"groupbox"  ,  "toolbox/simulink/simulink/private/";
"groupbox"  ,  "toolbox/stateflow/stateflow/private/";
"grp2idx"  ,  "toolbox/stats/";
"grpdelay"  ,  "toolbox/signal/signal/";
"grpstats"  ,  "toolbox/stats/";
"gscatter"  ,  "toolbox/stats/";
"gui_sizes"  ,  "toolbox/signal/sigtools/private/";
"h2data"  ,  "toolbox/robust/";
"h2des1"  ,  "toolbox/robust/";
"h2lqg"  ,  "toolbox/robust/";
"hamming"  ,  "toolbox/signal/signal/";
"hann"  ,  "toolbox/signal/signal/";
"hanning"  ,  "toolbox/signal/signal/";
"harmmean"  ,  "toolbox/stats/";
"hasmask"  ,  "toolbox/simulink/simulink/";
"hasmaskdlg"  ,  "toolbox/simulink/simulink/";
"hasmaskicon"  ,  "toolbox/simulink/simulink/";
"hdsCatArray"  ,  "toolbox/shared/hds/";
"hdsGetSize"  ,  "toolbox/shared/hds/";
"hdsGetSlice"  ,  "toolbox/shared/hds/";
"hdsNewArray"  ,  "toolbox/shared/hds/";
"hdsReplicateArray"  ,  "toolbox/shared/hds/";
"hdsReshapeArray"  ,  "toolbox/shared/hds/";
"hdsSetSlice"  ,  "toolbox/shared/hds/";
"heatex"  ,  "toolbox/control/ctrldemos/";
"heatex_clbk"  ,  "toolbox/control/ctrldemos/";
"heatex_getdata"  ,  "toolbox/control/ctrldemos/";
"heatex_sls"  ,  "toolbox/control/ctrldemos/";
"heaviside"  ,  "toolbox/symbolic/";
"helplinf"  ,  "toolbox/robust/";
"hessabc"  ,  "toolbox/control/ctrlutil/";
"hgrc"  ,  "toolbox/local/";
"hidecrit"  ,  "toolbox/simulink/components/";
"hiercheck"  ,  "toolbox/stateflow/stateflow/private/";
"highpass"  ,  "toolbox/signal/signal/private/";
"hilbert"  ,  "toolbox/signal/signal/";
"hilbfilt"  ,  "toolbox/signal/signal/private/";
"hilite_system"  ,  "toolbox/simulink/simulink/";
"hilitediscblock"  ,  "toolbox/simulink/components/";
"hinf"  ,  "toolbox/robust/";
"hinfdata"  ,  "toolbox/robust/";
"hinfdemo"  ,  "toolbox/robust/";
"hinfdes1"  ,  "toolbox/robust/";
"hinfkgjd"  ,  "toolbox/robust/";
"hinflim"  ,  "toolbox/robust/";
"hinfopt"  ,  "toolbox/robust/";
"hist3"  ,  "toolbox/stats/";
"histeq"  ,  "toolbox/images/images/";
"histfit"  ,  "toolbox/stats/";
"histodem"  ,  "toolbox/splines/";
"hkl1"  ,  "toolbox/robust/";
"hkl2"  ,  "toolbox/robust/";
"hkl3"  ,  "toolbox/robust/";
"hkl4"  ,  "toolbox/robust/";
"hksv"  ,  "toolbox/robust/";
"hmatdemo"  ,  "toolbox/robust/";
"hmfbx4"  ,  "toolbox/optim/";
"hmfleq1"  ,  "toolbox/optim/";
"hmmdecode"  ,  "toolbox/stats/";
"hmmestimate"  ,  "toolbox/stats/";
"hmmgenerate"  ,  "toolbox/stats/";
"hmmtrain"  ,  "toolbox/stats/";
"hmmviterbi"  ,  "toolbox/stats/";
"hmult"  ,  "toolbox/optim/private/";
"hostid"  ,  "toolbox/local/";
"hougen"  ,  "toolbox/stats/";
"hoverfig"  ,  "toolbox/shared/controllib/";
"hplant"  ,  "toolbox/robust/";
"hprecon"  ,  "toolbox/optim/";
"hqr10"  ,  "toolbox/robust/";
"htdes1"  ,  "toolbox/robust/";
"hygecdf"  ,  "toolbox/stats/";
"hygeinv"  ,  "toolbox/stats/";
"hygepdf"  ,  "toolbox/stats/";
"hygernd"  ,  "toolbox/stats/";
"hygestat"  ,  "toolbox/stats/";
"hyperbolic"  ,  "toolbox/pde/";
"hypergeom"  ,  "toolbox/symbolic/";
"icceps"  ,  "toolbox/signal/signal/";
"iccread"  ,  "toolbox/images/images/";
"icdf"  ,  "toolbox/stats/";
"iconedit"  ,  "toolbox/simulink/simulink/";
"idarxstr"  ,  "toolbox/ident/idguis/";
"idbuildw"  ,  "toolbox/ident/idguis/";
"idbwtext"  ,  "toolbox/ident/idguis/";
"idchi2"  ,  "toolbox/ident/idutils/";
"idchnona"  ,  "toolbox/ident/idutils/";
"idcmdld"  ,  "toolbox/ident/idguis/";
"idconfcp"  ,  "toolbox/ident/idguis/";
"idct"  ,  "toolbox/signal/signal/";
"idct"  ,  "toolbox/images/images/private/";
"idct2"  ,  "toolbox/images/images/";
"idctold"  ,  "toolbox/signal/signal/private/";
"iddatfig"  ,  "toolbox/ident/idguis/";
"iddef"  ,  "toolbox/ident/idutils/";
"iddeft"  ,  "toolbox/ident/idutils/";
"iddefw"  ,  "toolbox/ident/idutils/";
"iddemo"  ,  "toolbox/ident/iddemos/";
"iddemo1"  ,  "toolbox/ident/iddemos/";
"iddemo2"  ,  "toolbox/ident/iddemos/";
"iddemo3"  ,  "toolbox/ident/iddemos/";
"iddemo4"  ,  "toolbox/ident/iddemos/";
"iddemo5"  ,  "toolbox/ident/iddemos/";
"iddemo6"  ,  "toolbox/ident/iddemos/";
"iddemo7"  ,  "toolbox/ident/iddemos/";
"iddemo8"  ,  "toolbox/ident/iddemos/";
"iddemo9"  ,  "toolbox/ident/iddemos/";
"iddemofr"  ,  "toolbox/ident/iddemos/";
"iddemopr"  ,  "toolbox/ident/iddemos/";
"iddemosl"  ,  "toolbox/ident/iddemos/";
"iddfthru"  ,  "toolbox/ident/idutils/";
"iddfthru"  ,  "toolbox/ident/ident/";
"iddmtab"  ,  "toolbox/ident/idguis/";
"ident"  ,  "toolbox/ident/idguis/";
"identsinkwrite"  ,  "toolbox/ident/idutils/";
"identsinkwrite"  ,  "toolbox/ident/ident/";
"idextmat"  ,  "toolbox/ident/idutils/";
"idfilt"  ,  "toolbox/ident/ident/";
"idfrd2iddata"  ,  "toolbox/ident/idutils/";
"idgenfig"  ,  "toolbox/ident/idguis/";
"idgtws"  ,  "toolbox/ident/idguis/";
"idgwarn"  ,  "toolbox/ident/idguis/";
"idhelp"  ,  "toolbox/ident/ident/";
"idinput"  ,  "toolbox/ident/ident/";
"idinseva"  ,  "toolbox/ident/idguis/";
"idlayout"  ,  "toolbox/ident/idguis/";
"idlaytab"  ,  "toolbox/ident/idguis/";
"idltifr"  ,  "toolbox/ident/idutils/";
"idmdlmask"  ,  "toolbox/ident/idutils/";
"idmhit"  ,  "toolbox/ident/idguis/";
"idmodred"  ,  "toolbox/ident/ident/";
"idmsize"  ,  "toolbox/ident/idutils/";
"idmspop"  ,  "toolbox/ident/idguis/";
"idmwwb"  ,  "toolbox/ident/idguis/";
"idnamchk"  ,  "toolbox/ident/idutils/";
"idnamede"  ,  "toolbox/ident/idutils/";
"idnextw"  ,  "toolbox/ident/idguis/";
"idnonzer"  ,  "toolbox/ident/idguis/";
"ido2th"  ,  "toolbox/ident/idobsolete/";
"idoptcmp"  ,  "toolbox/ident/idguis/";
"idopttog"  ,  "toolbox/ident/idguis/";
"idparest"  ,  "toolbox/ident/idguis/";
"idplot"  ,  "toolbox/ident/idobsolete/";
"idprocest"  ,  "toolbox/ident/idguis/";
"idprops"  ,  "toolbox/ident/ident/";
"idresamp"  ,  "toolbox/ident/idobsolete/";
"idresamp"  ,  "toolbox/ident/ident/";
"idsample"  ,  "toolbox/ident/idutils/";
"idsim"  ,  "toolbox/ident/ident/";
"idsim"  ,  "toolbox/ident/idobsolete/";
"idsimsd"  ,  "toolbox/ident/idobsolete/";
"idsimsd"  ,  "toolbox/ident/ident/";
"idst"  ,  "toolbox/pde/";
"idstrip"  ,  "toolbox/ident/idguis/";
"idtscale"  ,  "toolbox/ident/idutils/";
"iduiarx"  ,  "toolbox/ident/idguis/";
"iduiaxes"  ,  "toolbox/ident/idguis/";
"iduiaxis"  ,  "toolbox/ident/idguis/";
"iduibn"  ,  "toolbox/ident/idguis/";
"iduicalc"  ,  "toolbox/ident/idguis/";
"iduiclpw"  ,  "toolbox/ident/idguis/";
"iduiconf"  ,  "toolbox/ident/idguis/";
"iduicra"  ,  "toolbox/ident/idguis/";
"iduidemo"  ,  "toolbox/ident/idguis/";
"iduidrop"  ,  "toolbox/ident/idguis/";
"iduiedit"  ,  "toolbox/ident/idguis/";
"iduiexp"  ,  "toolbox/ident/idguis/";
"iduifile"  ,  "toolbox/ident/idguis/";
"iduifilt"  ,  "toolbox/ident/idguis/";
"iduifoc"  ,  "toolbox/ident/idguis/";
"iduigco"  ,  "toolbox/ident/idguis/";
"iduigetd"  ,  "toolbox/ident/idguis/";
"iduigetp"  ,  "toolbox/ident/idguis/";
"iduihelp"  ,  "toolbox/ident/idguis/";
"iduiinfo"  ,  "toolbox/ident/idguis/";
"iduiinsd"  ,  "toolbox/ident/idguis/";
"iduiinsm"  ,  "toolbox/ident/idguis/";
"iduiio"  ,  "toolbox/ident/idguis/";
"iduiiono"  ,  "toolbox/ident/idguis/";
"iduiiter"  ,  "toolbox/ident/idguis/";
"iduikeyp"  ,  "toolbox/ident/idguis/";
"iduilay"  ,  "toolbox/ident/idguis/";
"iduilay1"  ,  "toolbox/ident/idguis/";
"iduilay2"  ,  "toolbox/ident/idguis/";
"iduimbcb"  ,  "toolbox/ident/idguis/";
"iduimod"  ,  "toolbox/ident/idguis/";
"iduims"  ,  "toolbox/ident/idguis/";
"iduinpar"  ,  "toolbox/ident/idguis/";
"iduiopt"  ,  "toolbox/ident/idguis/";
"iduipoin"  ,  "toolbox/ident/idguis/";
"iduipop"  ,  "toolbox/ident/idguis/";
"iduipw"  ,  "toolbox/ident/idguis/";
"iduiqs"  ,  "toolbox/ident/idguis/";
"iduisel"  ,  "toolbox/ident/idguis/";
"iduisess"  ,  "toolbox/ident/idguis/";
"iduispa"  ,  "toolbox/ident/idguis/";
"iduiss"  ,  "toolbox/ident/idguis/";
"iduistat"  ,  "toolbox/ident/idguis/";
"iduital"  ,  "toolbox/ident/idguis/";
"iduitrf"  ,  "toolbox/ident/idguis/";
"iduivis"  ,  "toolbox/ident/idguis/";
"iduiwast"  ,  "toolbox/ident/idguis/";
"iduiwok"  ,  "toolbox/ident/idguis/";
"idummy"  ,  "toolbox/stats/private/";
"idunlink"  ,  "toolbox/ident/idguis/";
"idvmenus"  ,  "toolbox/ident/idguis/";
"idwb"  ,  "toolbox/ident/idutils/";
"ifanbeam"  ,  "toolbox/images/images/";
"iirchk"  ,  "toolbox/signal/signal/private/";
"im2bw"  ,  "toolbox/images/images/";
"im2col"  ,  "toolbox/images/images/";
"im2double"  ,  "toolbox/images/images/";
"im2java2d"  ,  "toolbox/images/images/";
"im2mis"  ,  "toolbox/stats/private/";
"im2mis"  ,  "toolbox/images/images/";
"im2uint16"  ,  "toolbox/images/images/";
"im2uint8"  ,  "toolbox/images/images/";
"imabsdiff"  ,  "toolbox/images/images/";
"imadd"  ,  "toolbox/images/images/";
"imadjdemo"  ,  "toolbox/images/imdemos/";
"imadjust"  ,  "toolbox/images/images/";
"imapprox"  ,  "toolbox/images/images/";
"imargin"  ,  "toolbox/control/control/";
"imbothat"  ,  "toolbox/images/images/";
"imclearborder"  ,  "toolbox/images/images/";
"imclose"  ,  "toolbox/images/images/";
"imcomplement"  ,  "toolbox/images/images/";
"imcontour"  ,  "toolbox/images/images/";
"imcrop"  ,  "toolbox/images/images/";
"imdilate"  ,  "toolbox/images/images/";
"imdivide"  ,  "toolbox/images/images/";
"imerode"  ,  "toolbox/images/images/";
"imextendedmax"  ,  "toolbox/images/images/";
"imextendedmin"  ,  "toolbox/images/images/";
"imfeature"  ,  "toolbox/images/images/";
"imfill"  ,  "toolbox/images/images/";
"imfilter"  ,  "toolbox/images/images/";
"imhist"  ,  "toolbox/images/images/";
"imhistc"  ,  "toolbox/images/images/private/";
"imhmax"  ,  "toolbox/images/images/";
"imhmin"  ,  "toolbox/images/images/";
"imimposemin"  ,  "toolbox/images/images/";
"imlincomb"  ,  "toolbox/images/images/";
"immovie"  ,  "toolbox/images/images/";
"immultiply"  ,  "toolbox/images/images/";
"imnoise"  ,  "toolbox/images/images/";
"imopen"  ,  "toolbox/images/images/";
"imp2ss"  ,  "toolbox/robust/";
"impinvar"  ,  "toolbox/signal/signal/";
"impixel"  ,  "toolbox/images/images/";
"importfcn"  ,  "toolbox/control/ctrlguis/";
"importfilt"  ,  "toolbox/signal/sptoolgui/private/";
"importsig"  ,  "toolbox/signal/sptoolgui/private/";
"importspec"  ,  "toolbox/signal/sptoolgui/private/";
"improfile"  ,  "toolbox/images/images/";
"impulse"  ,  "toolbox/control/control/";
"impz"  ,  "toolbox/signal/signal/";
"impzlength"  ,  "toolbox/signal/signal/";
"imreconstruct"  ,  "toolbox/images/images/";
"imregionalmax"  ,  "toolbox/images/images/";
"imregionalmin"  ,  "toolbox/images/images/";
"imresize"  ,  "toolbox/images/images/";
"imrotate"  ,  "toolbox/images/images/";
"imshow"  ,  "toolbox/images/images/";
"imslice"  ,  "toolbox/images/images/";
"imsubtract"  ,  "toolbox/images/images/";
"imtophat"  ,  "toolbox/images/images/";
"imtransform"  ,  "toolbox/images/images/";
"imuigeom"  ,  "toolbox/images/imdemos/private/";
"imview"  ,  "toolbox/images/images/";
"imviewhelp"  ,  "toolbox/images/images/private/";
"imzoom"  ,  "toolbox/images/images/";
"inbounds"  ,  "toolbox/signal/sptoolgui/private/";
"inconsistent"  ,  "toolbox/stats/";
"increment_name"  ,  "toolbox/stateflow/stateflow/private/";
"ind2gray"  ,  "toolbox/images/images/";
"indmatch"  ,  "toolbox/ident/idutils/";
"inductor"  ,  "toolbox/control/ctrldemos/private/";
"infline"  ,  "toolbox/control/ctrlguis/";
"info2mask"  ,  "toolbox/signal/sigtools/";
"infomatman"  ,  "toolbox/stateflow/stateflow/private/";
"inherit"  ,  "toolbox/ident/idutils/";
"init_html_renderer"  ,  "toolbox/stateflow/stateflow/private/";
"initial"  ,  "toolbox/control/control/";
"initialUpper"  ,  "toolbox/simulink/simulink/private/";
"initialize_data_information"  ,  "toolbox/stateflow/coder/private/";
"initmesh"  ,  "toolbox/pde/";
"initopspec"  ,  "toolbox/shared/slcontrollib/";
"initprefs"  ,  "toolbox/local/";
"initsim"  ,  "toolbox/stateflow/sfdemos/";
"initsysresp"  ,  "toolbox/control/ctrlguis/";
"inpd2nk"  ,  "toolbox/ident/idutils/";
"insert_dsp_includes"  ,  "toolbox/stateflow/coder/private/";
"insertfdtbxhelp"  ,  "toolbox/signal/sigtools/private/";
"interc"  ,  "toolbox/robust/";
"interp"  ,  "toolbox/signal/signal/";
"interspace"  ,  "toolbox/signal/sigtools/";
"intfilt"  ,  "toolbox/signal/signal/";
"intline"  ,  "toolbox/images/images/private/";
"invfreqs"  ,  "toolbox/signal/signal/";
"invfreqz"  ,  "toolbox/signal/signal/";
"invsinc"  ,  "toolbox/signal/signal/private/";
"iofc"  ,  "toolbox/robust/";
"iofr"  ,  "toolbox/robust/";
"ipex001"  ,  "toolbox/images/imdemos/";
"ipex002"  ,  "toolbox/images/imdemos/";
"ipex003"  ,  "toolbox/images/imdemos/";
"ipex004"  ,  "toolbox/images/imdemos/";
"ipex005"  ,  "toolbox/images/imdemos/";
"ipex006"  ,  "toolbox/images/imdemos/";
"ipexangle"  ,  "toolbox/images/imdemos/";
"ipexcontrast"  ,  "toolbox/images/imdemos/";
"ipexfabric"  ,  "toolbox/images/imdemos/";
"ipexhistology"  ,  "toolbox/images/imdemos/";
"ipexlanstretch"  ,  "toolbox/images/imdemos/";
"ipexpendulum"  ,  "toolbox/images/imdemos/";
"ipexradius"  ,  "toolbox/images/imdemos/";
"ipexreconstruct"  ,  "toolbox/images/imdemos/";
"ipexregularized"  ,  "toolbox/images/imdemos/";
"ipexrice"  ,  "toolbox/images/imdemos/";
"ipexrotate"  ,  "toolbox/images/imdemos/";
"ipexroundness"  ,  "toolbox/images/imdemos/";
"ipexsnow"  ,  "toolbox/images/imdemos/";
"ipexwatershed"  ,  "toolbox/images/imdemos/";
"ippl"  ,  "toolbox/images/images/";
"iptdemos"  ,  "toolbox/images/imdemos/";
"iptgate"  ,  "toolbox/images/images/";
"iptgetpref"  ,  "toolbox/images/images/";
"iptprefs"  ,  "toolbox/images/images/private/";
"iptregistry"  ,  "toolbox/images/images/private/";
"iptsetpref"  ,  "toolbox/images/images/";
"iqr"  ,  "toolbox/stats/";
"iradon"  ,  "toolbox/images/images/";
"is2rc"  ,  "toolbox/signal/signal/";
"isModelClosed"  ,  "toolbox/simulink/simulink/private/";
"isNCDStruct"  ,  "toolbox/sloptim/sloptobsolete/";
"is_chart_input_data"  ,  "toolbox/stateflow/coder/private/";
"is_chart_output_data"  ,  "toolbox/stateflow/coder/private/";
"is_eml_block"  ,  "toolbox/simulink/simulink/";
"is_eml_chart"  ,  "toolbox/stateflow/stateflow/private/";
"is_eml_fcn"  ,  "toolbox/stateflow/stateflow/private/";
"is_eml_script"  ,  "toolbox/stateflow/stateflow/private/";
"is_enum_property"  ,  "toolbox/stateflow/stateflow/private/";
"is_ert_multi_instance"  ,  "toolbox/stateflow/coder/private/";
"is_object_editable"  ,  "toolbox/stateflow/stateflow/private/";
"is_sf_chart"  ,  "toolbox/stateflow/stateflow/private/";
"is_sf_chart_block"  ,  "toolbox/stateflow/stateflow/private/";
"is_sf_fixpt_autoscale"  ,  "toolbox/simulink/fixedandfloat/";
"is_sf_machine"  ,  "toolbox/stateflow/stateflow/private/";
"is_simulink_handle"  ,  "toolbox/simulink/simulink/";
"is_truth_table_chart"  ,  "toolbox/stateflow/stateflow/private/";
"is_truth_table_fcn"  ,  "toolbox/stateflow/stateflow/private/";
"isbw"  ,  "toolbox/images/images/";
"iscatter"  ,  "toolbox/stats/";
"iscolor"  ,  "toolbox/signal/sptoolgui/private/";
"isconfigurable"  ,  "toolbox/simulink/components/private/";
"iscontinuous"  ,  "toolbox/simulink/components/private/";
"iscpstruct"  ,  "toolbox/images/images/private/";
"iscvar"  ,  "toolbox/simulink/simulink/";
"isdynpropenab"  ,  "toolbox/signal/sigtools/";
"iseuclidean"  ,  "toolbox/stats/private/";
"isfdt"  ,  "toolbox/signal/sptoolgui/private/";
"isfdtbxinstalled"  ,  "toolbox/signal/sigtools/";
"isfixptinstalled"  ,  "toolbox/signal/sigtools/";
"isgray"  ,  "toolbox/images/images/";
"isinaxes"  ,  "toolbox/stats/private/";
"isind"  ,  "toolbox/images/images/";
"ispc"  ,  "toolbox/stateflow/stateflow/private/";
"isresampler"  ,  "toolbox/images/images/private/";
"isreserved"  ,  "toolbox/signal/sigtools/";
"isrgb"  ,  "toolbox/images/images/";
"issame"  ,  "toolbox/robust/";
"issystem"  ,  "toolbox/robust/";
"istform"  ,  "toolbox/images/images/private/";
"isthss"  ,  "toolbox/ident/idobsolete/";
"istito"  ,  "toolbox/robust/private/";
"istree"  ,  "toolbox/robust/";
"isvalidvar"  ,  "toolbox/signal/sptoolgui/private/";
"iv"  ,  "toolbox/ident/ident/";
"iv4"  ,  "toolbox/ident/ident/";
"ivar"  ,  "toolbox/ident/ident/";
"ivstruc"  ,  "toolbox/ident/ident/";
"ivx"  ,  "toolbox/ident/ident/";
"iwishrnd"  ,  "toolbox/stats/";
"jacColumnErr"  ,  "toolbox/optim/private/";
"jacobian2ss"  ,  "toolbox/slcontrol/slctrlutil/";
"javaDAClipboard"  ,  "toolbox/shared/dastudio/";
"javaSimulinkRoot"  ,  "toolbox/shared/dastudio/";
"javaWorkspace"  ,  "toolbox/shared/dastudio/";
"jbtest"  ,  "toolbox/stats/";
"jetdemo"  ,  "toolbox/control/ctrldemos/";
"jigglemesh"  ,  "toolbox/pde/";
"joinCellToStr"  ,  "toolbox/simulink/simulink/private/";
"jordan"  ,  "toolbox/symbolic/";
"josedemo"  ,  "toolbox/robust/";
"junctddg"  ,  "toolbox/stateflow/stateflow/private/";
"junctdlg"  ,  "toolbox/stateflow/stateflow/private/";
"justzoom"  ,  "toolbox/signal/sptoolgui/private/";
"kaiser"  ,  "toolbox/signal/signal/";
"kaiserord"  ,  "toolbox/signal/signal/";
"kalmdemo"  ,  "toolbox/control/ctrldemos/";
"kdtree"  ,  "toolbox/images/images/private/";
"kmeans"  ,  "toolbox/stats/";
"knt2brk"  ,  "toolbox/splines/";
"knt2mlt"  ,  "toolbox/splines/";
"kratio"  ,  "toolbox/signal/signal/";
"kruskalwallis"  ,  "toolbox/stats/";
"ksdensity"  ,  "toolbox/stats/";
"kstest"  ,  "toolbox/stats/";
"kstest2"  ,  "toolbox/stats/";
"kurtosis"  ,  "toolbox/stats/";
"lab2double"  ,  "toolbox/images/images/";
"lab2lch"  ,  "toolbox/images/images/private/";
"lab2str"  ,  "toolbox/control/ctrlobsolete/";
"lab2uint16"  ,  "toolbox/images/images/";
"lab2uint8"  ,  "toolbox/images/images/";
"lab2xyz"  ,  "toolbox/images/images/private/";
"label"  ,  "toolbox/simulink/simulink/private/";
"label2rgb"  ,  "toolbox/images/images/";
"labelacc"  ,  "toolbox/robust/";
"labelstr"  ,  "toolbox/stateflow/stateflow/private/";
"lambertw"  ,  "toolbox/symbolic/";
"landsatdemo"  ,  "toolbox/images/imdemos/";
"lar2rc"  ,  "toolbox/signal/signal/";
"largestuiwidth"  ,  "toolbox/signal/sigtools/";
"latc2tf"  ,  "toolbox/signal/signal/";
"latcfilt"  ,  "toolbox/signal/signal/";
"launchfv"  ,  "toolbox/signal/sigtools/";
"layout_disc_window"  ,  "toolbox/simulink/components/";
"lch2lab"  ,  "toolbox/images/images/private/";
"lclfminbnd"  ,  "toolbox/signal/signal/private/";
"levdown"  ,  "toolbox/signal/signal/private/";
"leverage"  ,  "toolbox/stats/";
"levinson"  ,  "toolbox/signal/signal/";
"levup"  ,  "toolbox/signal/signal/private/";
"lfdata"  ,  "toolbox/signal/sptoolgui/private/";
"lftf"  ,  "toolbox/robust/";
"lhsdesign"  ,  "toolbox/stats/";
"lhsnorm"  ,  "toolbox/stats/";
"libbrowse"  ,  "toolbox/simulink/simulink/";
"libinfo"  ,  "toolbox/simulink/simulink/";
"libintro"  ,  "toolbox/simulink/simdemos/";
"license"  ,  "toolbox/local/";
"lillietest"  ,  "toolbox/stats/";
"limintm"  ,  "toolbox/simulink/blocks/";
"lineSearch"  ,  "toolbox/optim/private/";
"linearize"  ,  "toolbox/slcontrol/slcontrol/";
"linedir"  ,  "toolbox/simulink/simulink/private/";
"lineext"  ,  "toolbox/simulink/simulink/private/";
"linemima"  ,  "toolbox/simulink/simulink/private/";
"linetip"  ,  "toolbox/shared/controllib/";
"linevent"  ,  "toolbox/slcontrol/slcontrol/";
"linf"  ,  "toolbox/robust/";
"linfdemo"  ,  "toolbox/robust/";
"linio"  ,  "toolbox/slcontrol/slcontrol/";
"linkage"  ,  "toolbox/stats/";
"linmod"  ,  "toolbox/simulink/simulink/";
"linmod2"  ,  "toolbox/simulink/simulink/";
"linmodsupported"  ,  "toolbox/simulink/simulink/private/";
"linmodv5"  ,  "toolbox/simulink/simulink/";
"linoptions"  ,  "toolbox/slcontrol/slcontrol/";
"linprog"  ,  "toolbox/optim/";
"linsetup"  ,  "toolbox/simulink/blocks/";
"linsim"  ,  "toolbox/simulink/simulink/";
"linsub"  ,  "toolbox/control/ctrlutil/";
"linterp"  ,  "toolbox/robust/";
"lipsol"  ,  "toolbox/optim/private/";
"listModels"  ,  "toolbox/shared/dastudio/";
"lnkfvtool2mask"  ,  "toolbox/signal/sigtools/";
"load_model"  ,  "toolbox/simulink/simulink/private/";
"load_simulink"  ,  "toolbox/simulink/simulink/";
"load_system"  ,  "toolbox/simulink/simulink/";
"local_max"  ,  "toolbox/signal/signal/private/";
"locateFileInPath"  ,  "toolbox/simulink/simulink/private/";
"log_file_manager"  ,  "toolbox/stateflow/stateflow/private/";
"logcfg"  ,  "toolbox/simulink/simulink/";
"logctrlpanel"  ,  "toolbox/simulink/simulink/";
"logical2string"  ,  "toolbox/signal/sigtools/";
"logncdf"  ,  "toolbox/stats/";
"lognfit"  ,  "toolbox/stats/";
"logninv"  ,  "toolbox/stats/";
"lognlike"  ,  "toolbox/stats/";
"lognpdf"  ,  "toolbox/stats/";
"lognrnd"  ,  "toolbox/stats/";
"lognstat"  ,  "toolbox/stats/";
"logpanel"  ,  "toolbox/simulink/simulink/";
"look1_func_approx"  ,  "toolbox/simulink/blocks/private/";
"look1_func_plot"  ,  "toolbox/simulink/blocks/private/";
"look_for_corrupted_models"  ,  "toolbox/stateflow/stateflow/private/";
"lookundermask"  ,  "toolbox/simulink/simulink/";
"lookup1dddg"  ,  "toolbox/simulink/blocks/";
"lookup2dddg"  ,  "toolbox/simulink/blocks/";
"loopstruct"  ,  "toolbox/control/ctrlguis/";
"lorenzi"  ,  "toolbox/simulink/dee/";
"lowpass"  ,  "toolbox/signal/signal/private/";
"lp2bp"  ,  "toolbox/signal/signal/";
"lp2bs"  ,  "toolbox/signal/signal/";
"lp2hp"  ,  "toolbox/signal/signal/";
"lp2lp"  ,  "toolbox/signal/signal/";
"lpc"  ,  "toolbox/signal/signal/";
"lpc-ardemo"  ,  "toolbox/signal/sigdemos/";
"lproject"  ,  "toolbox/control/ctrlguis/";
"lqe"  ,  "toolbox/control/ctrlobsolete/";
"lqe2"  ,  "toolbox/control/ctrlobsolete/";
"lqed"  ,  "toolbox/control/ctrlobsolete/";
"lqew"  ,  "toolbox/control/ctrlobsolete/";
"lqg"  ,  "toolbox/robust/";
"lqr"  ,  "toolbox/control/control/";
"lqr2"  ,  "toolbox/control/ctrlobsolete/";
"lqrc"  ,  "toolbox/robust/";
"lqrd"  ,  "toolbox/control/control/";
"lqrdes"  ,  "toolbox/control/ctrldemos/";
"lqry"  ,  "toolbox/control/control/";
"lrscale"  ,  "toolbox/control/ctrlutil/";
"lsf2poly"  ,  "toolbox/signal/signal/";
"lshapeb"  ,  "toolbox/pde/";
"lshapec"  ,  "toolbox/pde/";
"lshapeg"  ,  "toolbox/pde/";
"lsim"  ,  "toolbox/control/control/";
"lsline"  ,  "toolbox/stats/";
"lsqcurvefit"  ,  "toolbox/optim/";
"lsqfcnchk"  ,  "toolbox/optim/private/";
"lsqisotonic"  ,  "toolbox/stats/private/";
"lsqlin"  ,  "toolbox/optim/";
"lsqncommon"  ,  "toolbox/optim/private/";
"lsqnonlin"  ,  "toolbox/optim/";
"lticharmenu"  ,  "toolbox/control/ctrlguis/";
"ltidemo"  ,  "toolbox/control/ctrldemos/";
"ltifr"  ,  "toolbox/control/control/";
"ltimask"  ,  "toolbox/control/control/";
"ltimodels"  ,  "toolbox/control/control/";
"ltiplot"  ,  "toolbox/control/ctrlguis/";
"ltiplotmenu"  ,  "toolbox/control/ctrlguis/";
"ltiplottypes"  ,  "toolbox/control/ctrlguis/";
"ltiprops"  ,  "toolbox/control/control/";
"ltitipmenus"  ,  "toolbox/shared/controllib/";
"ltitr"  ,  "toolbox/control/control/";
"ltiview"  ,  "toolbox/control/control/";
"ltk2"  ,  "toolbox/ident/idutils/private/";
"ltrdata1"  ,  "toolbox/robust/";
"ltrdata2"  ,  "toolbox/robust/";
"ltrdemo"  ,  "toolbox/robust/";
"ltrdes1"  ,  "toolbox/robust/";
"ltrdes2"  ,  "toolbox/robust/";
"ltru"  ,  "toolbox/robust/";
"ltry"  ,  "toolbox/robust/";
"lutbridge"  ,  "toolbox/images/images/private/";
"lutclean"  ,  "toolbox/images/images/private/";
"lutdiag"  ,  "toolbox/images/images/private/";
"lutdilate"  ,  "toolbox/images/images/private/";
"luteditorddg_cb"  ,  "toolbox/simulink/blocks/";
"luterode"  ,  "toolbox/images/images/private/";
"lutfatten"  ,  "toolbox/images/images/private/";
"lutfill"  ,  "toolbox/images/images/private/";
"luthbreak"  ,  "toolbox/images/images/private/";
"lutiso"  ,  "toolbox/images/images/private/";
"lutmajority"  ,  "toolbox/images/images/private/";
"lutper4"  ,  "toolbox/images/images/private/";
"lutper8"  ,  "toolbox/images/images/private/";
"lutremove"  ,  "toolbox/images/images/private/";
"lutshrink"  ,  "toolbox/images/images/private/";
"lutsingle"  ,  "toolbox/images/images/private/";
"lutskel1"  ,  "toolbox/images/images/private/";
"lutskel2"  ,  "toolbox/images/images/private/";
"lutskel3"  ,  "toolbox/images/images/private/";
"lutskel4"  ,  "toolbox/images/images/private/";
"lutskel5"  ,  "toolbox/images/images/private/";
"lutskel6"  ,  "toolbox/images/images/private/";
"lutskel7"  ,  "toolbox/images/images/private/";
"lutskel8"  ,  "toolbox/images/images/private/";
"lutspur"  ,  "toolbox/images/images/private/";
"lutthin1"  ,  "toolbox/images/images/private/";
"lutthin2"  ,  "toolbox/images/images/private/";
"lutthin3"  ,  "toolbox/images/images/private/";
"lutthin4"  ,  "toolbox/images/images/private/";
"lyap"  ,  "toolbox/control/control/";
"lyap2"  ,  "toolbox/control/ctrlobsolete/";
"lyapchol"  ,  "toolbox/control/control/";
"lyapkr"  ,  "toolbox/robust/";
"machine2model"  ,  "toolbox/stateflow/stateflow/private/";
"machine_bind_sflinks"  ,  "toolbox/stateflow/stateflow/private/";
"machine_shallow_find"  ,  "toolbox/stateflow/stateflow/private/";
"machineddg"  ,  "toolbox/stateflow/stateflow/private/";
"machinedlg"  ,  "toolbox/stateflow/stateflow/private/";
"mad"  ,  "toolbox/stats/";
"mag2dB"  ,  "toolbox/control/ctrlutil/";
"magballdat"  ,  "toolbox/slcontrol/slctrldemos/";
"magballinit"  ,  "toolbox/slcontrol/slctrldemos/";
"mahal"  ,  "toolbox/stats/";
"make_ansi_tfl"  ,  "toolbox/simulink/simulink/";
"make_ecoder_hook"  ,  "toolbox/rtw/rtw/";
"make_formatters"  ,  "toolbox/simulink/simcoverage/private/";
"make_gnu_tfl"  ,  "toolbox/simulink/simulink/";
"make_iso_tfl"  ,  "toolbox/simulink/simulink/";
"make_rtw"  ,  "toolbox/rtw/rtw/";
"make_targetfcnlib_mat_files"  ,  "toolbox/simulink/simulink/";
"make_tlc_only"  ,  "toolbox/rtw/rtw/";
"makecform"  ,  "toolbox/images/images/";
"makelut"  ,  "toolbox/images/images/";
"makeresampler"  ,  "toolbox/images/images/";
"maketform"  ,  "toolbox/images/images/";
"makeuniqcellstrs"  ,  "toolbox/signal/sigtools/";
"manova1"  ,  "toolbox/stats/";
"manovacluster"  ,  "toolbox/stats/";
"manswitch"  ,  "toolbox/simulink/blocks/";
"maple"  ,  "toolbox/symbolic/";
"mapleinit"  ,  "toolbox/symbolic/";
"maplemex"  ,  "toolbox/symbolic/";
"margin"  ,  "toolbox/control/control/";
"margindemo"  ,  "toolbox/control/ctrldemos/";
"margindemo_sls"  ,  "toolbox/control/ctrldemos/";
"maskedit"  ,  "toolbox/simulink/simulink/";
"maskpopups"  ,  "toolbox/simulink/simulink/";
"masksync"  ,  "toolbox/simulink/simulink/private/";
"masspg"  ,  "toolbox/simulink/dee/";
"masspgi"  ,  "toolbox/simulink/dee/";
"mat2gray"  ,  "toolbox/images/images/";
"matchlsq"  ,  "toolbox/control/ctrlguis/";
"matq2ws"  ,  "toolbox/pde/private/";
"matqdlg"  ,  "toolbox/pde/private/";
"matqparse"  ,  "toolbox/pde/private/";
"matqueue"  ,  "toolbox/pde/private/";
"matrxcatmask"  ,  "toolbox/simulink/blocks/";
"maxflat"  ,  "toolbox/signal/signal/";
"mcodeutils"  ,  "toolbox/signal/sigtools/";
"md2c"  ,  "toolbox/ident/idutils/";
"mdlRefDepsComment"  ,  "toolbox/simulink/simulink/private/";
"mdldisc_demo"  ,  "toolbox/simulink/simdemos/simfeatures/";
"mdlref_basicscript"  ,  "toolbox/simulink/simdemos/simfeatures/mdlref/";
"mdlref_busscript"  ,  "toolbox/simulink/simdemos/simfeatures/mdlref/";
"mdlref_conversionscript"  ,  "toolbox/simulink/simdemos/simfeatures/mdlref/";
"mdlref_depgraph_demo"  ,  "toolbox/simulink/simdemos/simfeatures/mdlref/";
"mdlref_paramargsscript"  ,  "toolbox/simulink/simdemos/simfeatures/mdlref/";
"mdlrefddg_cb"  ,  "toolbox/simulink/simulink/";
"mdscale"  ,  "toolbox/stats/";
"mdscaledemo"  ,  "toolbox/stats/";
"mean2"  ,  "toolbox/images/images/";
"meansgraph"  ,  "toolbox/stats/";
"medfilt1"  ,  "toolbox/signal/signal/";
"medfilt2"  ,  "toolbox/images/images/";
"merge"  ,  "toolbox/signal/sptoolgui/private/";
"mergedemoscript"  ,  "toolbox/simulink/simdemos/simfeatures/";
"mergefcn"  ,  "toolbox/simulink/simdemos/simfeatures/";
"mex_setup"  ,  "toolbox/stateflow/stateflow/private/";
"mex_sfun_user_fxp_examples"  ,  "toolbox/simulink/fixedandfloat/fxpdemos/";
"mf2th"  ,  "toolbox/ident/idobsolete/";
"mfun"  ,  "toolbox/symbolic/";
"mfunlist"  ,  "toolbox/symbolic/";
"mgrp2idx"  ,  "toolbox/stats/private/";
"mhelp"  ,  "toolbox/symbolic/";
"midprefs"  ,  "toolbox/ident/idguis/";
"milldemo"  ,  "toolbox/control/ctrldemos/";
"milldemo_sls"  ,  "toolbox/control/ctrldemos/";
"mimofr"  ,  "toolbox/control/control/";
"min4termwin"  ,  "toolbox/signal/signal/private/";
"miniplot"  ,  "toolbox/control/ctrlobsolete/";
"minlin"  ,  "toolbox/simulink/simulink/";
"minloop"  ,  "toolbox/ident/idutils/";
"minreal"  ,  "toolbox/control/control/";
"misdata"  ,  "toolbox/ident/ident/";
"mixedalg"  ,  "toolbox/robust/";
"mixedm"  ,  "toolbox/simulink/blocks/";
"mkargs"  ,  "toolbox/robust/";
"mkargs1"  ,  "toolbox/robust/";
"mkargs5x"  ,  "toolbox/robust/";
"mkconstarray"  ,  "toolbox/images/images/private/";
"mklti"  ,  "toolbox/robust/private/";
"mksys"  ,  "toolbox/robust/";
"mktito"  ,  "toolbox/robust/private/";
"ml_type"  ,  "toolbox/stateflow/stateflow/private/";
"mle"  ,  "toolbox/stats/";
"mlecov"  ,  "toolbox/stats/";
"mlecustom"  ,  "toolbox/stats/private/";
"mlscript_ui"  ,  "toolbox/simulink/simulink/";
"mltrdemo"  ,  "toolbox/robust/";
"mmole"  ,  "toolbox/optim/";
"moddemo"  ,  "toolbox/signal/sigdemos/";
"model2machine"  ,  "toolbox/shared/dastudio/";
"modeladvisor"  ,  "toolbox/simulink/simulink/";
"modelassistant"  ,  "toolbox/simulink/simulink/";
"modelddg"  ,  "toolbox/simulink/simulink/";
"modelddg_file_cb"  ,  "toolbox/simulink/simulink/";
"modelddg_readOnly_cb"  ,  "toolbox/simulink/simulink/";
"modeldeps"  ,  "toolbox/simulink/simulink/private/";
"modelref_conversion_bus_utils"  ,  "toolbox/simulink/simulink/private/";
"modelref_conversion_utilities"  ,  "toolbox/simulink/simulink/private/";
"modelrefsiglog"  ,  "toolbox/simulink/simulink/";
"modelrefsim_default_tmf"  ,  "toolbox/rtw/rtw/";
"modreal"  ,  "toolbox/robust/";
"modred"  ,  "toolbox/control/control/";
"modstruc"  ,  "toolbox/ident/idutils/";
"modulate"  ,  "toolbox/signal/signal/";
"molecule"  ,  "toolbox/optim/";
"moment"  ,  "toolbox/stats/";
"montage"  ,  "toolbox/images/images/";
"morphop"  ,  "toolbox/images/images/private/";
"motor"  ,  "toolbox/ident/ident/";
"movemask"  ,  "toolbox/simulink/simulink/";
"moveptr"  ,  "toolbox/control/ctrlguis/";
"mpt_get_data_types"  ,  "toolbox/simulink/simulink/";
"mrdemo"  ,  "toolbox/robust/";
"mrgfocus"  ,  "toolbox/control/ctrlutil/";
"mrgios"  ,  "toolbox/control/ctrlguis/";
"mroots"  ,  "toolbox/control/ctrlutil/";
"ms2th"  ,  "toolbox/ident/idobsolete/";
"mscohere"  ,  "toolbox/signal/signal/";
"msearch"  ,  "toolbox/ident/idutils/";
"msfuntmpl"  ,  "toolbox/simulink/blocks/";
"mskeddlg"  ,  "toolbox/simulink/simulink/";
"mskedpg"  ,  "toolbox/simulink/simulink/private/";
"mu2lti"  ,  "toolbox/robust/private/";
"mudemo"  ,  "toolbox/robust/";
"mudemo1"  ,  "toolbox/robust/";
"mueva"  ,  "toolbox/robust/";
"mulerr"  ,  "toolbox/robust/";
"mulresp"  ,  "toolbox/control/ctrlobsolete/";
"multcompare"  ,  "toolbox/stats/";
"multiband"  ,  "toolbox/signal/signal/private/";
"multidat"  ,  "toolbox/simulink/simdemos/";
"muopt"  ,  "toolbox/robust/";
"muoptold"  ,  "toolbox/robust/";
"muplt"  ,  "toolbox/robust/";
"music"  ,  "toolbox/signal/signal/private/";
"musldemo"  ,  "toolbox/robust/";
"musol4"  ,  "toolbox/robust/";
"musyn"  ,  "toolbox/robust/";
"muxwidths"  ,  "toolbox/stateflow/stateflow/private/";
"mvnpdf"  ,  "toolbox/stats/";
"mvnrnd"  ,  "toolbox/stats/";
"mvplotdemo"  ,  "toolbox/stats/";
"mvtrnd"  ,  "toolbox/stats/";
"mx2str"  ,  "toolbox/stateflow/stateflow/private/";
"n4sid"  ,  "toolbox/ident/ident/";
"n4sid_f"  ,  "toolbox/ident/ident/";
"nanmax"  ,  "toolbox/stats/";
"nanmean"  ,  "toolbox/stats/";
"nanmedian"  ,  "toolbox/stats/";
"nanmin"  ,  "toolbox/stats/";
"nanstd"  ,  "toolbox/stats/";
"nanstruc"  ,  "toolbox/ident/idutils/";
"nansum"  ,  "toolbox/stats/";
"nanvar"  ,  "toolbox/stats/";
"nbincdf"  ,  "toolbox/stats/";
"nbinfit"  ,  "toolbox/stats/";
"nbininv"  ,  "toolbox/stats/";
"nbinlike"  ,  "toolbox/stats/";
"nbinpdf"  ,  "toolbox/stats/";
"nbinrnd"  ,  "toolbox/stats/";
"nbinstat"  ,  "toolbox/stats/";
"ncdglob"  ,  "toolbox/sloptim/sloptobsolete/";
"ncdupdate"  ,  "toolbox/sloptim/sloptobsolete/";
"ncfcdf"  ,  "toolbox/stats/";
"ncfinv"  ,  "toolbox/stats/";
"ncfpdf"  ,  "toolbox/stats/";
"ncfrnd"  ,  "toolbox/stats/";
"ncfstat"  ,  "toolbox/stats/";
"nctcdf"  ,  "toolbox/stats/";
"nctinv"  ,  "toolbox/stats/";
"nctpdf"  ,  "toolbox/stats/";
"nctrnd"  ,  "toolbox/stats/";
"nctstat"  ,  "toolbox/stats/";
"ncx2cdf"  ,  "toolbox/stats/";
"ncx2inv"  ,  "toolbox/stats/";
"ncx2pdf"  ,  "toolbox/stats/";
"ncx2rnd"  ,  "toolbox/stats/";
"ncx2stat"  ,  "toolbox/stats/";
"nddirectico"  ,  "toolbox/simulink/blocks/";
"ndlookico"  ,  "toolbox/simulink/blocks/";
"new_data"  ,  "toolbox/stateflow/stateflow/private/";
"new_event"  ,  "toolbox/stateflow/stateflow/private/";
"new_rtw_interface_marker"  ,  "toolbox/stateflow/coder/private/";
"new_state_output_data"  ,  "toolbox/stateflow/stateflow/private/";
"new_system"  ,  "toolbox/simulink/simulink/";
"new_target"  ,  "toolbox/stateflow/stateflow/private/";
"newknt"  ,  "toolbox/splines/";
"newsro"  ,  "toolbox/sloptim/sloptim/";
"nextcolor"  ,  "toolbox/signal/sptoolgui/private/";
"ngrid"  ,  "toolbox/control/control/";
"nicchart"  ,  "toolbox/control/ctrlguis/";
"nice_shot"  ,  "toolbox/stateflow/stateflow/private/";
"nichols"  ,  "toolbox/control/control/";
"niclims"  ,  "toolbox/control/ctrlguis/";
"nlconst"  ,  "toolbox/optim/private/";
"nlconst"  ,  "toolbox/simulink/simulink/private/";
"nlfilter"  ,  "toolbox/images/images/";
"nlinfit"  ,  "toolbox/stats/";
"nlinopt"  ,  "toolbox/sloptim/sloptobsolete/";
"nlintool"  ,  "toolbox/stats/";
"nlparci"  ,  "toolbox/stats/";
"nlpredci"  ,  "toolbox/stats/";
"nls3"  ,  "toolbox/optim/";
"nlsf1"  ,  "toolbox/optim/";
"nlsf1a"  ,  "toolbox/optim/";
"nlsf3a"  ,  "toolbox/optim/";
"nlsmm3"  ,  "toolbox/optim/";
"nlsq"  ,  "toolbox/optim/private/";
"nnsearch"  ,  "toolbox/images/images/private/";
"noiprefi"  ,  "toolbox/ident/idutils/";
"non_empty_subcharts_in"  ,  "toolbox/stateflow/stateflow/private/";
"normcdf"  ,  "toolbox/stats/";
"normfit"  ,  "toolbox/stats/";
"normh2"  ,  "toolbox/robust/";
"normhinf"  ,  "toolbox/robust/";
"norminv"  ,  "toolbox/stats/";
"normlike"  ,  "toolbox/stats/";
"normpdf"  ,  "toolbox/stats/";
"normplot"  ,  "toolbox/stats/";
"normrnd"  ,  "toolbox/stats/";
"normspec"  ,  "toolbox/stats/";
"normstat"  ,  "toolbox/stats/";
"normxcorr2"  ,  "toolbox/images/images/";
"notbool"  ,  "toolbox/simulink/simulink/private/";
"notchdemo"  ,  "toolbox/control/ctrldemos/";
"notchdemo_sls"  ,  "toolbox/control/ctrldemos/";
"nrfiltdemo"  ,  "toolbox/images/imdemos/";
"ntsc2rgb"  ,  "toolbox/images/images/";
"nuderst"  ,  "toolbox/ident/idutils/";
"num2fix"  ,  "toolbox/simulink/fixedandfloat/";
"num2fixpt"  ,  "toolbox/simulink/fixedandfloat/";
"num2ordinal"  ,  "toolbox/images/images/private/";
"numdemo"  ,  "toolbox/control/ctrldemos/";
"numerictypeddg"  ,  "toolbox/simulink/simulink/";
"nuttallwin"  ,  "toolbox/signal/signal/";
"nyqaux"  ,  "toolbox/ident/idutils/";
"nyqchart"  ,  "toolbox/control/ctrlguis/";
"nyqplot"  ,  "toolbox/ident/idobsolete/";
"nyquist"  ,  "toolbox/control/control/";
"obalreal"  ,  "toolbox/robust/";
"object_limits"  ,  "toolbox/stateflow/stateflow/private/";
"objfun"  ,  "toolbox/optim/";
"objfungrad"  ,  "toolbox/optim/";
"obsv"  ,  "toolbox/control/control/";
"obsvf"  ,  "toolbox/control/control/";
"oe"  ,  "toolbox/ident/ident/";
"oestab"  ,  "toolbox/ident/idutils/";
"officeassign"  ,  "toolbox/optim/";
"ohkapp"  ,  "toolbox/robust/";
"ohkdemo"  ,  "toolbox/robust/";
"ohklmr"  ,  "toolbox/robust/";
"on2off"  ,  "toolbox/stats/private/";
"onoff"  ,  "toolbox/simulink/simulink/private/";
"onoffdemocontrol"  ,  "toolbox/simulink/simdemos/aerospace/";
"opamp"  ,  "toolbox/control/ctrldemos/private/";
"opampdemo"  ,  "toolbox/control/ctrldemos/";
"opampdemo_aux"  ,  "toolbox/control/ctrldemos/";
"open_system"  ,  "toolbox/simulink/simulink/";
"open_target_dialog"  ,  "toolbox/stateflow/sfdemos/";
"operpoint"  ,  "toolbox/shared/slcontrollib/";
"operspec"  ,  "toolbox/shared/slcontrollib/";
"optblock"  ,  "toolbox/sloptim/sloptobsolete/";
"optdeblur"  ,  "toolbox/optim/";
"opteval"  ,  "toolbox/simulink/simulink/private/";
"optimfcnchk"  ,  "toolbox/shared/optimlib/";
"optimoptioncheckfield"  ,  "toolbox/shared/optimlib/";
"optimoptiongetfields"  ,  "toolbox/shared/optimlib/";
"optimoptions"  ,  "toolbox/shared/optimlib/";
"optknt"  ,  "toolbox/splines/";
"optsiminit"  ,  "toolbox/optim/";
"ord2"  ,  "toolbox/control/control/";
"ordered_unique_paths"  ,  "toolbox/stateflow/stateflow/private/";
"ordfilt2"  ,  "toolbox/images/images/";
"ortc"  ,  "toolbox/robust/";
"ortr"  ,  "toolbox/robust/";
"osborne"  ,  "toolbox/robust/";
"otf2psf"  ,  "toolbox/images/images/";
"padarray"  ,  "toolbox/images/images/";
"pade"  ,  "toolbox/control/control/";
"padess"  ,  "toolbox/simulink/simulink/";
"padlength"  ,  "toolbox/images/images/private/";
"pandown"  ,  "toolbox/signal/sptoolgui/private/";
"panfcn"  ,  "toolbox/signal/sptoolgui/";
"panner"  ,  "toolbox/signal/sptoolgui/private/";
"para2fan"  ,  "toolbox/images/images/";
"parabolic"  ,  "toolbox/pde/";
"parallel"  ,  "toolbox/control/control/";
"parallelcoords"  ,  "toolbox/stats/";
"parameterdlg"  ,  "toolbox/signal/sigtools/";
"parproc"  ,  "toolbox/ident/idutils/";
"parseLibCodePaneText"  ,  "toolbox/simulink/simulink/private/";
"parse_error_msg"  ,  "toolbox/stateflow/stateflow/private/";
"parse_formatter_strings"  ,  "toolbox/simulink/simcoverage/private/";
"parse_kernel"  ,  "toolbox/stateflow/stateflow/private/";
"parse_pv_pairs"  ,  "toolbox/signal/signal/private/";
"parse_this"  ,  "toolbox/stateflow/stateflow/private/";
"parseit"  ,  "toolbox/simulink/dee/";
"parser_unresolved_symbol"  ,  "toolbox/stateflow/stateflow/private/";
"parzenwin"  ,  "toolbox/signal/signal/";
"pathdef"  ,  "toolbox/local/";
"pathdef"  ,  "toolbox/local/template/";
"pburg"  ,  "toolbox/signal/signal/";
"pcacov"  ,  "toolbox/stats/";
"pcares"  ,  "toolbox/stats/";
"pceye"  ,  "toolbox/optim/";
"pcgr"  ,  "toolbox/optim/private/";
"pckkntdm"  ,  "toolbox/splines/";
"pcov"  ,  "toolbox/signal/signal/";
"pdeadgsc"  ,  "toolbox/pde/";
"pdeadworst"  ,  "toolbox/pde/";
"pdearcl"  ,  "toolbox/pde/";
"pdeasma"  ,  "toolbox/pde/";
"pdeasmc"  ,  "toolbox/pde/";
"pdeasmf"  ,  "toolbox/pde/";
"pdebasnm"  ,  "toolbox/pde/";
"pdebddlg"  ,  "toolbox/pde/";
"pdebddsp"  ,  "toolbox/pde/";
"pdebound"  ,  "toolbox/pde/";
"pdebsplit"  ,  "toolbox/pde/";
"pdecchk"  ,  "toolbox/pde/";
"pdecgrad"  ,  "toolbox/pde/";
"pdecirc"  ,  "toolbox/pde/";
"pdecont"  ,  "toolbox/pde/";
"pdecrcum"  ,  "toolbox/pde/";
"pdedemo1"  ,  "toolbox/pde/";
"pdedemo2"  ,  "toolbox/pde/";
"pdedemo3"  ,  "toolbox/pde/";
"pdedemo4"  ,  "toolbox/pde/";
"pdedemo5"  ,  "toolbox/pde/";
"pdedemo6"  ,  "toolbox/pde/";
"pdedemo7"  ,  "toolbox/pde/";
"pdedemo8"  ,  "toolbox/pde/";
"pdedemos"  ,  "toolbox/pde/";
"pdedistr"  ,  "toolbox/pde/";
"pdedlg"  ,  "toolbox/pde/";
"pdeeexpd"  ,  "toolbox/pde/";
"pdeefxpd"  ,  "toolbox/pde/";
"pdeeig"  ,  "toolbox/pde/";
"pdeeigx"  ,  "toolbox/pde/";
"pdeellip"  ,  "toolbox/pde/";
"pdeent"  ,  "toolbox/pde/";
"pdeexpd"  ,  "toolbox/pde/";
"pdeframe"  ,  "toolbox/pde/";
"pdegeom"  ,  "toolbox/pde/";
"pdegplot"  ,  "toolbox/pde/";
"pdegrad"  ,  "toolbox/pde/";
"pdegrmsc"  ,  "toolbox/pde/";
"pdehelp"  ,  "toolbox/pde/";
"pdehloc"  ,  "toolbox/pde/";
"pdehypdf"  ,  "toolbox/pde/";
"pdehypf"  ,  "toolbox/pde/";
"pdehypm"  ,  "toolbox/pde/";
"pdeicon"  ,  "toolbox/pde/";
"pdeigeom"  ,  "toolbox/pde/";
"pdeinfclk"  ,  "toolbox/pde/";
"pdeinfo"  ,  "toolbox/pde/";
"pdeinit"  ,  "toolbox/pde/";
"pdeintrn"  ,  "toolbox/pde/";
"pdeintrp"  ,  "toolbox/pde/";
"pdeisfunc"  ,  "toolbox/pde/";
"pdeisusd"  ,  "toolbox/pde/";
"pdejmps"  ,  "toolbox/pde/";
"pdel2fau"  ,  "toolbox/pde/";
"pdemdlcv"  ,  "toolbox/pde/";
"pdemesh"  ,  "toolbox/pde/";
"pdemgeom"  ,  "toolbox/pde/";
"pdemhdlg"  ,  "toolbox/pde/";
"pdemtncb"  ,  "toolbox/pde/";
"pdemvdlg"  ,  "toolbox/pde/";
"pdenanmn"  ,  "toolbox/pde/";
"pdenanmx"  ,  "toolbox/pde/";
"pdenonlin"  ,  "toolbox/pde/";
"pdenrmfl"  ,  "toolbox/pde/";
"pdenullorth"  ,  "toolbox/pde/";
"pdeobdlg"  ,  "toolbox/pde/";
"pdeonax"  ,  "toolbox/pde/";
"pdeoutfun"  ,  "toolbox/pde/";
"pdepatch"  ,  "toolbox/pde/";
"pdeplot"  ,  "toolbox/pde/";
"pdepoly"  ,  "toolbox/pde/";
"pdeprbdf"  ,  "toolbox/pde/";
"pdeprbf"  ,  "toolbox/pde/";
"pdeprbm"  ,  "toolbox/pde/";
"pdeprtni"  ,  "toolbox/pde/";
"pdepsdlg"  ,  "toolbox/pde/";
"pdeptdata"  ,  "toolbox/pde/";
"pdeptdlg"  ,  "toolbox/pde/";
"pdequote"  ,  "toolbox/pde/";
"pderect"  ,  "toolbox/pde/";
"pderel"  ,  "toolbox/pde/";
"pderesid"  ,  "toolbox/pde/";
"pderespe"  ,  "toolbox/pde/";
"pdermpnt"  ,  "toolbox/pde/";
"pderot3d"  ,  "toolbox/pde/";
"pdertdlg"  ,  "toolbox/pde/";
"pdesde"  ,  "toolbox/pde/";
"pdesdp"  ,  "toolbox/pde/";
"pdesdt"  ,  "toolbox/pde/";
"pdeselect"  ,  "toolbox/pde/";
"pdesetbd"  ,  "toolbox/pde/";
"pdeseteq"  ,  "toolbox/pde/";
"pdesetlb"  ,  "toolbox/pde/";
"pdesldlg"  ,  "toolbox/pde/";
"pdesmech"  ,  "toolbox/pde/";
"pdesnap"  ,  "toolbox/pde/";
"pdespdlg"  ,  "toolbox/pde/";
"pdesubix"  ,  "toolbox/pde/";
"pdesurf"  ,  "toolbox/pde/";
"pdet2str"  ,  "toolbox/pde/";
"pdetexpd"  ,  "toolbox/pde/";
"pdetfxpd"  ,  "toolbox/pde/";
"pdetool"  ,  "toolbox/pde/";
"pdetrans"  ,  "toolbox/pde/";
"pdetrdlg"  ,  "toolbox/pde/";
"pdetrg"  ,  "toolbox/pde/";
"pdetridi"  ,  "toolbox/pde/";
"pdetriq"  ,  "toolbox/pde/";
"pdetxpd"  ,  "toolbox/pde/";
"pdeuxpd"  ,  "toolbox/pde/";
"pdevoron"  ,  "toolbox/pde/";
"pdezoom"  ,  "toolbox/pde/";
"pdf"  ,  "toolbox/stats/";
"pdist"  ,  "toolbox/stats/";
"pe"  ,  "toolbox/ident/ident/";
"pe_f"  ,  "toolbox/ident/idutils/";
"pe_fp"  ,  "toolbox/ident/idutils/";
"pefilt"  ,  "toolbox/ident/idutils/private/";
"peig"  ,  "toolbox/signal/signal/";
"pem"  ,  "toolbox/ident/ident/";
"pemdecod"  ,  "toolbox/ident/idutils/";
"pemdecod_fp"  ,  "toolbox/ident/idutils/";
"pendan"  ,  "toolbox/simulink/simdemos/simgeneral/";
"periodogram"  ,  "toolbox/signal/signal/";
"perpxy"  ,  "toolbox/control/ctrlobsolete/";
"perron"  ,  "toolbox/robust/";
"perturb"  ,  "toolbox/optim/private/";
"phantom"  ,  "toolbox/images/images/";
"phase"  ,  "toolbox/ident/idobsolete/";
"phasedelay"  ,  "toolbox/signal/signal/";
"phaseticks"  ,  "toolbox/control/ctrlguis/";
"phasez"  ,  "toolbox/signal/signal/";
"phone"  ,  "toolbox/signal/sigdemos/";
"pickfcn"  ,  "toolbox/signal/sptoolgui/private/";
"pinrect"  ,  "toolbox/signal/sptoolgui/private/";
"pixval"  ,  "toolbox/images/images/";
"place"  ,  "toolbox/control/control/";
"placetitlebar"  ,  "toolbox/stats/private/";
"plotbode"  ,  "toolbox/control/ctrlobsolete/";
"plotdatapoints"  ,  "toolbox/optim/";
"plotnic"  ,  "toolbox/control/ctrlobsolete/";
"plotnyq"  ,  "toolbox/control/ctrlobsolete/";
"pltopt"  ,  "toolbox/robust/";
"pmatchm"  ,  "toolbox/ident/idutils/";
"pmcov"  ,  "toolbox/signal/signal/";
"pmem"  ,  "toolbox/signal/signal/";
"pmtm"  ,  "toolbox/signal/signal/";
"pmusic"  ,  "toolbox/signal/signal/";
"pnam2num"  ,  "toolbox/ident/idutils/";
"pndanim1"  ,  "toolbox/simulink/simdemos/simgeneral/";
"pndanim2"  ,  "toolbox/simulink/simdemos/simgeneral/";
"pndanim3"  ,  "toolbox/simulink/simdemos/simgeneral/";
"pnmatch"  ,  "toolbox/ident/idutils/";
"pnmatch"  ,  "toolbox/control/ctrlutil/";
"pnmatchd"  ,  "toolbox/ident/idutils/";
"pnsortd"  ,  "toolbox/ident/idutils/";
"poiasma"  ,  "toolbox/pde/";
"poicalc"  ,  "toolbox/pde/";
"poiindex"  ,  "toolbox/pde/";
"poimesh"  ,  "toolbox/pde/";
"pointtip"  ,  "toolbox/shared/controllib/";
"poisolv"  ,  "toolbox/pde/";
"poisscdf"  ,  "toolbox/stats/";
"poissfit"  ,  "toolbox/stats/";
"poissinv"  ,  "toolbox/stats/";
"poisspdf"  ,  "toolbox/stats/";
"poissrnd"  ,  "toolbox/stats/";
"poisstat"  ,  "toolbox/stats/";
"poly2ac"  ,  "toolbox/signal/signal/";
"poly2edgelist"  ,  "toolbox/images/images/private/";
"poly2lsf"  ,  "toolbox/signal/signal/";
"poly2mask"  ,  "toolbox/images/images/";
"poly2rc"  ,  "toolbox/signal/signal/";
"poly2str"  ,  "toolbox/control/ctrlobsolete/";
"poly2sym"  ,  "toolbox/symbolic/";
"poly2th"  ,  "toolbox/ident/idobsolete/";
"polyconf"  ,  "toolbox/stats/";
"polyform"  ,  "toolbox/ident/idobsolete/";
"polyscale"  ,  "toolbox/signal/signal/";
"polystab"  ,  "toolbox/signal/signal/";
"polytool"  ,  "toolbox/stats/";
"popdemo"  ,  "toolbox/simulink/simdemos/";
"port"  ,  "toolbox/control/ctrldemos/private/";
"powerwindow02script"  ,  "toolbox/simulink/simdemos/automotive/";
"powerwindow03script"  ,  "toolbox/simulink/simdemos/automotive/";
"powerwindow04script"  ,  "toolbox/simulink/simdemos/automotive/";
"powerwindow05script"  ,  "toolbox/simulink/simdemos/automotive/";
"powerwindowscript"  ,  "toolbox/simulink/simdemos/automotive/";
"pp2sp"  ,  "toolbox/splines/";
"ppalldem"  ,  "toolbox/splines/";
"ppbrk"  ,  "toolbox/splines/";
"ppcgr"  ,  "toolbox/optim/private/";
"ppmak"  ,  "toolbox/splines/";
"pprfn"  ,  "toolbox/splines/";
"ppual"  ,  "toolbox/splines/";
"prctile"  ,  "toolbox/stats/";
"preaug"  ,  "toolbox/optim/private/";
"predict"  ,  "toolbox/ident/ident/";
"prefcnchk"  ,  "toolbox/simulink/simulink/private/";
"prefspanel"  ,  "toolbox/signal/signal/";
"preload_diff"  ,  "toolbox/simulink/fixedandfloat/fxpdemos/";
"preload_feedback"  ,  "toolbox/simulink/fixedandfloat/fxpdemos/";
"preload_integrate"  ,  "toolbox/simulink/fixedandfloat/fxpdemos/";
"preload_lead_lag"  ,  "toolbox/simulink/fixedandfloat/fxpdemos/";
"preload_state_space"  ,  "toolbox/simulink/fixedandfloat/fxpdemos/";
"preprocess_truth_table"  ,  "toolbox/stateflow/stateflow/private/";
"present"  ,  "toolbox/ident/idobsolete/";
"princomp"  ,  "toolbox/stats/";
"print_html_str"  ,  "toolbox/stateflow/stateflow/private/";
"printcomp"  ,  "toolbox/signal/sptoolgui/";
"printdamp"  ,  "toolbox/control/ctrlutil/";
"printframe"  ,  "toolbox/simulink/simulink/";
"printmat"  ,  "toolbox/control/ctrlobsolete/";
"printofficeassign"  ,  "toolbox/optim/";
"printopt"  ,  "toolbox/local/";
"printsys"  ,  "toolbox/control/ctrlobsolete/";
"printtext"  ,  "toolbox/simulink/simulink/private/";
"private_sl_decpath"  ,  "toolbox/simulink/simulink/";
"private_sl_enc2normalpath"  ,  "toolbox/simulink/simulink/";
"private_sl_encpath"  ,  "toolbox/simulink/simulink/";
"prm_disp_cntrl"  ,  "toolbox/rtw/rtw/";
"probplot"  ,  "toolbox/stats/";
"procmod"  ,  "toolbox/ident/idutils/";
"procrustes"  ,  "toolbox/stats/";
"project"  ,  "toolbox/optim/private/";
"prony"  ,  "toolbox/signal/signal/";
"psd"  ,  "toolbox/signal/signal/";
"psdchk"  ,  "toolbox/signal/signal/private/";
"psddemo"  ,  "toolbox/signal/sigdemos/";
"psdfreqvec"  ,  "toolbox/signal/signal/";
"psdoptions"  ,  "toolbox/signal/signal/";
"psdplot"  ,  "toolbox/signal/signal/";
"psf2otf"  ,  "toolbox/images/images/";
"psv"  ,  "toolbox/robust/";
"pulstran"  ,  "toolbox/signal/signal/";
"pvformat"  ,  "toolbox/control/ctrlutil/";
"pwelch"  ,  "toolbox/signal/signal/";
"pyulear"  ,  "toolbox/signal/signal/";
"pzmap"  ,  "toolbox/control/control/";
"qfilt2dfilt"  ,  "toolbox/signal/sigtools/";
"qfiltexists"  ,  "toolbox/signal/sigtools/";
"qpsub"  ,  "toolbox/optim/private/";
"qpsub"  ,  "toolbox/simulink/simulink/private/";
"qqplot"  ,  "toolbox/stats/";
"qtdecomp"  ,  "toolbox/images/images/";
"qtdemo"  ,  "toolbox/images/imdemos/";
"qtgetblk"  ,  "toolbox/images/images/";
"qtsetblk"  ,  "toolbox/images/images/";
"quad2"  ,  "toolbox/optim/";
"quadi"  ,  "toolbox/optim/";
"quadprog"  ,  "toolbox/optim/";
"quantile"  ,  "toolbox/stats/";
"quantize"  ,  "toolbox/simulink/blocks/";
"quine_mcclusky"  ,  "toolbox/stateflow/stateflow/private/";
"radon"  ,  "toolbox/images/images/";
"radonc"  ,  "toolbox/images/images/private/";
"randg"  ,  "toolbox/stats/";
"random"  ,  "toolbox/stats/";
"randsample"  ,  "toolbox/stats/";
"randtool"  ,  "toolbox/stats/";
"randunc"  ,  "toolbox/sloptim/sloptim/";
"range"  ,  "toolbox/stats/";
"ranksum"  ,  "toolbox/stats/";
"rarmax"  ,  "toolbox/ident/ident/";
"rarx"  ,  "toolbox/ident/ident/";
"raylcdf"  ,  "toolbox/stats/";
"raylfit"  ,  "toolbox/stats/";
"raylinv"  ,  "toolbox/stats/";
"raylpdf"  ,  "toolbox/stats/";
"raylrnd"  ,  "toolbox/stats/";
"raylstat"  ,  "toolbox/stats/";
"rbj"  ,  "toolbox/ident/ident/";
"rc2ac"  ,  "toolbox/signal/signal/";
"rc2is"  ,  "toolbox/signal/signal/";
"rc2lar"  ,  "toolbox/signal/signal/";
"rc2poly"  ,  "toolbox/signal/signal/";
"rceps"  ,  "toolbox/signal/signal/";
"rcoplot"  ,  "toolbox/stats/";
"rct2lti"  ,  "toolbox/robust/";
"rctdemo"  ,  "toolbox/robust/";
"rctdemo1"  ,  "toolbox/robust/";
"rdsigma"  ,  "toolbox/robust/";
"readstdtcdata"  ,  "toolbox/simulink/simdemos/simfeatures/";
"reconcile_function_io"  ,  "toolbox/stateflow/stateflow/private/";
"rectconv"  ,  "toolbox/simulink/simulink/private/";
"rectpuls"  ,  "toolbox/signal/signal/";
"rectwin"  ,  "toolbox/signal/signal/";
"refcurve"  ,  "toolbox/stats/";
"refinemesh"  ,  "toolbox/pde/";
"reflect"  ,  "toolbox/optim/private/";
"refline"  ,  "toolbox/stats/";
"reg"  ,  "toolbox/control/control/";
"regionprops"  ,  "toolbox/images/images/";
"regress"  ,  "toolbox/stats/";
"regstats"  ,  "toolbox/stats/";
"reig"  ,  "toolbox/robust/";
"rel_path"  ,  "toolbox/stateflow/stateflow/private/";
"release_version"  ,  "toolbox/rtw/rtw/";
"remdemo"  ,  "toolbox/robust/";
"remez"  ,  "toolbox/signal/signal/";
"remezord"  ,  "toolbox/signal/signal/";
"removeampersands"  ,  "toolbox/signal/sigtools/private/";
"removetrailzeros"  ,  "toolbox/signal/sigtools/";
"remstr"  ,  "toolbox/signal/sptoolgui/private/";
"render_cshelpbtn"  ,  "toolbox/signal/sigtools/";
"render_gridonoffbtn"  ,  "toolbox/signal/sigtools/";
"render_hiddenzoombtns"  ,  "toolbox/signal/sigtools/private/";
"render_legendonoffbtn"  ,  "toolbox/signal/sigtools/";
"render_spteditmenu"  ,  "toolbox/signal/sigtools/";
"render_sptfilemenu"  ,  "toolbox/signal/sigtools/";
"render_spthelpmenu"  ,  "toolbox/signal/sigtools/";
"render_sptinsertmenu"  ,  "toolbox/signal/sigtools/";
"render_sptprintbtns"  ,  "toolbox/signal/sigtools/";
"render_sptscribebtns"  ,  "toolbox/signal/sigtools/";
"render_spttoolsmenu"  ,  "toolbox/signal/sigtools/";
"render_sptwindowmenu"  ,  "toolbox/signal/sigtools/";
"render_statusbar"  ,  "toolbox/signal/sigtools/";
"render_zoombtns"  ,  "toolbox/signal/sigtools/";
"render_zoommenus"  ,  "toolbox/signal/sigtools/";
"reorderstructure"  ,  "toolbox/signal/sigtools/";
"replace_block"  ,  "toolbox/simulink/simulink/";
"resample"  ,  "toolbox/signal/signal/";
"resetPropertyFactoryValue"  ,  "toolbox/shared/dastudio/";
"reset_target_code_flags"  ,  "toolbox/stateflow/stateflow/private/";
"resetaxes"  ,  "toolbox/signal/sigtools/private/";
"reshapemask"  ,  "toolbox/simulink/blocks/";
"resid"  ,  "toolbox/ident/idobsolete/";
"residuez"  ,  "toolbox/signal/signal/";
"resistor"  ,  "toolbox/control/ctrldemos/private/";
"resizedispatch"  ,  "toolbox/signal/sptoolgui/private/";
"respdemo"  ,  "toolbox/control/ctrldemos/";
"restorePrm"  ,  "toolbox/simulink/simulink/private/";
"restoredefaultpath"  ,  "toolbox/local/";
"revertit"  ,  "toolbox/simulink/dee/";
"rfinputs"  ,  "toolbox/control/ctrlguis/";
"rg"  ,  "toolbox/stateflow/stateflow/private/";
"rg_dialog"  ,  "toolbox/stateflow/stateflow/private/";
"rg_nice_shot"  ,  "toolbox/stateflow/stateflow/private/";
"rg_printbook_cant_handle_chart"  ,  "toolbox/stateflow/stateflow/private/";
"rgb2gray"  ,  "toolbox/images/images/";
"rgb2ind"  ,  "toolbox/images/images/";
"rgb2ntsc"  ,  "toolbox/images/images/";
"rgb2ycbcr"  ,  "toolbox/images/images/";
"rguipopts"  ,  "toolbox/control/ctrlguis/";
"ric"  ,  "toolbox/control/ctrlobsolete/";
"riccond"  ,  "toolbox/robust/";
"ridge"  ,  "toolbox/stats/";
"rk23"  ,  "toolbox/simulink/simulink/";
"rk45"  ,  "toolbox/simulink/simulink/";
"rlcdemo"  ,  "toolbox/control/ctrldemos/";
"rlevinson"  ,  "toolbox/signal/signal/";
"rlocfind"  ,  "toolbox/control/control/";
"rloclims"  ,  "toolbox/control/ctrlguis/";
"rlocmult"  ,  "toolbox/control/ctrlutil/";
"rlocus"  ,  "toolbox/control/control/";
"rlsests"  ,  "toolbox/simulink/simdemos/";
"rlspps"  ,  "toolbox/simulink/simdemos/";
"rltool"  ,  "toolbox/control/control/";
"rmdynprop"  ,  "toolbox/signal/sigtools/";
"rmnk"  ,  "toolbox/ident/idutils/";
"rmodel"  ,  "toolbox/robust/";
"rmodel"  ,  "toolbox/control/control/";
"rmprops"  ,  "toolbox/signal/sigtools/";
"robustdemo"  ,  "toolbox/stats/";
"robustfit"  ,  "toolbox/stats/";
"roe"  ,  "toolbox/ident/ident/";
"roicolor"  ,  "toolbox/images/images/";
"roidemo"  ,  "toolbox/images/imdemos/";
"roifill"  ,  "toolbox/images/images/";
"roifilt2"  ,  "toolbox/images/images/";
"roipoly"  ,  "toolbox/images/images/";
"roipolyold"  ,  "toolbox/images/images/";
"rootddg"  ,  "toolbox/simulink/simulink/";
"rooteig"  ,  "toolbox/signal/signal/";
"rootmusic"  ,  "toolbox/signal/signal/";
"rootobjectenum"  ,  "toolbox/simulink/simulink/";
"rotatefactors"  ,  "toolbox/stats/";
"roundfocus"  ,  "toolbox/ident/idutils/private/";
"rowexch"  ,  "toolbox/stats/";
"rpbrk"  ,  "toolbox/splines/";
"rpem"  ,  "toolbox/ident/ident/";
"rplr"  ,  "toolbox/ident/ident/";
"rpmak"  ,  "toolbox/splines/";
"rsbrk"  ,  "toolbox/splines/";
"rschur"  ,  "toolbox/robust/";
"rsigma"  ,  "toolbox/robust/";
"rsmak"  ,  "toolbox/splines/";
"rsmdemo"  ,  "toolbox/stats/";
"rss"  ,  "toolbox/control/control/";
"rstool"  ,  "toolbox/stats/";
"rsums"  ,  "toolbox/symbolic/";
"rsval"  ,  "toolbox/splines/";
"rtmdlsortflds"  ,  "toolbox/rtw/rtw/";
"rtslider"  ,  "toolbox/control/ctrldemos/private/";
"rtw_c"  ,  "toolbox/rtw/rtw/";
"rtw_cgt_name_conv"  ,  "toolbox/rtw/rtw/";
"rtw_checkdir"  ,  "toolbox/rtw/rtw/";
"rtw_copy_file"  ,  "toolbox/rtw/rtw/";
"rtw_delete_file"  ,  "toolbox/rtw/rtw/";
"rtw_expand_template"  ,  "toolbox/rtw/rtw/";
"rtw_expand_template_from_tlc"  ,  "toolbox/rtw/rtw/";
"rtw_fileparts"  ,  "toolbox/rtw/rtw/";
"rtw_gen_shared_utils"  ,  "toolbox/rtw/rtw/";
"rtw_host_implementation_props"  ,  "toolbox/rtw/rtw/";
"rtw_implementation_props"  ,  "toolbox/rtw/rtw/";
"rtw_is_hardware_state_unknown"  ,  "toolbox/rtw/rtw/";
"rtw_mlscript_tlcgen"  ,  "toolbox/rtw/rtw/";
"rtw_optimization_info"  ,  "toolbox/stateflow/stateflow/private/";
"rtw_prodhw_get"  ,  "toolbox/rtw/rtw/";
"rtw_prodhw_sizes"  ,  "toolbox/rtw/rtw/";
"rtw_rsim_mdlref_compatibility"  ,  "toolbox/rtw/rtw/";
"rtw_shared_utils_enabled"  ,  "toolbox/stateflow/stateflow/private/";
"rtw_target_fcn_lib_mgr"  ,  "toolbox/simulink/simulink/";
"rtw_target_methods"  ,  "toolbox/stateflow/stateflow/private/";
"rtw_target_props"  ,  "toolbox/stateflow/coder/private/";
"rtwbuild"  ,  "toolbox/rtw/rtw/";
"rtwconfiguremodel"  ,  "toolbox/rtw/rtw/";
"rtwdwork_inspect"  ,  "toolbox/simulink/simdemos/";
"rtwenvironmentmode"  ,  "toolbox/simulink/simulink/";
"rtwgen"  ,  "toolbox/rtw/rtw/";
"rtwgettargetfcnlib"  ,  "toolbox/simulink/simulink/";
"rtwhostwordlengths"  ,  "toolbox/rtw/rtw/";
"rtwmaputil"  ,  "toolbox/rtw/rtw/";
"rtwmath_base_fcn_name_list"  ,  "toolbox/simulink/simulink/";
"rtwmath_data_type_prop_list"  ,  "toolbox/simulink/simulink/";
"rtwprivate"  ,  "toolbox/rtw/rtw/";
"rtwrebuild"  ,  "toolbox/rtw/rtw/";
"rtwsampleconfig"  ,  "toolbox/rtw/rtw/";
"rtwwordlengths"  ,  "toolbox/rtw/rtw/";
"ruldown"  ,  "toolbox/signal/sptoolgui/private/";
"ruler"  ,  "toolbox/signal/sptoolgui/private/";
"rulermo"  ,  "toolbox/signal/sptoolgui/private/";
"rules"  ,  "toolbox/simulink/components/private/";
"runabs"  ,  "toolbox/simulink/simdemos/automotive/";
"runfleq1"  ,  "toolbox/optim/";
"runnls3"  ,  "toolbox/optim/";
"runqpbox4"  ,  "toolbox/optim/";
"runqpbox4prec"  ,  "toolbox/optim/";
"runqpeq5"  ,  "toolbox/optim/";
"runtracklsq"  ,  "toolbox/optim/";
"runtrackmm"  ,  "toolbox/optim/";
"safely_execute_dos_command"  ,  "toolbox/stateflow/stateflow/private/";
"same"  ,  "toolbox/robust/";
"sample"  ,  "toolbox/ident/idobsolete/";
"sample"  ,  "toolbox/ident/idutils/";
"samplesizedemo"  ,  "toolbox/stats/";
"sanim"  ,  "toolbox/simulink/simdemos/aerospace/";
"sanim3dof"  ,  "toolbox/simulink/simdemos/aerospace/";
"sanity_check_chart_simulink_block"  ,  "toolbox/stateflow/stateflow/private/";
"saveAndSetPrm"  ,  "toolbox/simulink/simulink/private/";
"save_system"  ,  "toolbox/simulink/simulink/";
"sawtooth"  ,  "toolbox/signal/signal/";
"sbarray"  ,  "toolbox/signal/sptoolgui/private/";
"sbclose"  ,  "toolbox/signal/sptoolgui/private/";
"sbcmplx"  ,  "toolbox/signal/sptoolgui/private/";
"sbhelpstr"  ,  "toolbox/signal/sptoolgui/private/";
"sbinit"  ,  "toolbox/signal/sptoolgui/private/";
"sbmotion"  ,  "toolbox/signal/sptoolgui/private/";
"sbresize"  ,  "toolbox/signal/sptoolgui/private/";
"sbswitch"  ,  "toolbox/signal/sptoolgui/";
"sbtitle"  ,  "toolbox/signal/sptoolgui/private/";
"sbzoom"  ,  "toolbox/signal/sptoolgui/private/";
"scalevaluefixup"  ,  "toolbox/signal/sigtools/";
"scalewinfo"  ,  "toolbox/signal/sigdemos/private/";
"scalewinzo"  ,  "toolbox/signal/sigdemos/private/";
"scalingfactor"  ,  "toolbox/signal/sigdemos/private/";
"scatterb"  ,  "toolbox/pde/";
"scatterg"  ,  "toolbox/pde/";
"scdtmpini"  ,  "toolbox/slcontrol/slctrldemos/";
"scdtmpinit"  ,  "toolbox/slcontrol/slctrldemos/";
"schart"  ,  "toolbox/stats/";
"schbal"  ,  "toolbox/robust/";
"schmr"  ,  "toolbox/robust/";
"schord"  ,  "toolbox/control/ctrlobsolete/";
"schurrc"  ,  "toolbox/signal/signal/";
"scopebar"  ,  "toolbox/simulink/simulink/";
"scopebarsv"  ,  "toolbox/simulink/simulink/";
"scopezoom"  ,  "toolbox/simulink/simulink/";
"scpprop"  ,  "toolbox/simulink/simulink/";
"scppropsv"  ,  "toolbox/simulink/simulink/";
"searchq"  ,  "toolbox/optim/";
"sec2tss"  ,  "toolbox/robust/";
"sectf"  ,  "toolbox/robust/";
"sectf88"  ,  "toolbox/robust/";
"segment"  ,  "toolbox/ident/ident/";
"selstruc"  ,  "toolbox/ident/ident/";
"semicon"  ,  "toolbox/optim/";
"seqperiod"  ,  "toolbox/signal/signal/";
"series"  ,  "toolbox/control/control/";
"sershbl"  ,  "toolbox/robust/";
"setActiveConfigSet"  ,  "toolbox/simulink/simulink/";
"setHardwareDevice"  ,  "toolbox/simulink/simulink/private/";
"set_eml_script"  ,  "toolbox/simulink/simulink/";
"set_mask_display"  ,  "toolbox/stateflow/stateflow/private/";
"set_param"  ,  "toolbox/simulink/simulink/";
"set_signal_name_for_out_port"  ,  "toolbox/stateflow/stateflow/private/";
"set_target_code_flags"  ,  "toolbox/stateflow/stateflow/private/";
"setcoincidentgrid"  ,  "toolbox/signal/sigtools/";
"setdatamarkers"  ,  "toolbox/signal/sigtools/";
"setenableprop"  ,  "toolbox/signal/sigtools/";
"setjavaxtreenode"  ,  "toolbox/simulink/blocks/private/";
"setjavaxtreenode"  ,  "toolbox/simulink/simulink/private/";
"setlinio"  ,  "toolbox/slcontrol/slcontrol/";
"setpname"  ,  "toolbox/ident/idutils/";
"setrul"  ,  "toolbox/signal/sptoolgui/private/";
"setrulxdata"  ,  "toolbox/signal/sptoolgui/private/";
"setsigpref"  ,  "toolbox/signal/sptoolgui/";
"setslopeline"  ,  "toolbox/signal/sptoolgui/private/";
"setstructfields"  ,  "toolbox/signal/sigtools/";
"setsysloc"  ,  "toolbox/simulink/simulink/";
"sett"  ,  "toolbox/ident/idobsolete/";
"setup_for_borland"  ,  "toolbox/rtw/rtw/";
"setup_for_intel"  ,  "toolbox/rtw/rtw/";
"setup_for_lcc"  ,  "toolbox/rtw/rtw/";
"setup_for_visual"  ,  "toolbox/rtw/rtw/";
"setup_for_watcom"  ,  "toolbox/rtw/rtw/";
"setxu"  ,  "toolbox/slcontrol/slcontrol/";
"setzoomstate"  ,  "toolbox/signal/sigtools/";
"sf_add_custom_menu"  ,  "toolbox/stateflow/stateflow/private/";
"sf_aerodyn"  ,  "toolbox/control/ctrldemos/";
"sf_bridge_state"  ,  "toolbox/stateflow/sfdemos/";
"sf_comment"  ,  "toolbox/stateflow/coder/private/";
"sf_copyobj"  ,  "toolbox/stateflow/stateflow/private/";
"sf_cruise_button_mgr"  ,  "toolbox/stateflow/sfdemos/";
"sf_cruise_control_ui"  ,  "toolbox/stateflow/sfdemos/";
"sf_date_num"  ,  "toolbox/stateflow/stateflow/private/";
"sf_date_str"  ,  "toolbox/stateflow/stateflow/private/";
"sf_deal_cards"  ,  "toolbox/stateflow/sfdemos/";
"sf_debug_exec"  ,  "toolbox/stateflow/stateflow/private/";
"sf_debug_exit_trap"  ,  "toolbox/stateflow/stateflow/private/";
"sf_debugger_trap"  ,  "toolbox/stateflow/stateflow/private/";
"sf_delete_file"  ,  "toolbox/stateflow/stateflow/private/";
"sf_demo_disclaimer"  ,  "toolbox/stateflow/stateflow/private/";
"sf_display"  ,  "toolbox/stateflow/stateflow/private/";
"sf_dos"  ,  "toolbox/stateflow/stateflow/private/";
"sf_echo_generating"  ,  "toolbox/stateflow/coder/private/";
"sf_edit_icon"  ,  "toolbox/stateflow/sfdemos/";
"sf_elevator_gui"  ,  "toolbox/stateflow/sfdemos/";
"sf_evalin_base"  ,  "toolbox/stateflow/coder/private/";
"sf_figure"  ,  "toolbox/stateflow/stateflow/private/";
"sf_force_open_machine"  ,  "toolbox/stateflow/stateflow/private/";
"sf_get_component_root"  ,  "toolbox/stateflow/stateflow/private/";
"sf_get_icon_data"  ,  "toolbox/stateflow/stateflow/private/";
"sf_get_reference_block_name"  ,  "toolbox/stateflow/stateflow/private/";
"sf_get_schema"  ,  "toolbox/stateflow/stateflow/private/";
"sf_hg_get"  ,  "toolbox/stateflow/stateflow/private/";
"sf_hg_set"  ,  "toolbox/stateflow/stateflow/private/";
"sf_hier_print"  ,  "toolbox/stateflow/stateflow/private/";
"sf_inhibit_code"  ,  "toolbox/stateflow/sfdemos/";
"sf_inject_event"  ,  "toolbox/stateflow/sfdemos/";
"sf_keyboard"  ,  "toolbox/stateflow/stateflow/private/";
"sf_load_model"  ,  "toolbox/stateflow/stateflow/private/";
"sf_mandel_gui"  ,  "toolbox/stateflow/sfdemos/";
"sf_mark_block_as_tainted"  ,  "toolbox/stateflow/stateflow/private/";
"sf_menu_mode"  ,  "toolbox/stateflow/stateflow/private/";
"sf_mk_dir"  ,  "toolbox/stateflow/stateflow/private/";
"sf_profile"  ,  "toolbox/stateflow/stateflow/private/";
"sf_root"  ,  "toolbox/stateflow/stateflow/private/";
"sf_rtw"  ,  "toolbox/stateflow/stateflow/private/";
"sf_rtw"  ,  "toolbox/rtw/rtw/";
"sf_scalar2str"  ,  "toolbox/stateflow/stateflow/private/";
"sf_simtime_throttle"  ,  "toolbox/stateflow/sfdemos/";
"sf_snr_inject_event"  ,  "toolbox/stateflow/stateflow/private/";
"sf_srch"  ,  "toolbox/stateflow/stateflow/private/";
"sf_stickslipedit"  ,  "toolbox/stateflow/sfdemos/";
"sf_tetris_gui"  ,  "toolbox/stateflow/sfdemos/";
"sf_tictacflow_mex"  ,  "toolbox/stateflow/sfdemos/";
"sf_tictacflow_simgui"  ,  "toolbox/stateflow/sfdemos/";
"sf_tictacflowgui"  ,  "toolbox/stateflow/sfdemos/";
"sf_tmp_undo_marker"  ,  "toolbox/stateflow/stateflow/private/";
"sf_type_enum_from_name"  ,  "toolbox/stateflow/coder/private/";
"sf_uicontextmenu"  ,  "toolbox/stateflow/stateflow/private/";
"sf_uicontrol"  ,  "toolbox/stateflow/stateflow/private/";
"sf_use_silent_build"  ,  "toolbox/stateflow/stateflow/private/";
"sfabout"  ,  "toolbox/stateflow/stateflow/private/";
"sfbcheckports"  ,  "toolbox/simulink/simulink/private/";
"sfbcheckstates"  ,  "toolbox/simulink/simulink/private/";
"sfbdroot"  ,  "toolbox/stateflow/stateflow/private/";
"sfblk"  ,  "toolbox/stateflow/stateflow/private/";
"sfbuilder_mexbuild"  ,  "toolbox/simulink/simulink/private/";
"sfc"  ,  "toolbox/stateflow/coder/";
"sfcall"  ,  "toolbox/stateflow/stateflow/private/";
"sfclipboard"  ,  "toolbox/stateflow/stateflow/";
"sfclose"  ,  "toolbox/stateflow/stateflow/";
"sfcndemo_hg_gui_m"  ,  "toolbox/simulink/simdemos/";
"sfcndemo_rtwcmd"  ,  "toolbox/simulink/simdemos/";
"sfcustom"  ,  "toolbox/stateflow/stateflow/private/";
"sfd"  ,  "toolbox/optim/";
"sfdbfig"  ,  "toolbox/stateflow/stateflow/private/";
"sfdebug"  ,  "toolbox/stateflow/stateflow/private/";
"sfdebug_get_linenum"  ,  "toolbox/stateflow/stateflow/private/";
"sfdebug_paused"  ,  "toolbox/stateflow/stateflow/private/";
"sfdebug_using_java"  ,  "toolbox/stateflow/stateflow/private/";
"sfdebugger"  ,  "toolbox/stateflow/stateflow/";
"sfdlg"  ,  "toolbox/stateflow/stateflow/private/";
"sfdnls"  ,  "toolbox/optim/";
"sfexit"  ,  "toolbox/stateflow/stateflow/";
"sfexplr"  ,  "toolbox/stateflow/stateflow/";
"sffind"  ,  "toolbox/stateflow/stateflow/";
"sfhelp"  ,  "toolbox/stateflow/stateflow/";
"sfinit"  ,  "toolbox/stateflow/stateflow/private/";
"sfix"  ,  "toolbox/simulink/fixedandfloat/";
"sfl"  ,  "toolbox/robust/";
"sflibrary"  ,  "toolbox/stateflow/stateflow/private/";
"sfminbx"  ,  "toolbox/optim/";
"sfminle"  ,  "toolbox/optim/";
"sfnew"  ,  "toolbox/stateflow/stateflow/";
"sfopen"  ,  "toolbox/stateflow/stateflow/";
"sfpcode"  ,  "toolbox/stateflow/stateflow/private/";
"sfpref"  ,  "toolbox/stateflow/stateflow/";
"sfprint"  ,  "toolbox/stateflow/stateflow/";
"sfprivate"  ,  "toolbox/stateflow/stateflow/";
"sfr"  ,  "toolbox/robust/";
"sfrac"  ,  "toolbox/simulink/fixedandfloat/";
"sfreplace"  ,  "toolbox/stateflow/stateflow/";
"sfroot"  ,  "toolbox/stateflow/stateflow/";
"sfrtw_compliant"  ,  "toolbox/rtw/rtw/";
"sfsave"  ,  "toolbox/stateflow/stateflow/";
"sfsim"  ,  "toolbox/stateflow/stateflow/private/";
"sfslbridge"  ,  "toolbox/stateflow/stateflow/";
"sfslfind"  ,  "toolbox/stateflow/stateflow/private/";
"sfsnr"  ,  "toolbox/stateflow/stateflow/private/";
"sfsrch"  ,  "toolbox/stateflow/stateflow/private/";
"sfstyler"  ,  "toolbox/stateflow/stateflow/private/";
"sftab2chk"  ,  "toolbox/simulink/blocks/";
"sftiffprintall"  ,  "toolbox/stateflow/stateflow/private/";
"sfun_bitopcbk"  ,  "toolbox/simulink/blocks/";
"sfun_target_methods"  ,  "toolbox/stateflow/stateflow/private/";
"sfun_varargm"  ,  "toolbox/simulink/blocks/";
"sfunbuilderports"  ,  "toolbox/simulink/simulink/private/";
"sfuncont"  ,  "toolbox/simulink/blocks/";
"sfuncorr"  ,  "toolbox/simulink/blocks/";
"sfunctionwizard"  ,  "toolbox/simulink/simulink/";
"sfunddg"  ,  "toolbox/simulink/blocks/";
"sfunddg_cb"  ,  "toolbox/simulink/blocks/";
"sfunddg_fs"  ,  "toolbox/simulink/blocks/private/";
"sfundemo_helper"  ,  "toolbox/simulink/simdemos/";
"sfundemo_maskdisp"  ,  "toolbox/simulink/simdemos/";
"sfundemo_open"  ,  "toolbox/simulink/simdemos/";
"sfundemo_openfcn"  ,  "toolbox/simulink/simdemos/";
"sfundsc1"  ,  "toolbox/simulink/blocks/";
"sfundsc2"  ,  "toolbox/simulink/blocks/";
"sfunid"  ,  "toolbox/ident/iddemos/";
"sfunlin"  ,  "toolbox/simulink/blocks/";
"sfunmem"  ,  "toolbox/simulink/blocks/";
"sfunpsd"  ,  "toolbox/simulink/blocks/";
"sfuntf"  ,  "toolbox/simulink/blocks/";
"sfuntmpl"  ,  "toolbox/simulink/blocks/";
"sfunxy"  ,  "toolbox/simulink/blocks/";
"sfunxys"  ,  "toolbox/simulink/blocks/";
"sfuny"  ,  "toolbox/simulink/blocks/";
"sfunyst"  ,  "toolbox/simulink/blocks/";
"sfversion"  ,  "toolbox/stateflow/stateflow/";
"sgolay"  ,  "toolbox/signal/signal/";
"sgolaydemo"  ,  "toolbox/signal/sigdemos/";
"sgolayfilt"  ,  "toolbox/signal/signal/";
"sgrid"  ,  "toolbox/control/control/";
"shiftdata"  ,  "toolbox/signal/signal/";
"shiftsc"  ,  "toolbox/optim/private/";
"showblockdatatypetable"  ,  "toolbox/simulink/simdemos/";
"showrootcs"  ,  "toolbox/simulink/simulink/";
"shuffle"  ,  "toolbox/stateflow/stateflow/private/";
"sido2n"  ,  "toolbox/ident/idguis/";
"sigSpecDataTypeParamCallBackFcn"  ,  "toolbox/simulink/blocks/";
"sigandscopemgr"  ,  "toolbox/simulink/simulink/";
"sigbrowse"  ,  "toolbox/signal/sptoolgui/";
"sigbuilder"  ,  "toolbox/simulink/simulink/";
"sigbuilder_beveled_frame"  ,  "toolbox/simulink/simulink/private/";
"sigbuilder_block"  ,  "toolbox/simulink/simulink/";
"sigbuilder_makemenu"  ,  "toolbox/simulink/simulink/private/";
"sigbuilder_modal_edit_dialog"  ,  "toolbox/simulink/simulink/private/";
"sigbuilder_tabselector"  ,  "toolbox/simulink/simulink/";
"sigcombobox"  ,  "toolbox/signal/sigtools/";
"sigdemo1"  ,  "toolbox/signal/sigdemos/";
"sigdemo2"  ,  "toolbox/signal/sigdemos/";
"siggetappdata"  ,  "toolbox/signal/sigtools/";
"sigisappdata"  ,  "toolbox/signal/sigtools/";
"siglogdialog"  ,  "toolbox/simulink/simulink/";
"sigma"  ,  "toolbox/control/control/";
"sigmpoles"  ,  "toolbox/signal/sigtools/";
"signalbuilder"  ,  "toolbox/simulink/simulink/";
"signalpolyutils"  ,  "toolbox/signal/signal/";
"signalselector"  ,  "toolbox/simulink/simulink/";
"signrank"  ,  "toolbox/stats/";
"signtest"  ,  "toolbox/stats/";
"sigprivate"  ,  "toolbox/signal/signal/";
"sigpropddg"  ,  "toolbox/simulink/simulink/";
"sigrmappdata"  ,  "toolbox/signal/sigtools/";
"sigsetappdata"  ,  "toolbox/signal/sigtools/";
"sigspecmask"  ,  "toolbox/simulink/blocks/";
"silhouette"  ,  "toolbox/stats/";
"sim"  ,  "toolbox/simulink/simulink/";
"sim_open_sys"  ,  "toolbox/stateflow/stateflow/private/";
"simbrowse"  ,  "toolbox/simulink/simulink/";
"simcad"  ,  "toolbox/simulink/simdemos/";
"simclock"  ,  "toolbox/simulink/simulink/";
"simcnstr"  ,  "toolbox/simulink/simulink/";
"simcontdesigner"  ,  "toolbox/slcontrol/slctrlguis/";
"simget"  ,  "toolbox/simulink/simulink/";
"simintro"  ,  "toolbox/simulink/simdemos/";
"simlp"  ,  "toolbox/simulink/simulink/";
"simmenu"  ,  "toolbox/simulink/simulink/private/";
"simom"  ,  "toolbox/simulink/blocks/";
"simom2"  ,  "toolbox/simulink/blocks/";
"simplex"  ,  "toolbox/optim/private/";
"simplexphaseone"  ,  "toolbox/optim/private/";
"simplexphasetwo"  ,  "toolbox/optim/private/";
"simplexpiecewise"  ,  "toolbox/optim/private/";
"simplexpostsolve"  ,  "toolbox/optim/private/";
"simplexpresolve"  ,  "toolbox/optim/private/";
"simplot"  ,  "toolbox/simulink/simulink/";
"simprintdlg"  ,  "toolbox/simulink/simulink/";
"simprintlog"  ,  "toolbox/simulink/simulink/";
"simprm"  ,  "toolbox/simulink/simulink/";
"simprmDlgCloseCallback"  ,  "toolbox/simulink/simulink/private/";
"simprmfield2prmmap"  ,  "toolbox/simulink/simulink/";
"simprmtagmap"  ,  "toolbox/simulink/simulink/";
"simscope"  ,  "toolbox/simulink/simulink/";
"simscopesv"  ,  "toolbox/simulink/simulink/";
"simset"  ,  "toolbox/simulink/simulink/";
"simsizes"  ,  "toolbox/simulink/simulink/";
"simulink"  ,  "toolbox/simulink/blocks/";
"simulinkrc"  ,  "toolbox/local/";
"simver"  ,  "toolbox/simulink/simulink/";
"sinc"  ,  "toolbox/signal/signal/";
"sinint"  ,  "toolbox/symbolic/";
"sint"  ,  "toolbox/simulink/fixedandfloat/";
"sisotool"  ,  "toolbox/control/control/";
"sizedat"  ,  "toolbox/ident/idutils/";
"skewness"  ,  "toolbox/stats/";
"skipdata"  ,  "toolbox/robust/";
"sl"  ,  "toolbox/simulink/simulink/";
"slCfgPrmDlg"  ,  "toolbox/simulink/simulink/";
"slCharacterEncoding"  ,  "toolbox/simulink/simulink/";
"slDDGUtil"  ,  "toolbox/simulink/simulink/";
"slDialogUtil"  ,  "toolbox/simulink/simulink/";
"slResolve"  ,  "toolbox/simulink/simulink/";
"sl_convert_to_model_reference"  ,  "toolbox/simulink/simulink/";
"sl_disp_info"  ,  "toolbox/simulink/simulink/private/";
"sl_file_is_newer"  ,  "toolbox/simulink/simulink/private/";
"sl_get_dialog_schema"  ,  "toolbox/simulink/simulink/";
"sl_get_file_date"  ,  "toolbox/simulink/simulink/private/";
"sl_open"  ,  "toolbox/stateflow/stateflow/private/";
"sl_snr_inject_event"  ,  "toolbox/shared/dastudio/";
"sl_type_enum_from_name"  ,  "toolbox/stateflow/coder/private/";
"sl_unified_lookup2d_dialog"  ,  "toolbox/simulink/blocks/";
"slblkpropdlg"  ,  "toolbox/simulink/simulink/";
"slblks"  ,  "toolbox/simulink/blocks/";
"slblocks"  ,  "toolbox/slcontrol/slctrlutil/";
"slblocks"  ,  "toolbox/control/control/";
"slblocks"  ,  "toolbox/rtw/rtw/";
"slblocks"  ,  "toolbox/sloptim/sloptim/";
"slblocks"  ,  "toolbox/stateflow/stateflow/";
"slblocks"  ,  "toolbox/ident/ident/";
"slblocks"  ,  "toolbox/simulink/blocks/";
"slbuild"  ,  "toolbox/simulink/simulink/";
"slchangelog"  ,  "toolbox/simulink/simulink/";
"slcheckprelookups"  ,  "toolbox/simulink/simdemos/simfeatures/";
"slcm"  ,  "toolbox/simulink/simulink/";
"slctrlexplorer"  ,  "toolbox/shared/slcontrollib/";
"sldatastoredlg"  ,  "toolbox/simulink/blocks/";
"sldebug"  ,  "toolbox/simulink/simulink/";
"sldebugui"  ,  "toolbox/simulink/simulink/";
"sldemo_bpcheck_script"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldemo_create_tc_blocks_data"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldemo_create_tc_tabledata"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldemo_luteditor_script"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldemo_prelookup_script"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldemo_sweeptable_thd"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldemo_tableplot_comet"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldemo_wavethd_script"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sldiagnostics"  ,  "toolbox/simulink/simulink/";
"sldiscmdl"  ,  "toolbox/simulink/components/";
"sldiscutil"  ,  "toolbox/simulink/components/";
"sldrop"  ,  "toolbox/simulink/simulink/private/";
"sldsmemdlg"  ,  "toolbox/simulink/blocks/";
"slexist"  ,  "toolbox/simulink/simulink/";
"slexplr"  ,  "toolbox/simulink/simulink/";
"slfind"  ,  "toolbox/simulink/simulink/";
"slfromdlg"  ,  "toolbox/simulink/blocks/";
"slgetcompilerinfo"  ,  "toolbox/simulink/simulink/private/";
"slgotodlg"  ,  "toolbox/simulink/blocks/";
"slhelp"  ,  "toolbox/simulink/simulink/";
"slideg"  ,  "toolbox/simulink/simulink/";
"slidentinit"  ,  "toolbox/ident/ident/";
"slidentinit"  ,  "toolbox/ident/idutils/";
"slight"  ,  "toolbox/simulink/simdemos/simgeneral/";
"slinstallprefs"  ,  "toolbox/simulink/simulink/";
"sllastdiagnostic"  ,  "toolbox/simulink/simulink/";
"sllasterror"  ,  "toolbox/simulink/simulink/";
"sllastwarning"  ,  "toolbox/simulink/simulink/";
"slloadpmmenuitems"  ,  "toolbox/simulink/simulink/";
"sllsbox"  ,  "toolbox/optim/private/";
"slmaskprmdispcntrl"  ,  "toolbox/simulink/simulink/";
"slmdldisc"  ,  "toolbox/simulink/components/";
"slmdldiscui"  ,  "toolbox/simulink/components/";
"slmodelprop"  ,  "toolbox/simulink/simulink/";
"slmodelpropj"  ,  "toolbox/simulink/simulink/";
"slowfast"  ,  "toolbox/robust/";
"slpmloadfunction"  ,  "toolbox/simulink/simulink/private/";
"slprivate"  ,  "toolbox/simulink/simulink/";
"slproductinstalled"  ,  "toolbox/simulink/simulink/";
"slprofile_hilite_system"  ,  "toolbox/simulink/simulink/";
"slprofile_unhilite_system"  ,  "toolbox/simulink/simulink/";
"slprofreport"  ,  "toolbox/simulink/simulink/";
"slprophelp"  ,  "toolbox/simulink/simulink/";
"slreplace"  ,  "toolbox/shared/dastudio/";
"slresolveporthandle"  ,  "toolbox/simulink/simulink/";
"slroot"  ,  "toolbox/simulink/simulink/";
"slsaveas"  ,  "toolbox/simulink/simulink/";
"slsaveassup"  ,  "toolbox/simulink/simulink/";
"slsf"  ,  "toolbox/stateflow/stateflow/private/";
"slsfnagctlr"  ,  "toolbox/simulink/simulink/";
"slsigpropdlg"  ,  "toolbox/simulink/simulink/";
"slsnr"  ,  "toolbox/shared/dastudio/";
"sltbldesigner"  ,  "toolbox/simulink/blocks/";
"sltbledit"  ,  "toolbox/simulink/blocks/";
"sltipalert"  ,  "toolbox/simulink/simulink/";
"sltranslate"  ,  "toolbox/simulink/simulink/";
"sltrdemo"  ,  "toolbox/robust/";
"sluigeom"  ,  "toolbox/simulink/simulink/";
"sluiutil"  ,  "toolbox/simulink/simulink/";
"slupdate"  ,  "toolbox/simulink/simulink/";
"slvblk"  ,  "toolbox/splines/";
"slview"  ,  "toolbox/control/control/";
"slwsprmattrib"  ,  "toolbox/simulink/simulink/";
"smreal"  ,  "toolbox/control/ctrlutil/";
"snls"  ,  "toolbox/optim/private/";
"solve"  ,  "toolbox/symbolic/";
"sort_exported_fcns_info"  ,  "toolbox/stateflow/stateflow/private/";
"sorted"  ,  "toolbox/splines/";
"sos2cell"  ,  "toolbox/signal/signal/";
"sos2ss"  ,  "toolbox/signal/signal/";
"sos2tf"  ,  "toolbox/signal/signal/";
"sos2zp"  ,  "toolbox/signal/signal/";
"sosdemo"  ,  "toolbox/signal/sigdemos/";
"sosfilt"  ,  "toolbox/signal/signal/";
"sp2bb"  ,  "toolbox/splines/";
"sp2pp"  ,  "toolbox/splines/";
"spa"  ,  "toolbox/ident/ident/";
"spafdr"  ,  "toolbox/ident/ident/";
"spalldem"  ,  "toolbox/splines/";
"spap2"  ,  "toolbox/splines/";
"spapi"  ,  "toolbox/splines/";
"spapidem"  ,  "toolbox/splines/";
"spaps"  ,  "toolbox/splines/";
"spbrk"  ,  "toolbox/splines/";
"spchart"  ,  "toolbox/control/ctrlguis/";
"spcol"  ,  "toolbox/splines/";
"spcrv"  ,  "toolbox/splines/";
"spcrvdem"  ,  "toolbox/splines/";
"spdialog"  ,  "toolbox/simulink/simulink/";
"specgram"  ,  "toolbox/signal/signal/";
"specgramdemo"  ,  "toolbox/signal/sigdemos/";
"specplot"  ,  "toolbox/signal/signal/";
"spectralanalysisobjsdemo"  ,  "toolbox/signal/sigdemos/";
"spectrum"  ,  "toolbox/signal/signal/";
"spectview"  ,  "toolbox/signal/sptoolgui/";
"speditline"  ,  "toolbox/signal/sptoolgui/private/";
"sphelpstr"  ,  "toolbox/signal/sptoolgui/private/";
"spinit"  ,  "toolbox/signal/sptoolgui/private/";
"spldems"  ,  "toolbox/splines/";
"splexmpl"  ,  "toolbox/splines/";
"splinetool"  ,  "toolbox/splines/";
"splitText"  ,  "toolbox/simulink/simulink/private/";
"splpp"  ,  "toolbox/splines/";
"spmak"  ,  "toolbox/splines/";
"spmethp"  ,  "toolbox/signal/sptoolgui/private/";
"spmotion"  ,  "toolbox/signal/sptoolgui/private/";
"spresize"  ,  "toolbox/signal/sptoolgui/private/";
"sprfn"  ,  "toolbox/splines/";
"spriorityfcn"  ,  "toolbox/simulink/simdemos/simfeatures/";
"sprpp"  ,  "toolbox/splines/";
"sptarn"  ,  "toolbox/pde/";
"sptcompp"  ,  "toolbox/signal/sptoolgui/private/";
"spterms"  ,  "toolbox/splines/";
"sptexport"  ,  "toolbox/signal/sptoolgui/private/";
"sptfileheader"  ,  "toolbox/signal/sigtools/";
"spthelp"  ,  "toolbox/signal/sptoolgui/private/";
"spthelpstr"  ,  "toolbox/signal/sptoolgui/private/";
"sptimport"  ,  "toolbox/signal/sptoolgui/private/";
"sptlegend"  ,  "toolbox/signal/sptoolgui/private/";
"sptlinetip"  ,  "toolbox/signal/sigtools/";
"sptool"  ,  "toolbox/signal/sptoolgui/";
"sptool_helpmenu"  ,  "toolbox/signal/sptoolgui/private/";
"sptprefp"  ,  "toolbox/signal/sptoolgui/private/";
"sptprefs"  ,  "toolbox/signal/sptoolgui/private/";
"sptrmcharsfromcell"  ,  "toolbox/signal/sigtools/";
"sptsizes"  ,  "toolbox/signal/sptoolgui/private/";
"spval"  ,  "toolbox/splines/";
"spzoom"  ,  "toolbox/signal/sptoolgui/private/";
"sqpbox"  ,  "toolbox/optim/private/";
"sqpmin"  ,  "toolbox/optim/private/";
"sqrmtx"  ,  "toolbox/robust/";
"square"  ,  "toolbox/signal/signal/";
"squareb1"  ,  "toolbox/pde/";
"squareb2"  ,  "toolbox/pde/";
"squareb3"  ,  "toolbox/pde/";
"squareb4"  ,  "toolbox/pde/";
"squareb5"  ,  "toolbox/pde/";
"squareform"  ,  "toolbox/stats/";
"squareg"  ,  "toolbox/pde/";
"sroproject"  ,  "toolbox/sloptim/sloptim/";
"srotut1_dat"  ,  "toolbox/sloptim/sloptdemos/";
"ss2sos"  ,  "toolbox/signal/signal/";
"ss2ss"  ,  "toolbox/control/control/";
"ss2th"  ,  "toolbox/ident/idobsolete/";
"ssdelete"  ,  "toolbox/control/ctrlobsolete/";
"ssfreqresp"  ,  "toolbox/ident/idutils/";
"ssfrupd"  ,  "toolbox/ident/idutils/private/";
"ssinthd"  ,  "toolbox/simulink/simdemos/simfeatures/";
"ssinv"  ,  "toolbox/robust/";
"ssmodxx"  ,  "toolbox/ident/idutils/";
"ssops"  ,  "toolbox/control/ctrlutil/";
"ssselect"  ,  "toolbox/control/ctrlobsolete/";
"ssssaux"  ,  "toolbox/ident/idutils/";
"ssv"  ,  "toolbox/robust/";
"stabproj"  ,  "toolbox/robust/";
"start_simulation"  ,  "toolbox/stateflow/stateflow/private/";
"startupdlg"  ,  "toolbox/control/ctrlguis/";
"startupsav"  ,  "toolbox/local/";
"startx"  ,  "toolbox/shared/optimlib/";
"statchol"  ,  "toolbox/stats/private/";
"statctexact"  ,  "toolbox/stats/private/";
"statdisptable"  ,  "toolbox/stats/";
"state2html"  ,  "toolbox/stateflow/stateflow/private/";
"state_print_fig"  ,  "toolbox/stateflow/stateflow/private/";
"stateddg"  ,  "toolbox/stateflow/stateflow/private/";
"statedlg"  ,  "toolbox/stateflow/stateflow/private/";
"stateflow"  ,  "toolbox/stateflow/stateflow/";
"statepropdialog"  ,  "toolbox/simulink/simulink/";
"statget"  ,  "toolbox/stats/";
"statgetargs"  ,  "toolbox/stats/private/";
"statgetargsuser"  ,  "toolbox/stats/private/";
"statgetcolor"  ,  "toolbox/stats/private/";
"statglmeval"  ,  "toolbox/stats/private/";
"staticres"  ,  "toolbox/signal/sigtools/";
"staticrespengine"  ,  "toolbox/signal/sigtools/";
"statinsertnan"  ,  "toolbox/stats/private/";
"statremovenan"  ,  "toolbox/stats/private/";
"statrobustfit"  ,  "toolbox/stats/private/";
"statset"  ,  "toolbox/stats/";
"statsfminbx"  ,  "toolbox/stats/private/";
"statsizechk"  ,  "toolbox/stats/private/";
"statsrexact"  ,  "toolbox/stats/private/";
"stattestlink"  ,  "toolbox/stats/private/";
"stbrk"  ,  "toolbox/splines/";
"stcol"  ,  "toolbox/splines/";
"std2"  ,  "toolbox/images/images/";
"stdrcdf"  ,  "toolbox/stats/private/";
"stdrinv"  ,  "toolbox/stats/private/";
"stealparameter"  ,  "toolbox/simulink/fixedandfloat/";
"step"  ,  "toolbox/control/control/";
"stepfun"  ,  "toolbox/control/ctrlobsolete/";
"stepwise"  ,  "toolbox/stats/";
"stepwisefit"  ,  "toolbox/stats/";
"stepz"  ,  "toolbox/signal/signal/";
"stf2target"  ,  "toolbox/rtw/rtw/";
"stf2tc"  ,  "toolbox/shared/dastudio/";
"stf4target"  ,  "toolbox/rtw/rtw/";
"stfInitTarget"  ,  "toolbox/rtw/rtw/";
"stfTargetDlgCallback"  ,  "toolbox/simulink/simulink/private/";
"stftarget_fillstring"  ,  "toolbox/rtw/rtw/";
"stmak"  ,  "toolbox/splines/";
"stmcb"  ,  "toolbox/signal/signal/";
"stop_simulation"  ,  "toolbox/stateflow/stateflow/private/";
"stowe_away_tlc_logs_for_testing"  ,  "toolbox/rtw/rtw/";
"stradd"  ,  "toolbox/stateflow/stateflow/private/";
"strcat_with_separator"  ,  "toolbox/simulink/simulink/private/";
"strelcheck"  ,  "toolbox/images/images/private/";
"stretchlim"  ,  "toolbox/images/images/";
"strip_path_from_name"  ,  "toolbox/stateflow/stateflow/private/";
"strip_trailing_new_lines"  ,  "toolbox/stateflow/coder/private/";
"strips"  ,  "toolbox/signal/signal/";
"strlen"  ,  "toolbox/stateflow/stateflow/private/";
"strlines"  ,  "toolbox/stateflow/stateflow/private/";
"strlong"  ,  "toolbox/stateflow/stateflow/private/";
"strrows"  ,  "toolbox/stateflow/stateflow/private/";
"struc"  ,  "toolbox/ident/ident/";
"struct2array"  ,  "toolbox/signal/sigtools/";
"structelementddg"  ,  "toolbox/simulink/simulink/";
"structtypeddg"  ,  "toolbox/simulink/simulink/";
"strwrite"  ,  "toolbox/stateflow/stateflow/private/";
"stval"  ,  "toolbox/splines/";
"subaxes"  ,  "toolbox/control/ctrlobsolete/";
"subimage"  ,  "toolbox/images/images/";
"subplus"  ,  "toolbox/splines/";
"subs"  ,  "toolbox/symbolic/";
"subsystem_configuration"  ,  "toolbox/simulink/simulink/";
"subsystem_configuration_blkinit"  ,  "toolbox/simulink/simulink/";
"subsystem_to_model_reference"  ,  "toolbox/simulink/simulink/private/";
"sum4vms"  ,  "toolbox/ident/idutils/";
"sumblock"  ,  "toolbox/control/ctrldemos/private/";
"sumboard"  ,  "toolbox/ident/idguis/";
"super_checker"  ,  "toolbox/stateflow/stateflow/private/";
"surfht"  ,  "toolbox/stats/";
"survivaldemo"  ,  "toolbox/stats/";
"suspdat"  ,  "toolbox/simulink/simdemos/automotive/";
"suspgrph"  ,  "toolbox/simulink/simdemos/automotive/";
"svburg"  ,  "toolbox/signal/sptoolgui/private/";
"svcov"  ,  "toolbox/signal/sptoolgui/private/";
"svextrap"  ,  "toolbox/signal/sptoolgui/private/";
"svfft"  ,  "toolbox/signal/sptoolgui/private/";
"sviewer"  ,  "toolbox/simulink/simulink/";
"svmcov"  ,  "toolbox/signal/sptoolgui/private/";
"svmtm"  ,  "toolbox/signal/sptoolgui/private/";
"svmusic"  ,  "toolbox/signal/sptoolgui/private/";
"svwelch"  ,  "toolbox/signal/sptoolgui/private/";
"svyulear"  ,  "toolbox/signal/sptoolgui/private/";
"symbol_wiz"  ,  "toolbox/stateflow/stateflow/private/";
"symcalcdemo"  ,  "toolbox/symbolic/";
"symdemos"  ,  "toolbox/symbolic/";
"symeqndemo"  ,  "toolbox/symbolic/";
"symintro"  ,  "toolbox/symbolic/";
"symlindemo"  ,  "toolbox/symbolic/";
"symrotdemo"  ,  "toolbox/symbolic/";
"syms"  ,  "toolbox/symbolic/";
"symvpademo"  ,  "toolbox/symbolic/";
"syncDlgStopTimes"  ,  "toolbox/simulink/simulink/";
"sync_target"  ,  "toolbox/stateflow/stateflow/private/";
"sys2ss"  ,  "toolbox/robust/";
"sysardec"  ,  "toolbox/ident/idutils/";
"sysblock"  ,  "toolbox/control/ctrldemos/private/";
"sysdemo"  ,  "toolbox/robust/";
"sysirdec"  ,  "toolbox/ident/idutils/";
"sysmatrix"  ,  "toolbox/signal/sigtools/";
"tabulate"  ,  "toolbox/stats/";
"tagdialog"  ,  "toolbox/simulink/simulink/";
"target_code_flags"  ,  "toolbox/stateflow/stateflow/private/";
"target_methods"  ,  "toolbox/stateflow/stateflow/private/";
"target_name_change"  ,  "toolbox/stateflow/stateflow/private/";
"target_opts_ddg"  ,  "toolbox/stateflow/stateflow/private/";
"targetddg"  ,  "toolbox/stateflow/stateflow/private/";
"targetddg_btn_coder_cb"  ,  "toolbox/stateflow/stateflow/private/";
"targetddg_btn_target_cb"  ,  "toolbox/stateflow/stateflow/private/";
"targetddg_preapply_callback"  ,  "toolbox/stateflow/stateflow/private/";
"targetddg_preclose_callback"  ,  "toolbox/stateflow/stateflow/private/";
"targetdevicetypechanged"  ,  "toolbox/simulink/simulink/";
"targetdlg"  ,  "toolbox/stateflow/stateflow/private/";
"targetman"  ,  "toolbox/stateflow/stateflow/private/";
"taylortool"  ,  "toolbox/symbolic/";
"tbfillblanks"  ,  "toolbox/signal/sptoolgui/private/";
"tblpresrc"  ,  "toolbox/simulink/simulink/private/";
"tblread"  ,  "toolbox/stats/";
"tblwrite"  ,  "toolbox/stats/";
"tbroyfg"  ,  "toolbox/optim/";
"tcdf"  ,  "toolbox/stats/";
"tchop"  ,  "toolbox/control/ctrlutil/";
"tdfread"  ,  "toolbox/stats/";
"tdfthru"  ,  "toolbox/control/ctrlutil/";
"ted_the_editors"  ,  "toolbox/stateflow/stateflow/private/";
"termcross"  ,  "toolbox/stats/private/";
"test_points_in"  ,  "toolbox/stateflow/stateflow/private/";
"testing_stateflow_in_bat"  ,  "toolbox/stateflow/stateflow/private/";
"tf2latc"  ,  "toolbox/signal/signal/";
"tf2sos"  ,  "toolbox/signal/signal/";
"tf2zpk"  ,  "toolbox/signal/signal/";
"tfe"  ,  "toolbox/signal/signal/";
"tfestimate"  ,  "toolbox/signal/signal/";
"tffunc"  ,  "toolbox/signal/sigdemos/";
"tfm2ss"  ,  "toolbox/robust/";
"tform"  ,  "toolbox/images/images/private/";
"tformarray"  ,  "toolbox/images/images/";
"tformfwd"  ,  "toolbox/images/images/";
"tforminv"  ,  "toolbox/images/images/";
"th2arx"  ,  "toolbox/ident/idobsolete/";
"th2ff"  ,  "toolbox/ident/idobsolete/";
"th2ido"  ,  "toolbox/ident/idobsolete/";
"th2par"  ,  "toolbox/ident/idobsolete/";
"th2poly"  ,  "toolbox/ident/idobsolete/";
"th2ss"  ,  "toolbox/ident/idobsolete/";
"th2tf"  ,  "toolbox/ident/idobsolete/";
"th2zp"  ,  "toolbox/ident/idobsolete/";
"thc2thd"  ,  "toolbox/ident/idobsolete/";
"thd2thc"  ,  "toolbox/ident/idobsolete/";
"thermdat"  ,  "toolbox/simulink/simdemos/simgeneral/";
"thinit"  ,  "toolbox/ident/idobsolete/";
"this_is_an_sflink"  ,  "toolbox/stateflow/stateflow/private/";
"thss2th"  ,  "toolbox/ident/idobsolete/";
"tiedrank"  ,  "toolbox/stats/";
"timestwo"  ,  "toolbox/simulink/blocks/";
"timezparse"  ,  "toolbox/signal/signal/";
"timezplot"  ,  "toolbox/signal/signal/private/";
"timscale"  ,  "toolbox/ident/idutils/private/";
"timvec"  ,  "toolbox/control/ctrlobsolete/";
"tinv"  ,  "toolbox/stats/";
"titanium"  ,  "toolbox/splines/";
"title4ax"  ,  "toolbox/signal/sigtools/";
"tlc"  ,  "toolbox/rtw/rtw/";
"tlc2m"  ,  "toolbox/rtw/rtw/";
"tlc_c"  ,  "toolbox/rtw/rtw/";
"tlcsetup"  ,  "toolbox/rtw/rtw/";
"toast"  ,  "toolbox/simulink/dee/";
"toiletgui"  ,  "toolbox/simulink/simdemos/simgeneral/";
"toiletsfun"  ,  "toolbox/simulink/simdemos/simgeneral/";
"tokenize"  ,  "toolbox/stateflow/stateflow/private/";
"tokenize"  ,  "toolbox/images/images/private/";
"too_many_editors"  ,  "toolbox/stateflow/stateflow/private/";
"toolbox_path_cache"  ,  "toolbox/local/";
"topicshow"  ,  "toolbox/control/ctrldemos/private/";
"tornado_callback_handler"  ,  "toolbox/rtw/rtw/";
"tpaps"  ,  "toolbox/splines/";
"tpdf"  ,  "toolbox/stats/";
"transddg"  ,  "toolbox/stateflow/stateflow/private/";
"transdlg"  ,  "toolbox/stateflow/stateflow/private/";
"transf"  ,  "toolbox/ident/idutils/";
"translate_io_size_mismatch_error"  ,  "toolbox/stateflow/stateflow/private/";
"trdg"  ,  "toolbox/optim/private/";
"trdog"  ,  "toolbox/optim/private/";
"tree"  ,  "toolbox/robust/";
"treedisp"  ,  "toolbox/stats/";
"treefit"  ,  "toolbox/stats/";
"treeprune"  ,  "toolbox/stats/";
"treetest"  ,  "toolbox/stats/";
"treeval"  ,  "toolbox/stats/";
"treeview"  ,  "toolbox/simulink/simulink/";
"trf"  ,  "toolbox/ident/idobsolete/";
"tri2grid"  ,  "toolbox/pde/";
"triang"  ,  "toolbox/signal/signal/";
"tridieig"  ,  "toolbox/signal/signal/private/";
"tridisolve"  ,  "toolbox/signal/signal/private/";
"trim"  ,  "toolbox/simulink/simulink/";
"trimfcn"  ,  "toolbox/simulink/simulink/";
"trimmean"  ,  "toolbox/stats/";
"tripuls"  ,  "toolbox/signal/signal/";
"trnd"  ,  "toolbox/stats/";
"truesize"  ,  "toolbox/images/images/";
"trust"  ,  "toolbox/optim/private/";
"trustnleqn"  ,  "toolbox/optim/private/";
"truth_table_handle_man"  ,  "toolbox/stateflow/stateflow/private/";
"truth_table_man"  ,  "toolbox/stateflow/stateflow/private/";
"truth_tables_in"  ,  "toolbox/stateflow/stateflow/private/";
"try_indenting_file"  ,  "toolbox/stateflow/coder/private/";
"tsAlignSizes"  ,  "toolbox/shared/timeseries/";
"tsChkTime"  ,  "toolbox/shared/timeseries/";
"tsIsDateFormat"  ,  "toolbox/shared/timeseries/";
"tsParseInputs"  ,  "toolbox/shared/timeseries/";
"tsarrayFcn"  ,  "toolbox/shared/timeseries/";
"tsdateinterval"  ,  "toolbox/shared/timeseries/";
"tsinterp"  ,  "toolbox/shared/timeseries/";
"tspdem"  ,  "toolbox/splines/";
"tss"  ,  "toolbox/robust/private/";
"tssdata"  ,  "toolbox/robust/private/";
"tssorttime"  ,  "toolbox/shared/timeseries/";
"tstat"  ,  "toolbox/stats/";
"tsunitconv"  ,  "toolbox/shared/timeseries/";
"tt_check_specification"  ,  "toolbox/stateflow/stateflow/private/";
"ttest"  ,  "toolbox/stats/";
"ttest2"  ,  "toolbox/stats/";
"tukeywin"  ,  "toolbox/signal/signal/";
"tunable_param_dlg"  ,  "toolbox/simulink/simulink/";
"tunablevars2parameterobjects"  ,  "toolbox/simulink/simulink/";
"tutdemo"  ,  "toolbox/optim/";
"type2pp"  ,  "toolbox/ident/idutils/";
"tzero2"  ,  "toolbox/control/ctrlobsolete/";
"udd_property_help"  ,  "toolbox/stateflow/stateflow/private/";
"uddpvparse"  ,  "toolbox/signal/sigtools/";
"udecode"  ,  "toolbox/signal/signal/";
"uencode"  ,  "toolbox/signal/signal/";
"ufix"  ,  "toolbox/simulink/fixedandfloat/";
"ufrac"  ,  "toolbox/simulink/fixedandfloat/";
"uget_param"  ,  "toolbox/simulink/simulink/";
"uint"  ,  "toolbox/simulink/fixedandfloat/";
"uintlut"  ,  "toolbox/images/images/";
"unencrypted_charts_in"  ,  "toolbox/stateflow/stateflow/private/";
"unfixpar"  ,  "toolbox/ident/idobsolete/";
"unidcdf"  ,  "toolbox/stats/";
"unidinv"  ,  "toolbox/stats/";
"unidpdf"  ,  "toolbox/stats/";
"unidrnd"  ,  "toolbox/stats/";
"unidstat"  ,  "toolbox/stats/";
"unifcdf"  ,  "toolbox/stats/";
"unifinv"  ,  "toolbox/stats/";
"unifit"  ,  "toolbox/stats/";
"unifpdf"  ,  "toolbox/stats/";
"unifrnd"  ,  "toolbox/stats/";
"unifstat"  ,  "toolbox/stats/";
"uniqlabel"  ,  "toolbox/signal/sptoolgui/private/";
"uniqname"  ,  "toolbox/control/ctrlguis/";
"unique_name_for_list"  ,  "toolbox/stateflow/stateflow/private/";
"unitconv"  ,  "toolbox/control/ctrlguis/";
"unpack_machine_id"  ,  "toolbox/stateflow/stateflow/private/";
"unshiftdata"  ,  "toolbox/signal/signal/";
"unshsca"  ,  "toolbox/optim/private/";
"unstkc"  ,  "toolbox/robust/";
"unstkr"  ,  "toolbox/robust/";
"update_assert_sys"  ,  "toolbox/simulink/blocks/";
"update_eml_data"  ,  "toolbox/stateflow/stateflow/private/";
"update_exported_fcn_info"  ,  "toolbox/stateflow/stateflow/private/";
"update_fvtool"  ,  "toolbox/signal/sptoolgui/private/";
"update_library_link_charts_for_rtw"  ,  "toolbox/stateflow/stateflow/private/";
"update_model_reference_targets"  ,  "toolbox/simulink/simulink/private/";
"update_params_on_instances"  ,  "toolbox/stateflow/stateflow/private/";
"update_rtb"  ,  "toolbox/simulink/blocks/";
"update_statusbar"  ,  "toolbox/signal/sigtools/";
"update_toolbox_cache"  ,  "toolbox/local/";
"update_truth_table_for_fcn"  ,  "toolbox/stateflow/stateflow/private/";
"update_truth_tables"  ,  "toolbox/stateflow/stateflow/private/";
"update_truthtable_data"  ,  "toolbox/stateflow/stateflow/private/";
"updatewarn"  ,  "toolbox/control/ctrlutil/";
"updownsample"  ,  "toolbox/signal/signal/private/";
"upfind"  ,  "toolbox/stateflow/stateflow/private/";
"upfirdn"  ,  "toolbox/signal/signal/";
"upsample"  ,  "toolbox/signal/signal/";
"upvpl2xyz"  ,  "toolbox/images/images/private/";
"userpath"  ,  "toolbox/local/";
"uset_param"  ,  "toolbox/simulink/simulink/";
"utAssignParams"  ,  "toolbox/sloptim/sloptguis/";
"utEvalModelVar"  ,  "toolbox/sloptim/sloptguis/";
"utEvalParams"  ,  "toolbox/sloptim/sloptguis/";
"utFindLog"  ,  "toolbox/sloptim/sloptim/";
"utFindParams"  ,  "toolbox/sloptim/sloptguis/";
"utFindProject"  ,  "toolbox/sloptim/sloptguis/";
"utGetLastError"  ,  "toolbox/sloptim/sloptguis/";
"utGetLogData"  ,  "toolbox/sloptim/sloptim/";
"utGetSimInterval"  ,  "toolbox/sloptim/sloptguis/";
"utLoadProject"  ,  "toolbox/sloptim/sloptguis/";
"utSROCopyFcn"  ,  "toolbox/sloptim/sloptguis/";
"utgetaxes"  ,  "toolbox/shared/timeseries/";
"uvl2xyz"  ,  "toolbox/images/images/private/";
"v2sort"  ,  "toolbox/shared/optimlib/";
"validarg"  ,  "toolbox/signal/sptoolgui/private/";
"valve"  ,  "toolbox/control/ctrldemos/private/";
"vco"  ,  "toolbox/signal/signal/";
"vdlmintm"  ,  "toolbox/simulink/blocks/";
"vdpdemo"  ,  "toolbox/simulink/simdemos/simgeneral/";
"vdpm"  ,  "toolbox/simulink/blocks/";
"version"  ,  "toolbox/local/";
"vhdlplugin"  ,  "toolbox/signal/sigtools/";
"view_mdlrefs"  ,  "toolbox/simulink/simulink/";
"viewimportfcn"  ,  "toolbox/control/ctrlguis/";
"viewlinkdata"  ,  "toolbox/simulink/simulink/";
"vlimintm"  ,  "toolbox/simulink/blocks/";
"vpa"  ,  "toolbox/symbolic/";
"vratio"  ,  "toolbox/signal/signal/";
"vrsys"  ,  "toolbox/robust/";
"vset"  ,  "toolbox/stateflow/stateflow/private/";
"vsfunc"  ,  "toolbox/simulink/blocks/";
"waitbar"  ,  "toolbox/stateflow/stateflow/private/";
"walk"  ,  "toolbox/stateflow/stateflow/private/";
"warp"  ,  "toolbox/images/images/";
"watchsigsdlg"  ,  "toolbox/simulink/simulink/";
"watershed"  ,  "toolbox/images/images/";
"watertankdat"  ,  "toolbox/slcontrol/slctrldemos/";
"waveformdemo"  ,  "toolbox/signal/sigdemos/";
"wblcdf"  ,  "toolbox/stats/";
"wblfit"  ,  "toolbox/stats/";
"wblinv"  ,  "toolbox/stats/";
"wbllike"  ,  "toolbox/stats/";
"wblpdf"  ,  "toolbox/stats/";
"wblplot"  ,  "toolbox/stats/";
"wblrnd"  ,  "toolbox/stats/";
"wblstat"  ,  "toolbox/stats/";
"wbound"  ,  "toolbox/pde/";
"weibcdf"  ,  "toolbox/stats/";
"weibfit"  ,  "toolbox/stats/";
"weibinv"  ,  "toolbox/stats/";
"weiblike"  ,  "toolbox/stats/";
"weibpdf"  ,  "toolbox/stats/";
"weibplot"  ,  "toolbox/stats/";
"weibrnd"  ,  "toolbox/stats/";
"weibstat"  ,  "toolbox/stats/";
"welch"  ,  "toolbox/signal/signal/private/";
"wgeom"  ,  "toolbox/pde/";
"wgtnormfit"  ,  "toolbox/stats/";
"wgtnormfit2"  ,  "toolbox/stats/";
"wheel"  ,  "toolbox/robust/";
"whitepoint"  ,  "toolbox/images/images/";
"wiener2"  ,  "toolbox/images/images/";
"window"  ,  "toolbox/signal/signal/";
"windowstrs2fcnnames"  ,  "toolbox/signal/sigtools/private/";
"windtrandemo"  ,  "toolbox/signal/sigdemos/";
"winintegrate"  ,  "toolbox/signal/sigdemos/private/";
"winorderfirst"  ,  "toolbox/signal/sigdemos/private/";
"wintool"  ,  "toolbox/signal/sigtools/";
"wintool_help"  ,  "toolbox/signal/sigtools/";
"wire"  ,  "toolbox/control/ctrldemos/private/";
"wishrnd"  ,  "toolbox/stats/";
"workspaceddg"  ,  "toolbox/simulink/simulink/";
"workspaceddg_cb"  ,  "toolbox/simulink/simulink/";
"ws2matq"  ,  "toolbox/pde/private/";
"wvtool"  ,  "toolbox/signal/sigtools/";
"x0est"  ,  "toolbox/ident/idutils/private/";
"x0est_f"  ,  "toolbox/ident/idutils/";
"x2fx"  ,  "toolbox/stats/";
"xbarplot"  ,  "toolbox/stats/";
"xcorr"  ,  "toolbox/signal/signal/";
"xcorr2"  ,  "toolbox/signal/signal/";
"xcov"  ,  "toolbox/signal/signal/";
"xlabel4ax"  ,  "toolbox/signal/sigtools/";
"xpbanplt"  ,  "toolbox/optim/";
"xplot"  ,  "toolbox/optim/private/";
"xtrack"  ,  "toolbox/optim/private/";
"xyl2xyz"  ,  "toolbox/images/images/private/";
"xyz2double"  ,  "toolbox/images/images/";
"xyz2lab"  ,  "toolbox/images/images/private/";
"xyz2uint16"  ,  "toolbox/images/images/";
"xyz2upvpl"  ,  "toolbox/images/images/private/";
"xyz2uvl"  ,  "toolbox/images/images/private/";
"xyz2xyl"  ,  "toolbox/images/images/private/";
"ycbcr2rgb"  ,  "toolbox/images/images/";
"ydataspan"  ,  "toolbox/control/ctrlguis/";
"ylabel4ax"  ,  "toolbox/signal/sigtools/";
"ylwk"  ,  "toolbox/robust/";
"youla"  ,  "toolbox/robust/";
"yulewalk"  ,  "toolbox/signal/signal/";
"zerophase"  ,  "toolbox/signal/signal/";
"zeta"  ,  "toolbox/symbolic/";
"zfcheck"  ,  "toolbox/ident/idutils/";
"zgrid"  ,  "toolbox/control/control/";
"zoom_cbs"  ,  "toolbox/signal/sigtools/private/";
"zp"  ,  "toolbox/ident/idobsolete/";
"zp2sos"  ,  "toolbox/signal/signal/";
"zpchart"  ,  "toolbox/control/ctrlguis/";
"zpform"  ,  "toolbox/ident/idobsolete/";
"zplane"  ,  "toolbox/signal/signal/";
"zplaneplot"  ,  "toolbox/signal/signal/";
"zpplot"  ,  "toolbox/ident/idobsolete/";
"zscore"  ,  "toolbox/stats/";
"ztest"  ,  "toolbox/stats/"]
k=find(namefun==tb(:,1))
if k<>[] then
mtlbpath=tb(k,2)
ismtlb=%t
end
endfunction